
// EncodeDoc.h : CEncodeDoc NX̐錾уC^[tFCX̒`܂B
// EncodeDoc.h : interface of the CEncodeDoc class
// Copyright (C) 2000 Canopus Co., Ltd. All rights reserved.

/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENCODEDOC_H__0A808E64_D845_11D3_B44A_00A0C9B32266__INCLUDED_)
#define AFX_ENCODEDOC_H__0A808E64_D845_11D3_B44A_00A0C9B32266__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMpegSender; // for forward reference

class CEncodeDoc : public CDocument
{
protected:	// VACY@\݂̂쐬܂B
			// create from serialization only
	CEncodeDoc();
	DECLARE_DYNCREATE(CEncodeDoc)

// Agr[g
// Attributes
public:
	enum EncState {
		encNone, encConnected, encDisconnected, encStarted, encStopped
	};
	EncState m_fState;

// Iy[V
// Operations
public:
	static void CALLBACK EncStatusCallback(UINT nEncId, ENC_STATUS_NOTIFY fStatus);
	static void CALLBACK EncErrorCallback(UINT nEncId, ULONG ulError);

//I[o[Ch
// Overrides
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEncodeDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	//}}AFX_VIRTUAL

// Cve[V
// Implementation
public:
	virtual ~CEncodeDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CMpegSender* m_pSender;
	WORD m_nPort;
	CString m_szAddress;
	CString m_szAddressSendTo;
	DWORD m_cbBssBuff; // BSS buffer size in bytes
	DWORD m_cBssBuff; // default BSS buffer count

// ꂽbZ[W }bv֐
// Generated message map functions
protected:
	//{{AFX_MSG(CEncodeDoc)
	afx_msg void OnConnect();
	afx_msg void OnUpdateConnect(CCmdUI* pCmdUI);
	afx_msg void OnDisconnect();
	afx_msg void OnUpdateDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnSendStart();
	afx_msg void OnUpdateSendStart(CCmdUI* pCmdUI);
	afx_msg void OnSendEnd();
	afx_msg void OnUpdateSendEnd(CCmdUI* pCmdUI);
	afx_msg void OnConnectOption();
	afx_msg void OnUpdateConnectOption(CCmdUI* pCmdUI);
	afx_msg void OnSendOption();
	afx_msg void OnUpdateSendOption(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENCODEDOC_H__0A808E64_D845_11D3_B44A_00A0C9B32266__INCLUDED_)

