//======================================================================
// -- MainFrm.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//@MPEG2vOXg[M    TvvO      
//  MPEG2 program stream sender sample program          
//                                                                      
// Copyright (C) 2000-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// MainFrm.cpp : CMainFrame NX̓̒`s܂B
// MainFrm.cpp : implementation of the CMainFrame class

#include "stdafx.h"
#include "Encode_cEx.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_MOVE()
	ON_WM_SIZE()
	ON_WM_SYSCOMMAND()
	ON_MESSAGE(MSG_ENC_STATUS, OnEncStatus)
	ON_MESSAGE(MSG_ENC_ERROR, OnEncError)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	// TODO: add member initialization code here

}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh
// CMainFrame message handlers

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// adjust window size so that COverlayView have desired client size
	CRect rcClient, rcWin;
	GetClientRect(&rcClient); ClientToScreen(&rcClient);
	GetWindowRect(&rcWin);
	int cx = VIDEO_WIDTH + (rcWin.Width() - rcClient.Width()) + GetSystemMetrics(SM_CXBORDER) * 4;
	int cy = NTSC_VIDEO_HEIGHT + (rcWin.Height() - rcClient.Height()) + GetSystemMetrics(SM_CYBORDER) * 4;
	SetWindowPos(NULL, 0, 0, cx, cy, SWP_NOMOVE | SWP_NOZORDER); // no other way
	return 0;
}

void CMainFrame::OnMove(int x, int y)
{
	CFrameWnd::OnMove(x, y);
	CView* pView = GetActiveView();
	if (pView) {
		CRect rc;
		pView->GetClientRect(&rc);
		pView->PostMessage(WM_MOVE, 0, MAKELONG(rc.left, rc.top));
	}
}

void CMainFrame::OnSize(UINT nType, int cx, int cy)
{
	CFrameWnd::OnSize(nType, cx, cy);
	CView* pView = GetActiveView();
	if (pView)
		pView->SetWindowPos(NULL, 0, 0, cx, cy, SWP_NOMOVE | SWP_NOZORDER);
}

void CMainFrame::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID != SC_SCREENSAVE) // prevent activation of screen saver
		CWnd::OnSysCommand(nID, lParam);
}

LRESULT CMainFrame::OnEncStatus(WPARAM wParam, LPARAM lParam)
{
	ASSERT((UINT)wParam == GetEncId());
	switch ((ENC_STATUS_NOTIFY)lParam) {
	case ENC_NOTIFY_STOP:
	{
		UINT cFrame;
		double Time;
		if (ENC_Get_Frame_Count(GetEncId(), &cFrame) != ENC_SUCCESS ||
			ENC_Get_Time(GetEncId(), &Time) != ENC_SUCCESS)
			EncErrorMessageBox();
		TCHAR szFrame[MAX_PATH], szTime[MAX_PATH];
		_stprintf(szFrame, _T("%d"), cFrame);
		_stprintf(szTime, _T("%.3f"), Time);
		CString strMessage;
		AfxFormatString2(strMessage, IDS_ENC_STOPPED, szFrame, szTime);
		AfxMessageBox(strMessage);
		break;
	}
	default:
		break;
	}
	return 0;
}

LRESULT CMainFrame::OnEncError(WPARAM wParam, LPARAM lParam)
{
	ASSERT((UINT)wParam == GetEncId());
	EncErrorMessageBox((LPDWORD)&lParam);
	return 0;
}

