//======================================================================
// -- OverlayView.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//@MPEG2vOXg[M    TvvO      
//  MPEG2 program stream sender sample program          
//                                                                      
// Copyright (C) 2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// OverlayView.cpp : COverlayView NX̓̒`s܂B
// OverlayView.cpp : implementation of the COverlayView class

#include "stdafx.h"
#include "Encode_cEx.h"

#include "EncodeDoc.h"
#include "OverlayView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COverlayView

IMPLEMENT_DYNCREATE(COverlayView, CView)

BEGIN_MESSAGE_MAP(COverlayView, CView)
	//{{AFX_MSG_MAP(COverlayView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_MOVE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̍\z/
// COverlayView construction/destruction

COverlayView::COverlayView()
	: m_hWndOverlay(NULL)
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	// TODO: add construction code here

}

COverlayView::~COverlayView()
{
}

BOOL COverlayView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̕`
// COverlayView drawing

void COverlayView::OnDraw(CDC* pDC)
{
	CEncodeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̐ff
// COverlayView diagnostics

#ifdef _DEBUG
void COverlayView::AssertValid() const
{
	CView::AssertValid();
}

void COverlayView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CEncodeDoc* COverlayView::GetDocument()		// fobO o[W̓CCłB
											// non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEncodeDoc)));
	return (CEncodeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̃bZ[W nh
// COverlayView message handlers

int COverlayView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	CRect rc;
    GetClientRect(&rc);
	if (ENC_Can_Overlay_Window(GetEncId(), NULL, rc.Width(), rc.Height()) == ENC_SUCCESS)
		ENC_Create_Overlay_Window(GetEncId(), m_hWnd, &m_hWndOverlay, 0, 0, rc.Width(), rc.Height());
	VERIFY(ENC_Start_Monitor(GetEncId()) == ENC_SUCCESS);
	return 0;
}

void COverlayView::OnDestroy()
{
	CView::OnDestroy();
	VERIFY(ENC_Stop_Monitor(GetEncId()) == ENC_SUCCESS);
	if (m_hWndOverlay) {
		VERIFY(ENC_Destroy_Overlay_Window(GetEncId()) == ENC_SUCCESS);
		m_hWndOverlay = NULL;
	}
}

void COverlayView::OnMove(int x, int y)
{
	CView::OnMove(x, y);
	if (m_hWndOverlay) {
		CPoint pt(x, y);
		ClientToScreen(&pt);
		VERIFY(ENC_Move_Overlay_Window(GetEncId(), pt.x, pt.y) == ENC_SUCCESS);
	}
}

void COverlayView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	if (m_hWndOverlay)
		VERIFY(ENC_Resize_Overlay_Window(GetEncId(), cx, cy) == ENC_SUCCESS);
}

