//======================================================================
// -- MainFrm.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//                                  fR[h    TvvO      
//                                  Decode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// MainFrm.cpp : CMainFrame NX̓̒`s܂B
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Decode.h"

#include "MainFrm.h"
#include "Adjust.h"
#include "AudioDlg.h"
#include "DecodeParam.h"
#include "SeekDlg.h"
#include "OverlayRectDlg.h"

#include "StillCapParam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_WM_CREATE()
    ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
    ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
    ON_COMMAND(IDM_DECODE_PLAY, OnDecodePlay)
    ON_UPDATE_COMMAND_UI(IDM_DECODE_PLAY, OnUpdateDecodePlay)
    ON_WM_CLOSE()
    ON_COMMAND(IDM_DECODE_STOP, OnDecodeStop)
    ON_UPDATE_COMMAND_UI(IDM_DECODE_STOP, OnUpdateDecodeStop)
    ON_COMMAND(IDM_DECODE_PAUSE, OnDecodePause)
    ON_UPDATE_COMMAND_UI(IDM_DECODE_PAUSE, OnUpdateDecodePause)
    ON_COMMAND(IDM_DECODE_REPEAT, OnDecodeRepeat)
    ON_UPDATE_COMMAND_UI(IDM_DECODE_REPEAT, OnUpdateDecodeRepeat)
    ON_WM_MOVE()
    ON_WM_SIZE()
    ON_COMMAND(IDM_SET_AUDIO, OnSetAudio)
    ON_COMMAND(IDM_SET_MONITOR, OnSetMonitor)
    ON_UPDATE_COMMAND_UI(IDM_SET_MONITOR, OnUpdateSetMonitor)
    ON_COMMAND(IDM_SIZE_SOURCE, OnSizeSource)
    ON_UPDATE_COMMAND_UI(IDM_SIZE_SOURCE, OnUpdateSizeSource)
    ON_UPDATE_COMMAND_UI(IDM_SET_SHOW_OVERLAY, OnUpdateSetShowOverlay)
    ON_COMMAND(IDM_SET_NTSC, OnSetNtsc)
    ON_COMMAND(IDM_SET_PAL, OnSetPal)
    ON_UPDATE_COMMAND_UI(IDM_SET_NTSC, OnUpdateSetNtsc)
    ON_UPDATE_COMMAND_UI(IDM_SET_PAL, OnUpdateSetPal)
    ON_COMMAND(IDM_SET_DECODE_PARAM, OnSetDecodeParam)
    ON_COMMAND(IDM_SET_ADJUST, OnSetAdjust)
    ON_COMMAND(IDM_SET_GET_LAST_ERROR, OnSetGetLastError)
    ON_COMMAND(IDM_DECODE_SEEK, OnDecodeSeek)
    ON_UPDATE_COMMAND_UI(IDM_DECODE_SEEK, OnUpdateDecodeSeek)
    ON_COMMAND(IDM_DECODE_PLAY_FROM, OnDecodePlayFrom)
    ON_UPDATE_COMMAND_UI(IDM_DECODE_PLAY_FROM, OnUpdateDecodePlayFrom)
    ON_UPDATE_COMMAND_UI(ID_APP_EXIT, OnUpdateAppExit)
    ON_COMMAND(IDM_SET_OVERLAY_RECT, OnSetOverlayRect)
    ON_UPDATE_COMMAND_UI(IDM_SET_OVERLAY_RECT, OnUpdateSetOverlayRect)
	ON_COMMAND(IDM_GET_STILL_IMAGE, OnGetStillImage)
	ON_COMMAND(IDM_SET_SHOW_OVERLAY, OnSetShowOverlay)
	ON_COMMAND(IDM_SET_VIDEOPORT_OVERLAY, OnSetVideoportOverlay)
	ON_UPDATE_COMMAND_UI(IDM_SET_VIDEOPORT_OVERLAY, OnUpdateSetVideoportOverlay)
	ON_COMMAND(IDM_SET_STILLCAPTURE_PARAM, OnSetStillcaptureParam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static  HINSTANCE   m_hInstance;
/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_fVideoPort = FALSE;
	m_fSupportVideoPort = FALSE;
    m_fRepeat   = FALSE;
    hWndOverlay = NULL;
    nWidth  = 720;
    nHeight = 480;
	m_nBoardConf = 0;

	m_nJpegQuality = 1;
	m_nStillCapture = MVRSTILL_FRAME;
}

CMainFrame::~CMainFrame()
{
}


//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
// @\                                                       
//                                                                      
//  F      LPCREATESTRUCT lpCreateStruct;                          
//                                                                      
//  ߂lF    int     0;                                          
//                      -1;     s                                    
//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
//  Function:   Initialize                                              
//                                                                      
//      Parameters: LPCREATESTRUCT lpCreateStruct;                      
//                                                                      
//      Return value:   int     0;  success                             
//                              -1; fail                                
//----------------------------------------------------------------------
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    DEC_RETURN  dec_return;
    CString     strMessage;
	UINT		nNumber=0;
	DEC_CONFIG	config;
	UINT		ui;

    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

    m_hInstance = AfxGetInstanceHandle();
	for (int i = 1; i < __argc; i++) {
		LPCTSTR pszParam = __targv[i];
		if ((pszParam[0] == _T('-') || pszParam[0] == _T('/')) && !_tcsnicmp(pszParam + 1, _T("id:"), _tcslen(_T("id:"))))
			// id number is specified by /id:n
			nNumber = atoi(pszParam + 4);
	}

	if (nNumber == 0)
	{
		memset(&config, 0, sizeof(DEC_CONFIG));
		DEC_Get_Codec_Config(DEC_ID, &config);

		for (ui = 0 ;ui <= config.NumberCodecs; ui++)
		{
			config.CodecNumber=ui;
			DEC_Get_Codec_Config(DEC_ID, &config);
			if (config.CurrentUtilization == FALSE)
			{
				if (config.CodecCaps & DECCAP_DECODE)
				{
	                if ( config.CodecCaps & DECCAP_D2200)
		            {
						m_nBoardConf = DECCAP_D2200;
					}
					else if ( config.CodecCaps & DECCAP_D2200V) 
					{
						m_nBoardConf = DECCAP_D2200V;
					}
					else {
						m_nBoardConf = 0;
					}

					nNumber = ui;
					break;
				}
			}
		}
	}
	
	DEC_ID = nNumber;
	DEC_Set_Codec_Number(DEC_ID, nNumber);

	// Cȕ
    // Initialize library
    dec_return = DEC_Initialize(DEC_ID);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_INIT_LIBRARY);
        MessageBox(strMessage);
        return -1;
    }

	// R[obN̐ݒ
    // Set CallbackProc
    dec_return = DEC_Set_Callback(DEC_ID, StatusProc, ErrorProc);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_SET_CALLBACK);
        MessageBox(strMessage);
        return -1;
    }

	RECT rc;

	GetClientRect(&rc);
 	dec_return = DEC_Can_VideoPort_Overlay_Window(DEC_ID, NULL, rc.right, rc.bottom);
  
	if(dec_return == DEC_SUCCESS)
		m_fSupportVideoPort = TRUE;

    // I[o[CEBhE̍쐬
    // Create overlay window
    if(hWndOverlay == NULL)
		CreateOverlayWindow();

    return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
    //       CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
    return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh
// CMainFrame message handlers

//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
// @\     AvP[VI܂                                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
//  Function:   End application                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnClose() 
{
    DEC_STATUS  dec_status;
    DEC_RETURN  dec_return;
    CString     strMessage;
    
    dec_return = DEC_Get_Status(DEC_ID, &dec_status);

    if(dec_return == DEC_SUCCESS)
    {
        if(dec_status != DEC_STATUS_STOP)
            return;
    }

    if(hWndOverlay != NULL)
    {
        dec_return = DEC_Destroy_Overlay_Window(DEC_ID);
        if(dec_return != DEC_SUCCESS)
        {
            strMessage.LoadString(IDS_ERROR_DESTROY_OVERLAY);
            MessageBox(strMessage);
        }
    }

    dec_return = DEC_Terminate(DEC_ID);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_TERMINATE_DECODE);
        MessageBox(strMessage);
    }

    CFrameWnd::OnClose();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnFileOpen ]                                          
//                                                                      
// @\     t@CJ                                              
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnFileOpen ]                                          
//                                                                      
//  Function:   Open a file                                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnFileOpen() 
{
    CFileDialog dlg(TRUE, NULL, NULL,
                    OFN_HIDEREADONLY |
                    OFN_FILEMUSTEXIST |
                    OFN_PATHMUSTEXIST,
                    NULL, this);
    DEC_VIDEO_PARAMETER dec_video_param;
    DEC_RETURN  dec_return;
    DEC_TYPE    dec_type;
    CString     strMessage;
    CString     strFile;
    CString     szType;
    char        szText[MAX_PATH];
    char        szFile[MAX_PATH];

    // t@C̎擾
    // Get file name
    dec_return = DEC_Get_Movie_File(DEC_ID, szFile);
    if(dec_return == DEC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    // t@CJ
    // Open file dialog
    if(dlg.DoModal() == IDOK)
    {
        strFile = dlg.GetPathName();
        lstrcpy(szFile, strFile);

        dec_return = DEC_Set_Movie_File(DEC_ID, szFile);
        if(dec_return != DEC_SUCCESS)
        {
            strMessage.LoadString(IDS_ERROR_OPEN_FILE);
            MessageBox(strMessage);
            return;
        }

        dec_return = DEC_Get_File_Type(DEC_ID, szFile, &dec_type);
        if(dec_return == DEC_SUCCESS)
        {
            switch(dec_type)
            {
            case DEC_TYPE_MPEG1_AUDIO:
                szType = "MPEG1 Audio";
                break;
            case DEC_TYPE_MPEG1_VIDEO:
                szType = "MPEG1 Video";
                break;
            case DEC_TYPE_MPEG1_SYSTEM_STREAM:
                szType = "MPEG1 System stream";
                break;
            case DEC_TYPE_MPEG2_AUDIO:
                szType = "MPEG2 Audio";
                break;
            case DEC_TYPE_MPEG2_VIDEO:
                szType = "MPEG2 Video";
                break;
            case DEC_TYPE_MPEG2_PROGRAM_STREAM:
                szType = "MPEG2 Program Stream";
                break;
            default:
                szType = "unknown";
                break;
            }
            wsprintf(szText, "[%s] : %s", szType, szFile);
        }
        else
        {
            wsprintf(szText, "%s", szFile);
        }

        SetWindowText( dlg.GetFileName());
    }

    // Kݒ肷
    // Set input standard
    dec_return = DEC_Get_Video_Parameter(DEC_ID, &dec_video_param);
    if(dec_return == DEC_SUCCESS)
    {
        if(dec_video_param.TV_System == DEC_VIDEO_TV_SYSTEM_NTSC)
            OnSetNtsc();
        else
            OnSetPal();
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateFileOpen ]                                    
//                                                                      
// @\     ~ȊO̓t@CJIłȂ悤ɂ          
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateFileOpen ]                                    
//                                                                      
//  Function:   User can't select file unless decoder is stopped.       
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
    DEC_STATUS  dec_status;
    
    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_STOP)
        pCmdUI->Enable(TRUE);
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePlay ]                                        
//                                                                      
// @\     fR[hJn܂                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePlay ]                                        
//                                                                      
//  Function:   Decode starts                                           
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodePlay() 
{
    DEC_RETURN  dec_return;
    DEC_STATUS  dec_status;
    CString     strMessage;

    // 摜TCY̎擾
    // Get image size
    dec_return = DEC_Get_Image_Size(DEC_ID, &nWidth, &nHeight);
    if(dec_return != DEC_SUCCESS)
    {
		DEC_Stop_Monitor(DEC_ID);
		/*
		strMessage.LoadString(IDS_ERROR_GET_SIZE);
		MessageBox(strMessage);
		return;
		*/
    }

    // fR[hJn
    // Start Decode
    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_PAUSE)
    {
        // ꎞ~
        // Resume
        DEC_Resume(DEC_ID);
    }
    else if(dec_status == DEC_STATUS_STOP)
    {
        // Đ
        // Play
        dec_return = DEC_Play(DEC_ID);
		if(dec_return != DEC_SUCCESS)
		{
			strMessage.LoadString(IDS_ERROR_CAN_PLAY);
			MessageBox(strMessage);
			return;
		}
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePlay ]                                  
//                                                                      
// @\     t@CIĂȂꍇ                            
//          GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePlay ]                                  
//                                                                      
//  Function:    User can't select item when a file is not selected,    
//              or when it is decoding.                                 
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return valueF  none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateDecodePlay(CCmdUI* pCmdUI) 
{
    DEC_RETURN  dec_return;
    DEC_STATUS  dec_status;
    DWORD       dwTime;

    // ~Ԃꎞ~ԂłȂΑIłȂ悤ɂ
    // If decoder is stopped or paused, user can select the item.
    dec_return = DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_return == DEC_SUCCESS)
        pCmdUI->Enable(TRUE);
    else
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    if(dec_status == DEC_STATUS_STOP || dec_status == DEC_STATUS_PAUSE)
        pCmdUI->Enable(TRUE);
    else
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    dec_return = DEC_Get_Playback_Time(DEC_ID, &dwTime);
    if(dec_return == DEC_SUCCESS && dwTime != 0)
        pCmdUI->Enable(TRUE);
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeStop ]                                        
//                                                                      
// @\     fR[h~܂                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeStop ]                                        
//                                                                      
//  Function:   Decode stops                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodeStop() 
{
    DEC_RETURN  dec_return;
    CString     strMessage;

    dec_return = DEC_Stop(DEC_ID);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_STOP_DECODE);
        MessageBox(strMessage);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodeStop ]                                  
//                                                                      
// @\     ĐAꎞ~̂ݑIł悤ɂ                    
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodeStop ]                                  
//                                                                      
//  Function:    User can select the item only during playback or pause.
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateDecodeStop(CCmdUI* pCmdUI) 
{
    DEC_STATUS  dec_status;

    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_PLAY || dec_status == DEC_STATUS_PAUSE)
        pCmdUI->Enable(TRUE);
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
// @\     I[o[CEBhE쐬                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE    EBhE쐬ɐ                    
//                      FALSE   EBhE쐬Ɏs                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
//  Function:   Create overlay window                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE;   success                         
//                              FALSE;  fail                            
//                                                                      
//----------------------------------------------------------------------
BOOL CMainFrame::CreateOverlayWindow()
{
    DEC_RETURN  dec_return;
    RECT        rc;
    CString     strMessage;

    GetClientRect(&rc);

	dec_return = DEC_Can_Overlay_Window(DEC_ID, NULL, rc.right, rc.bottom);
    if(dec_return != DEC_SUCCESS)
    {
		if ( m_nBoardConf != DECCAP_D2200V ) {
			strMessage.LoadString(IDS_ERROR_CAN_OVERLAY);
			MessageBox(strMessage);
			return FALSE;
		}
    }

    dec_return = DEC_Create_Overlay_Window( DEC_ID, m_hWnd, &hWndOverlay, 0, 0, rc.right, rc.bottom);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_CREATE_OVERLAY);
        MessageBox(strMessage);
        return FALSE;
    }

	DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);

    return TRUE;
}


//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePause ]                                       
//                                                                      
// @\     fR[hꎞ~܂                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePause ]                                       
//                                                                      
//  Function:   Pause decode                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodePause() 
{
    DEC_RETURN  dec_return;
    CString     strMessage;

    dec_return = DEC_Pause(DEC_ID);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_PAUSE_DECODE);
        MessageBox(strMessage);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePause ]                                 
//                                                                      
// @\     Đ̂ݑIł悤ɂ                              
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePause ]                                 
//                                                                      
//  Function:   If decoder is playing, user can select the item.        
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   nonr                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateDecodePause(CCmdUI* pCmdUI) 
{
    DEC_STATUS  dec_status;

    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_PLAY)
        pCmdUI->Enable(TRUE);
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeRepeat ]                                      
//                                                                      
// @\     s[g                                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeRepeat ]                                      
//                                                                      
//  Function:   Repeat                                                  
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodeRepeat() 
{
    DEC_RETURN  dec_return;
    
    dec_return = DEC_Get_Repeat(DEC_ID, &m_fRepeat);
    if(dec_return == DEC_SUCCESS)
    {
        m_fRepeat = !m_fRepeat;
        DEC_Set_Repeat(DEC_ID, m_fRepeat);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodeRepeat ]                                
//                                                                      
// @\     s[gɃ`FbN}[N                            
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodeRepeat ]                                
//                                                                      
//  Function:   Check the item                                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateDecodeRepeat(CCmdUI* pCmdUI) 
{
    pCmdUI->SetCheck(m_fRepeat);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
// @\     I[o[CEBhËʒüړ                          
//                                                                      
//  F      int     x                                               
//              int     y                                               
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
//  Function:   Move the overlay window.                                
//                                                                      
//      Parameters:     int     x                                       
//                      int     y                                       
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnMove(int x, int y) 
{
    CFrameWnd::OnMove(x, y);

    if(hWndOverlay)
        DEC_Move_Overlay_Window(DEC_ID, x, y);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
// @\     I[o[CEBhẼTCYύX                          
//                                                                      
//  F      UINT    nType                                           
//              int     cx                                              
//              int     cy                                              
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
//  Function:   Resize the overlay window.                              
//                                                                      
//      Parameters:     UINT    nType                                   
//                      int     cx                                      
//                      int     cy                                      
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);

    if(hWndOverlay)
        DEC_Resize_Overlay_Window(DEC_ID, cx, cy);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudio ]                                          
//                                                                      
// @\     I[fBI̐ݒ                                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudio ]                                          
//                                                                      
//  Function:   Set audio parameter                                     
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudio() 
{
    CAudioDlg   dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetMonitor ]                                        
//                                                                      
// @\     j^[̐ݒ                                              
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetMonitor ]                                        
//                                                                      
//  Function:   Set monitor                                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetMonitor() 
{
    DEC_RETURN  dec_return;
    RECT        rc;
    UINT        nMonitor;
    CString     strMessage;

    dec_return = DEC_Get_Monitor_Status(DEC_ID, &nMonitor);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_GET_MONITOR);
        MessageBox(strMessage);
        return;
    }

    nMonitor = !nMonitor;

    if(nMonitor)
    {
        DEC_Start_Monitor(DEC_ID);
        GetClientRect(&rc);
        DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);
    }
    else
        DEC_Stop_Monitor(DEC_ID);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetMonitor ]                                  
//                                                                      
// @\     j^[Ƀ`FbN}[N                            
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetMonitor ]                                  
//                                                                      
//  Function:   Check the item                                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetMonitor(CCmdUI* pCmdUI) 
{
    DEC_RETURN  dec_return;
    DEC_STATUS  dec_status;
    UINT        nMonitor;
    CString     strMessage;

    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status != DEC_STATUS_STOP)
        pCmdUI->Enable(FALSE);
    else
        pCmdUI->Enable(TRUE);

    dec_return = DEC_Get_Monitor_Status(DEC_ID, &nMonitor);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_GET_MONITOR);
        MessageBox(strMessage);
        return;
    }

    pCmdUI->SetCheck(nMonitor);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSizeSource ]                                        
//                                                                      
// @\     NCAg̈\[XTCYɂ                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSizeSource ]                                        
//                                                                      
//  Function:   Fit the client area to source size.                     
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSizeSource() 
{
    DEC_RETURN  dec_return;
    CString     strMessage;
    RECT    rc_client;
    RECT    rc_window;
    int     x, y;

    dec_return = DEC_Get_Image_Size(DEC_ID, &nWidth, &nHeight);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_GET_SIZE);
        MessageBox(strMessage);
        return;
    }

    GetWindowRect(&rc_window);
    GetClientRect(&rc_client);
    x = (rc_window.right - rc_window.left) - rc_client.right;
    y = (rc_window.bottom - rc_window.top) - rc_client.bottom;
    SetWindowPos(this, 0, 0, nWidth + x, nHeight + y, SWP_NOMOVE | SWP_NOZORDER);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSizeSource ]                                  
//                                                                      
// @\     t@CI΂ĂȂꍇ                              
//          Audiot@CIĂꍇ͑IłȂ悤ɂ   
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSizeSource ]                                  
//                                                                      
//  Function:    If user doesn't select any files or selects            
//              audio files, user can't select the item.                
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSizeSource(CCmdUI* pCmdUI) 
{
    DEC_TYPE    dec_type;
    DEC_RETURN  dec_return;
    char        szFile[MAX_PATH];

    // t@CIĂȂꍇ͑IłȂ悤ɂ
    // User can't select the item if user doesn't select any files.
    dec_return = DEC_Get_Movie_File(DEC_ID, szFile);
    if(dec_return == DEC_SUCCESS)
    {
        if(szFile[0] == NULL)
        {
            pCmdUI->Enable(FALSE);
            return;
        }
    }

    dec_return = DEC_Get_Type(DEC_ID, &dec_type);
    if(dec_return != DEC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }
    else
    {
        if( dec_type == DEC_TYPE_MPEG1_AUDIO ||
            dec_type == DEC_TYPE_MPEG2_AUDIO || dec_type == DEC_TYPE_UNKNOWN)
        {
            pCmdUI->Enable(FALSE);
            return;
        }
        else
        {
            pCmdUI->Enable(TRUE);
            return;
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetShowOverlay ]                                    
//                                                                      
// @\     I[o[CEBhE̕\Ԃ؂ւ                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetShowOverlay ]                                    
//                                                                      
//  Function:   Change overlay window state                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetShowOverlay() 
{
    DEC_RETURN  dec_return;
    CMenu*  pMenu;
    CMenu*  pPopup;
    UINT    nState;

    pMenu = GetMenu();
    pPopup = pMenu->GetSubMenu(1);
    nState = pPopup->GetMenuState(IDM_SET_SHOW_OVERLAY, MF_BYCOMMAND);

    // I[o[C\Ԃ̐؂ւ
    // Change overlay state, on/off
    dec_return = DEC_Show_Overlay_Window(DEC_ID, nState & MF_CHECKED ? FALSE : TRUE);

    if(dec_return == DEC_SUCCESS)
    {
        pPopup->CheckMenuItem(IDM_SET_SHOW_OVERLAY,
            MF_BYCOMMAND | (nState & MF_CHECKED ? MF_UNCHECKED : MF_CHECKED));
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetShowOverlay ]                              
//                                                                      
// @\     I[o[CEBhE݂Ȃꍇ                    
//          IłȂ悤ɂ                                      
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetShowOverlay ]                              
//                                                                      
//  Function:   If overlay window is not found, you cant select the item
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetShowOverlay(CCmdUI* pCmdUI) 
{
    if(!hWndOverlay)
            pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetNtsc ]                                           
//                                                                      
// @\     KiNTSCɐݒ肷                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetNtsc ]                                           
//                                                                      
//  Function:   Set NTSC                                                
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetNtsc() 
{
    DEC_RETURN  dec_return;
    DEC_VIDEO_PARAMETER dec_video_param;
    RECT        rc;
    UINT        nMonitor;
    CString     strMessage;

    // j^̏Ԃ擾
    // Get monitor status
    dec_return = DEC_Get_Monitor_Status(DEC_ID, &nMonitor);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_GET_MONITOR);
        MessageBox(strMessage);
        return;
    }

    // j^Ȃ烂j^~
    // Make to stop monitor
    if(nMonitor)
        DEC_Stop_Monitor(DEC_ID);

    // Set NTSC
    dec_video_param.TV_System = DEC_VIDEO_TV_SYSTEM_NTSC;
    dec_return = DEC_Set_Video_Parameter(DEC_ID, &dec_video_param);

    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_SET_VIDEO_PARAM);
        MessageBox(strMessage);
    }

    // j^̍ĊJ
    // Restart monitor
    if(nMonitor)
    {
        DEC_Start_Monitor(DEC_ID);
        GetClientRect(&rc);
        DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetNtsc ]                                     
//                                                                      
// @\     `FbN}[N̍XV                                        
//          Đ͑IłȂ悤ɂ                              
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetNtsc ]                                     
//                                                                      
//  Function:   If decode is working, you cant select the item          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetNtsc(CCmdUI* pCmdUI) 
{
    DEC_VIDEO_PARAMETER dec_video_param;
    DEC_STATUS  dec_status;

    DEC_Get_Video_Parameter(DEC_ID, &dec_video_param);

    if(dec_video_param.TV_System == DEC_VIDEO_TV_SYSTEM_NTSC)
        pCmdUI->SetCheck(TRUE);
    else
        pCmdUI->SetCheck(FALSE);

    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_PLAY)
        pCmdUI->Enable(FALSE);
    else
        pCmdUI->Enable(TRUE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetPal ]                                            
//                                                                      
// @\     KiPALɐݒ肷                                     
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetPal ]                                            
//                                                                      
//  Function:   Set PAL                                                 
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetPal() 
{
    DEC_RETURN  dec_return;
    DEC_VIDEO_PARAMETER dec_video_param;
    RECT        rc;
    UINT        nMonitor;
    CString     strMessage;

    // j^̏Ԃ擾
    // Get monitorstatus
    dec_return = DEC_Get_Monitor_Status(DEC_ID, &nMonitor);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_GET_MONITOR);
        MessageBox(strMessage);
        return;
    }

    // j^Ȃ烂j^~
    // Make to stop monitor
    if(nMonitor)
        DEC_Stop_Monitor(DEC_ID);

    // Set NTSC
    dec_video_param.TV_System = DEC_VIDEO_TV_SYSTEM_PAL;
    dec_return = DEC_Set_Video_Parameter(DEC_ID, &dec_video_param);

    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_SET_VIDEO_PARAM);
        MessageBox(strMessage);
    }

    // j^̍ĊJ
    // Restart monitor
    if(nMonitor)
    {
        DEC_Start_Monitor(DEC_ID);
        GetClientRect(&rc);
        DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetPal ]                                      
//                                                                      
// @\     `FbN}[N̍XV                                        
//          Đ͑IłȂ悤ɂ                              
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetPal ]                                      
//                                                                      
//  Function:   If decode is working, you cant select the item          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetPal(CCmdUI* pCmdUI) 
{
    DEC_VIDEO_PARAMETER dec_video_param;
    DEC_STATUS  dec_status;

    DEC_Get_Video_Parameter(DEC_ID, &dec_video_param);

    if(dec_video_param.TV_System == DEC_VIDEO_TV_SYSTEM_PAL)
        pCmdUI->SetCheck(TRUE);
    else
        pCmdUI->SetCheck(FALSE);

    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_PLAY)
        pCmdUI->Enable(FALSE);
    else
        pCmdUI->Enable(TRUE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetDecodeParam ]                                    
//                                                                      
// @\     fR[hp[^ݒ_CAǑďo                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetDecodeParam ]                                    
//                                                                      
//  Function:   Set decode parameter                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetDecodeParam() 
{
    CDecodeParam   dlg;

	dlg.m_nBoardConf = m_nBoardConf;
    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
// @\     R[obN֐                                            
//                                                                      
//  F      UINT                dec_id                              
//              DEC_STATUS_NOTIFY   dec_state                           
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
//  Function:   Callback function                                       
//                                                                      
//      Parameters:     UINT                dec_id                      
//                      DEC_STATUS_NOTIFY   dec_state                   
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK StatusProc(UINT dec_id, DEC_STATUS_NOTIFY dec_state)
{
    DEC_TYPE    dec_type;
    CString     szType;
    char        szText[MAX_PATH];

    if(dec_state == DEC_NOTIFY_STOP)
    {
        DEC_Get_Type(dec_id, &dec_type);

        switch(dec_type)
        {
        case DEC_TYPE_MPEG1_AUDIO:
            szType = "MPEG1 Audio";
            break;
        case DEC_TYPE_MPEG1_VIDEO:
            szType = "MPEG1 Video";
            break;
        case DEC_TYPE_MPEG1_SYSTEM_STREAM:
            szType = "MPEG1 System Stream";
            break;
        case DEC_TYPE_MPEG2_AUDIO:
            szType = "MPEG2 Audio";
            break;
        case DEC_TYPE_MPEG2_VIDEO:
            szType = "MPEG2 Video";
            break;
        case DEC_TYPE_MPEG2_PROGRAM_STREAM:
            szType = "MPEG2 Program Stream";
            break;
        default:
            szType = "unknown";
            break;
        }
    
        LoadString(m_hInstance, IDS_MESSAGE_STOP_DECODE, szText, sizeof(szText));
        ::MessageBox(AfxGetMainWnd()->GetSafeHwnd(), szText, szType, MB_OK);
    }
}

//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
// @\     R[obN֐iG[j                                  
//                                                                      
//  F      UINT        dec_id                                      
//              ULONG       error                                       
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
//  Function:   Callback function(error)                                
//                                                                      
//      Parameters:     UINT        dec_id                              
//                      ULONG       error                               
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK ErrorProc(UINT dec_id, ULONG error)
{
    CString strText;
    switch (error)
    {
    case MVR_ERROR_SUCCESS:
        strText = "MVR_ERROR_SUCCESS";
        break;
    case MVR_ERROR_PENDING:
        strText = "MVR_ERROR_PENDING";
        break;
    case MVR_ERROR_SYSTEM_ERROR:
        strText = "MVR_ERROR_SYSTEM_ERROR";
        break;
    case MVR_ERROR_NOT_PENDING:
        strText = "MVR_ERROR_NOT_PENDING";
        break;
    case MVR_ERROR_INVALID_ASYNCOP:
        strText = "MVR_ERROR_INVALID_ASYNCOP";
        break;
    case MVR_ERROR_UNSUPPORTED:
        strText = "MVR_ERROR_UNSUPPORTED";
        break;
    case MVR_ERROR_INVALID_TYPE:
        strText = "MVR_ERROR_INVALID_TYPE";
        break;
    case MVR_ERROR_INVALID_OPTION:
        strText = "MVR_ERROR_INVALID_OPTION";
        break;
    case MVR_ERROR_INVALID_ADDRESS:
        strText = "MVR_ERROR_INVALID_ADDRESS";
        break;
    case MVR_ERROR_LIMIT_EXCEEDED:
        strText = "MVR_ERROR_LIMIT_EXCEEDED";
        break;
    case MVR_ERROR_INVALID_HANDLE:
        strText = "MVR_ERROR_INVALID_HANDLE";
        break;
    case MVR_ERROR_INVALID_STREAM:
        strText = "MVR_ERROR_INVALID_STREAM";
        break;
    case MVR_ERROR_INVALID_BUFFER:
        strText = "MVR_ERROR_INVALID_BUFFER";
        break;
    case MVR_ERROR_INVALID_MESSAGE:
        strText = "MVR_ERROR_INVALID_MESSAGE";
        break;
    case MVR_ERROR_CANCELED:
        strText = "MVR_ERROR_CANCELED";
        break;
    case MVR_ERROR_BUSY:
        strText = "MVR_ERROR_BUSY";
        break;
    case MVR_ERROR_BUFFER_ERROR:
        strText = "MVR_ERROR_BUFFER_ERROR";
        break;
    case MVR_ERROR_MESSAGE_ERROR:
        strText = "MVR_ERROR_MESSAGE_ERROR";
        break;
    case MVR_ERROR_BAD_PARAM:
        strText = "MVR_ERROR_BAD_PARAM";
        break;
    case MVR_ERROR_HARDWARE_ERROR:
        strText = "MVR_ERROR_HARDWARE_ERROR";
        break;
    case MVR_ERROR_ALLOC_FAILURE:
        strText = "MVR_ERROR_ALLOC_FAILURE";
        break;
    case MVR_ERROR_INVALID_EVENT:
        strText = "MVR_ERROR_INVALID_EVENT";
        break;
    case MVR_ERROR_INVALID_STATE:
        strText = "MVR_ERROR_INVALID_STATE";
        break;
    case MVR_ERROR_CURRENT_STATE:
        strText = "MVR_ERROR_CURRENT_STATE";
        break;
    case MVR_ERROR_INVALID_FRAME_TYPE:
        strText = "MVR_ERROR_INVALID_FRAME_TYPE";
        break;
    case MVR_ERROR_INSUFFICIENT_BUFFERS:
        strText = "MVR_ERROR_INSUFFICIENT_BUFFERS";
        break;
    case MVR_ERROR_TIMEOUT:
        strText = "MVR_ERROR_TIMEOUT";
        break;
    case MVR_ERROR_INVALID_CODEC_STATE:
        strText = "MVR_ERROR_INVALID_CODEC_STATE";
        break;
    case MVR_ERROR_INVALID_FORMAT:
        strText = "MVR_ERROR_INVALID_FORMAT";
        break;
    case MVR_ERROR_INVALID_OPERATION:
        strText = "MVR_ERROR_INVALID_OPERATION";
        break;
    case MVR_ERROR_OVERFLOW:
        strText = "MVR_ERROR_OVERFLOW";
        break;
    case MVR_ERROR_UNDERFLOW:
        strText = "MVR_ERROR_UNDERFLOW";
        break;
    case MVR_ERROR_SESSION_CANCELED:
        strText = "MVR_ERROR_SESSION_CANCELED";
        break;
    case MVR_ERROR_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_AUDIO_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_AUDIO_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_PARSE_ERROR:
        strText = "MVR_ERROR_PARSE_ERROR";
        break;
    case MVR_ERROR_END_OF_STREAM:
        strText = "MVR_ERROR_END_OF_STREAM";
        break;
    case MVR_ERROR_DISK_FULL:
        strText = "MVR_ERROR_DISK_FULL";
        break;
    case MVR_ERROR_STREAMS_CLOSED:
        strText = "MVR_ERROR_STREAMS_CLOSED";
        break;
    case MVR_ERROR_INTERNAL_ERROR:
        strText = "MVR_ERROR_INTERNAL_ERROR";
        break;
    case MVR_ERROR_INVALID_SHORT_BUFFER:
        strText = "MVR_ERROR_INVALID_SHORT_BUFFER";
        break;
    case MVR_ERROR_EVENT_DATA_OVERRUN:
        strText = "MVR_ERROR_EVENT_DATA_OVERRUN";
        break;
    case MVR_ERROR_EVENT_DATA_UNDERRUN:
        strText = "MVR_ERROR_EVENT_DATA_UNDERRUN";
        break;
    case MVR_ERROR_EVENT_DEVICE_ERROR:
        strText = "MVR_ERROR_EVENT_DEVICE_ERROR";
        break;
    case MVR_ERROR_EVENT_LOSS_OF_VIDEO:
        strText = "MVR_ERROR_EVENT_LOSS_OF_VIDEO";
        break;
    case MVR_ERROR_EVENT_EVENT_LOSS:
        strText = "MVR_ERROR_EVENT_EVENT_LOSS";
        break;
    case MVR_ERROR_EVENT_UNRECOVERABLE_ERROR:
        strText = "MVR_ERROR_EVENT_UNRECOVERABLE_ERROR";
        break;
    default:
        strText = "????";
        break;
    }
    AfxMessageBox(strText);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAdjust ]                                         
//                                                                      
// @\     掿𒲐                                              
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAdjust ]                                         
//                                                                      
//  Function:   Set Adjust                                              
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAdjust() 
{
    CAdjust dlg;

	dlg.m_nBoardConf = m_nBoardConf;
    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetGetLastError ]                                   
//                                                                      
// @\     G[擾                                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetGetLastError ]                                   
//                                                                      
//  Function:   Get Last Error                                          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetGetLastError() 
{
    ULONG   Err;
    char    szText[256];

    Err = DEC_Get_Last_Error(DEC_ID);

    if(Err == MVR_ERROR_SUCCESS)
        return;

    wsprintf(szText, "Error = %d\n", Err);
    MessageBox(szText);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeSeek ]                                        
//                                                                      
// @\     V[N                                                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeSeek ]                                        
//                                                                      
//  Function:   Seek                                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodeSeek() 
{
    DEC_RETURN  dec_return;
    DWORD       dwTime;
    CSeekDlg    dlg;

    dec_return = DEC_Get_Playback_Time(DEC_ID, &dwTime);
    if(dec_return != DEC_SUCCESS || dwTime == 0)
        return;

    dlg.m_Edit_Seek_Time = 0;
    dlg.m_Edit_Time     = dwTime;

    if(dlg.DoModal() == IDOK)
    {
        if(!(dlg.m_Edit_Seek_Time >= 0 && dlg.m_Edit_Seek_Time <= dlg.m_Edit_Time))
            return;

        DEC_Seek(DEC_ID, dlg.m_Edit_Seek_Time);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodeSeek ]                                  
//                                                                      
// @\     t@CIĂȂꍇ                            
//          GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodeSeek ]                                  
//                                                                      
//  Function:    User can't select item when a file is not selected,    
//              or when it is decoding.                                 
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return valueF  none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateDecodeSeek(CCmdUI* pCmdUI) 
{
    DEC_RETURN  dec_return;
    DEC_STATUS  dec_status;
    DWORD       dwTime;

    dec_return = DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_return == DEC_SUCCESS && dec_status == DEC_STATUS_STOP)
        pCmdUI->Enable(TRUE);
    else
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    dec_return = DEC_Get_Playback_Time(DEC_ID, &dwTime);
    if(dec_return == DEC_SUCCESS && dwTime != 0)
        pCmdUI->Enable(TRUE);
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePlayFrom ]                                    
//                                                                      
// @\     Đʒuw肵čĐJn܂                          
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePlayFrom ]                                    
//                                                                      
//  Function:   Decode starts from seek point.                          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodePlayFrom() 
{
    DEC_RETURN  dec_return;
    DWORD       dwTime;
    CSeekDlg    dlg;

    dec_return = DEC_Get_Playback_Time(DEC_ID, &dwTime);
    if(dec_return != DEC_SUCCESS || dwTime == 0)
        return;

    dlg.m_Edit_Seek_Time = 0;
    dlg.m_Edit_Time     = dwTime;

    if(dlg.DoModal() == IDOK)
    {
        if(!(dlg.m_Edit_Seek_Time >= 0 && dlg.m_Edit_Seek_Time <= dlg.m_Edit_Time))
            return;

        DEC_Play_From(DEC_ID, dlg.m_Edit_Seek_Time);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePlayFrom ]                              
//                                                                      
// @\     t@CIĂȂꍇ                            
//          GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePlayFrom ]                              
//                                                                      
//  Function:    User can't select item when a file is not selected,    
//              or when it is decoding.                                 
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return valueF  none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateDecodePlayFrom(CCmdUI* pCmdUI) 
{
    DEC_RETURN  dec_return;
    DEC_STATUS  dec_status;
    DWORD       dwTime;

    dec_return = DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_return == DEC_SUCCESS && dec_status == DEC_STATUS_STOP)
        pCmdUI->Enable(TRUE);
    else
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    dec_return = DEC_Get_Playback_Time(DEC_ID, &dwTime);
    if(dec_return == DEC_SUCCESS && dwTime != 0)
        pCmdUI->Enable(TRUE);
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePlayFrom ]                              
//                                                                      
// @\     fR[h͑IłȂ悤ɂ                          
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateDecodePlayFrom ]                              
//                                                                      
//  Function:    If decoder is decoding, user can't select the item.    
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return valueF  none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateAppExit(CCmdUI* pCmdUI) 
{
    DEC_STATUS  dec_status;
    DEC_RETURN  dec_return;
    
    dec_return = DEC_Get_Status(DEC_ID, &dec_status);

    if(dec_return == DEC_SUCCESS)
    {
        if(dec_status == DEC_STATUS_STOP)
            pCmdUI->Enable(TRUE);
        else
            pCmdUI->Enable(FALSE);
    }
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlayRect ]                                    
//                                                                      
// @\     I[o[C̕\̈ݒ肵܂                          
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlayRect ]                                    
//                                                                      
//  Function:   Set overlay rect.                                       
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetOverlayRect() 
{
    COverlayRectDlg dlg;
    RECT            rc;

    if(DEC_Get_Overlay_Rect(DEC_ID, &rc) == DEC_FAIL)
        return;
    
    dlg.m_edit_top  = rc.top;
    dlg.m_edit_left = rc.left;
    dlg.m_edit_bottom   = rc.bottom;
    dlg.m_edit_right    = rc.right;

    if(dlg.DoModal() == IDOK)
    {
        rc.top      = dlg.m_edit_top;
        rc.left     = dlg.m_edit_left;
        rc.bottom   = dlg.m_edit_bottom;
        rc.right    = dlg.m_edit_right;
        
        DEC_Set_Overlay_Rect(DEC_ID, &rc);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetOverlayRect ]                              
//                                                                      
// @\     fR[h͑IłȂ悤ɂ                          
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetOverlayRect ]                              
//                                                                      
//  Function:   If decoder is decoding, user can't select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetOverlayRect(CCmdUI* pCmdUI) 
{
	if ( m_nBoardConf == DECCAP_D2200V ) 
	{
#define DECPARAM_OUTPUT_DEVICE 0x4000
#define DEC_OUTPUT_DEVICE_SOFTWARE	0	
#define DEC_OUTPUT_DEVICE_DVSTORM	1
#define DEC_OUTPUT_DEVICE_MVR_SOFTWARE		2
#define DEC_OUTPUT_DEVICE_MVR_HARDWARE		3

		DWORD dwValue;

		if ( DEC_Get_Overlay_Parameter_Ex( DEC_ID, (DECPARAM_OVERLAY)DECPARAM_OUTPUT_DEVICE, &dwValue) != DEC_FAIL ) {
			if ( dwValue != DEC_OUTPUT_DEVICE_MVR_HARDWARE ) {
				pCmdUI->Enable(FALSE);
			}
		}
	}
	else 
	{
		DEC_STATUS  dec_status;
    
		DEC_Get_Status(DEC_ID, &dec_status);
		if(dec_status == DEC_STATUS_STOP)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	}
}

//----------------------------------------------------------------------
// #[ CMainFrame::CreateVideoPortOverlayWindow ]                                 
//                                                                      
// @\     rfI|[gI[o[CEBhE쐬                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE    EBhE쐬ɐ                    
//                      FALSE   EBhE쐬Ɏs                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::CreateVideoPortOverlayWindow ]                                 
//                                                                      
//  Function:   Create video port overlay window                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE;   success                         
//                              FALSE;  fail                            
//                                                                      
//----------------------------------------------------------------------
BOOL CMainFrame::CreateVideoPortOverlayWindow()
{
    DEC_RETURN  dec_return;
    RECT        rc;
    CString     strMessage;

    GetClientRect(&rc);

	dec_return = DEC_Can_VideoPort_Overlay_Window(DEC_ID, NULL, rc.right, rc.bottom);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_CAN_VIDEOPORTOVERLAY);
        MessageBox(strMessage);
        return FALSE;
    }

    dec_return = DEC_Create_VideoPort_Overlay_Window( DEC_ID, m_hWnd, &hWndOverlay, 0, 0, rc.right, rc.bottom);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_CREATE_VIDEOPORTOVERLAY);
        MessageBox(strMessage);
        return FALSE;
    }

	DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);

    return TRUE;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoportOverlay ]                                 
//                                                                      
// @\     rfI|[ggpăI[o[C쐬邩ǂw肵܂B
//                                                                      
//
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoportOverlay ]                                 
//                                                                      
//  Function:   Specify whether to create overlay using VideoPort.                                  
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                      
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoportOverlay() 
{
	DEC_RETURN  dec_return;
	CString     strMessage;

	if(hWndOverlay != NULL)
	{
		dec_return = DEC_Destroy_Overlay_Window(DEC_ID);
		if(dec_return != DEC_SUCCESS)
		{
			strMessage.LoadString(IDS_ERROR_DESTROY_OVERLAY);
			MessageBox(strMessage);
		}
	}

	m_fVideoPort = !m_fVideoPort;

	if ( m_fVideoPort == TRUE) 
	{
		CreateVideoPortOverlayWindow();
	}
	else
	{
		CreateOverlayWindow();
	}
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoportOverlay ]                              
//                                                                      
// @\     I[o[C̏ԂύXłȂ
//                       
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoportOverlay ]                              
//                                                                      
//  Function:   If decoder is decoding, user can't select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoportOverlay(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_fVideoPort);

	DEC_STATUS  dec_status;
    
	DEC_Get_Status(DEC_ID, &dec_status);

	CMenu*  pMenu;
    CMenu*  pPopup;
    UINT    nState;

    pMenu = GetMenu();
    pPopup = pMenu->GetSubMenu(1);
    nState = pPopup->GetMenuState(IDM_SET_SHOW_OVERLAY, MF_BYCOMMAND);

	if ( nState & MF_CHECKED )
	{
		if(dec_status != DEC_STATUS_STOP)
		{
			pCmdUI->Enable(FALSE);
		}
		else 
		{
			if(m_fSupportVideoPort == TRUE)
				pCmdUI->Enable(TRUE);
			else
				pCmdUI->Enable(FALSE);
		}
	}
	else 
	{
		pCmdUI->Enable(FALSE);
	}
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnGetStillImage ]                                    
//                                                                      
// @\     Î~Lv`܂B                         
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnGetStillImage ]                                 
//                                                                      
//  Function:   Capture still image.                                  
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                      
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnGetStillImage() 
{
    CString strMessage;
    CString strFileName;
	CString strFilter;
	
	strFilter.LoadString(ID_STILLIMAGE_FILTER);

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, _T("bmp"), NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strFilter);

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
		if (strFileName.IsEmpty())
		{
			return;
		}

		MVRSTILLCAPPARAM Param;

		ZeroMemory( &Param, sizeof(MVRSTILLCAPPARAM));

		// TCYwiK{j
		// define the size (mandate)
		Param.dwSize = sizeof(MVRSTILLCAPPARAM);
		Param.nFrameCap = m_nStillCapture;

		// YUV - RGB ϊ[16-235] ͈̔  [0-255] ͈̔͂ɍL܂
		// expand the range [16-235] to [0-255]
		Param.fExpandRGB = TRUE;

		DEC_VIDEO_PARAMETER dec_video_param;

		DEC_Get_Video_Parameter(DEC_ID, &dec_video_param);

		// K}␳l  : NTSC : 2.2 PAL : 2.8
		// gamma value : default value is 2.2(NTSC) 2.8(PAL)
		if (dec_video_param.TV_System != DEC_VIDEO_TV_SYSTEM_NTSC) {
			Param.dCorrectGamma = 2.8;
		}
		else 
		{
			Param.dCorrectGamma = 2.2;
		}

		Param.pfnuyvy2rgb = NULL;

		if (dlg.GetFileExt() == "bmp")
		{
			if ( DEC_Save_DIB( DEC_ID, strFileName, &Param) != DEC_FAIL) 
			{
				return;
			}
		}
		else
		{
			if ( DEC_Save_JPEG( DEC_ID, strFileName, m_nJpegQuality, &Param) != DEC_FAIL)
			{
				return;
			}
		}

		strMessage.LoadString(IDS_ERROR_STILL_CAPTURE);
		MessageBox(strMessage);
	}
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetStillcaptureParam ]                                         
//                                                                      
// @\     Î~Lv`̃p[^ݒ肷B                                             
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetStillcaptureParam ]                                         
//                                                                      
//  Function:   Parameter setup for still image capture                                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetStillcaptureParam() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	// TODO: Add your command handler code here
	CStillCapParam dlg;

	dlg.m_nJpegQuality = m_nJpegQuality;
	dlg.m_nStillCapture = m_nStillCapture;

	if ( dlg.DoModal() == IDOK) {
		m_nJpegQuality = dlg.m_nJpegQuality;
		m_nStillCapture = dlg.m_nStillCapture;
	}
}
