//======================================================================
// -- MainFrm.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//                                  GR[h  TvvO      
//                                  Encode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// MainFrm.cpp : CMainFrame NX̓̒`s܂B
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Encode.h"

#include "MainFrm.h"
#include "TimeDlg.h"        // Set Record Time 
#include "AudioDlg.h"       // Set Audio Parameter
#include "AudioEncDlg.h"    // Set Audio Encode Parameter
#include "VideoDlg.h"       // Set Video Parameter
#include "VideoEncDlg.h"    // Set Video Encode Parameter
#include "VideoEncExDlg.h"  // Set Video Encode Parameter Ex
#include "OverlayDlg.h"     // Set Overlay Window(Adjust)
#include "overlayRectDlg.h"

#include "StillCapParam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern  int ENC_ID;
CMainFrame* pMain;
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_WM_CREATE()
    ON_WM_CLOSE()
    ON_WM_MOVE()
    ON_WM_SIZE()
    ON_COMMAND(IDM_SET_TIME, OnSetTime)
    ON_COMMAND(IDM_SET_AUDIO_PARAM, OnSetAudioParam)
    ON_COMMAND(IDM_SET_VIDEO_PARAM, OnSetVideoParam)
    ON_COMMAND(IDM_SET_VIDEO_ENC_PARAM, OnSetVideoEncParam)
    ON_COMMAND(IDM_SET_AUDIO_ENC_PARAM, OnSetAudioEncParam)
    ON_COMMAND(IDM_ENC_AUDIO, OnEncAudio)
    ON_COMMAND(IDM_ENC_VIDEO, OnEncVideo)
    ON_COMMAND(IDM_ENC_AV, OnEncAv)
    ON_COMMAND(IDM_ENC_PROGRAM, OnEncProgram)
    ON_UPDATE_COMMAND_UI(IDM_ENC_AUDIO, OnUpdateEncAudio)
    ON_UPDATE_COMMAND_UI(IDM_ENC_VIDEO, OnUpdateEncVideo)
    ON_UPDATE_COMMAND_UI(IDM_ENC_AV, OnUpdateEncAv)
    ON_UPDATE_COMMAND_UI(IDM_ENC_PROGRAM, OnUpdateEncProgram)
    ON_COMMAND(IDM_ENC_STOP, OnEncStop)
    ON_UPDATE_COMMAND_UI(IDM_ENC_STOP, OnUpdateEncStop)
    ON_UPDATE_COMMAND_UI(ID_APP_EXIT, OnUpdateAppExit)
    ON_UPDATE_COMMAND_UI(IDM_SET_AUDIO_PARAM, OnUpdateSetAudioParam)
    ON_UPDATE_COMMAND_UI(IDM_SET_AUDIO_ENC_PARAM, OnUpdateSetAudioEncParam)
    ON_UPDATE_COMMAND_UI(IDM_SET_VIDEO_PARAM, OnUpdateSetVideoParam)
    ON_UPDATE_COMMAND_UI(IDM_SET_VIDEO_ENC_PARAM, OnUpdateSetVideoEncParam)
    ON_UPDATE_COMMAND_UI(IDM_SET_TIME, OnUpdateSetTime)
    ON_COMMAND(IDM_SET_OVERLAY, OnSetOverlay)
    ON_UPDATE_COMMAND_UI(IDM_SET_OVERLAY, OnUpdateSetOverlay)
    ON_COMMAND(IDM_SET_MONITOR, OnSetMonitor)
    ON_UPDATE_COMMAND_UI(IDM_SET_MONITOR, OnUpdateSetMonitor)
    ON_COMMAND(IDM_SET_VIDEO_CD, OnSetVideoCd)
    ON_UPDATE_COMMAND_UI(IDM_SET_VIDEO_CD, OnUpdateSetVideoCd)
    ON_COMMAND(IDM_SET_AUDIO_FORMAT_MPEG, OnSetAudioFormatMpeg)
    ON_COMMAND(IDM_SET_AUDIO_FORMAT_MONO, OnSetAudioFormatMono)
    ON_COMMAND(IDM_SET_AUDIO_FORMAT_STEREO, OnSetAudioFormatStereo)
    ON_UPDATE_COMMAND_UI(IDM_SET_AUDIO_FORMAT_MPEG, OnUpdateSetAudioFormatMpeg)
    ON_UPDATE_COMMAND_UI(IDM_SET_AUDIO_FORMAT_MONO, OnUpdateSetAudioFormatMono)
    ON_UPDATE_COMMAND_UI(IDM_SET_AUDIO_FORMAT_STEREO, OnUpdateSetAudioFormatStereo)
    ON_COMMAND(IDM_SET_VIDEO_ENC_PARAM_EX, OnSetVideoEncParamEx)
    ON_UPDATE_COMMAND_UI(IDM_SET_VIDEO_ENC_PARAM_EX, OnUpdateSetVideoEncParamEx)
    ON_COMMAND(IDM_SET_OVERLAY_ADJUST, OnSetOverlayAdjust)
    ON_COMMAND(IDM_SET_GET_LAST_ERROR, OnSetGetLastError)
    ON_COMMAND(IDB_SET_ENCODE_FILE, OnSetEncodeFile)
    ON_COMMAND(IDM_SET_OVERLAY_RECT, OnSetOverlayRect)
    ON_UPDATE_COMMAND_UI(IDM_SET_OVERLAY_RECT, OnUpdateSetOverlayRect)
	ON_COMMAND(IDM_GET_STILL_IMAGE, OnGetStillImage)
	ON_COMMAND(IDM_SET_STILLCAPTURE_PARAM, OnSetStillcaptureParam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
    // TODO: ̈ʒuɃȍR[hǉĂB
 	// TODO: add member initialization code here
   hWndOverlay = NULL;
    nWidth = 720;
    nHeight = 480;
	m_nBoardConf = 0;

	m_nJpegQuality = 1;
	m_nStillCapture = MVRSTILL_FRAME;
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
    //       CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

    return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh
// CMainFrame message handlers

//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
// @\                                                       
//                                                                      
//  F      LPCREATESTRUCT lpCreateStruct;                          
//                                                                      
//  ߂lF    int     0;                                          
//                      -1;     s                                    
//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
//  Function:   Initialize                                              
//                                                                      
//      Parameters:     LPCREATESTRUCT lpCreateStruct;                  
//                                                                      
//      Return value:   int     0;      success                         
//                              -1;     fail                            
//----------------------------------------------------------------------
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    ENC_RETURN  enc_return;
    CString     strMessage;
    UINT        nNumber=0;

    ENC_CONFIG  config;
    UINT        ui;

    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

    pMain = this;

    for (int i = 1; i < __argc; i++) {
        LPCTSTR pszParam = __targv[i];
        if ((pszParam[0] == _T('-') || pszParam[0] == _T('/')) && !_tcsnicmp(pszParam + 1, _T("id:"), _tcslen(_T("id:"))))
            // id number is specified by /id:n
            nNumber = atoi(pszParam + 4);
    }

    if (nNumber == 0)
    {
        memset(&config, 0, sizeof(ENC_CONFIG));
        ENC_Get_Codec_Config(ENC_ID, &config);

        for (ui = 0;ui <= config.NumberCodecs; ui++)
        {
            config.CodecNumber = ui;
            ENC_Get_Codec_Config(ENC_ID, &config);
            if (config.CurrentUtilization == FALSE)
            {
                if (config.CodecCaps & ENCCAP_ENCODE)
                {
	                if ( config.CodecCaps & ENCCAP_D2200)
		            {
						m_nBoardConf = ENCCAP_D2200;
					}
					else if ( config.CodecCaps & ENCCAP_D2200V) 
					{
						m_nBoardConf = ENCCAP_D2200V;
					}
					else if ( config.CodecCaps & ENCCAP_D2200V) 
					{
						m_nBoardConf = ENCCAP_D2200V;
					}
					else {
						m_nBoardConf = 0;
					}
                    nNumber = ui;
                    break;
                }
            }
        }
    }
    
    ENC_ID = nNumber;

    ENC_Set_Codec_Number(ENC_ID, nNumber);

    // Cȕ
    // Initialize library
    enc_return = ENC_Initialize(ENC_ID);

    if(enc_return != ENC_SUCCESS)
    {
        int a;
        char b[50];
        a = ENC_Get_Last_Error(ENC_ID);
        wsprintf(b, "%d", a);
        strMessage.LoadString(IDC_ERROR_INIT_LIBRARY);
        MessageBox(strMessage,b);
        return -1;
    }

    // R[obN̐ݒ
    // Set CallbackProc
    enc_return = ENC_Set_Callback(ENC_ID, StatusProc, ErrorProc, TmapProc, NULL, NULL);
    if(enc_return != ENC_SUCCESS)
    {
        return -1;
    }

    // I[o[CEBhE̍쐬
    // Create overlay window
    if(hWndOverlay == NULL)
        CreateOverlayWindow();

    // ̓\[X̌o
    // Detect input source
    AutoDetect();
    
    // j^Jn
    // Start monitor
    ENC_Start_Monitor(ENC_ID);

    return 0;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
// @\     AvP[VI܂                                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
//  Function:   End application                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnClose() 
{
    ENC_RETURN  enc_return;
    CString     strMessage;

    // j^~
    // Stop monitor
    ENC_Stop_Monitor(ENC_ID);

    // I[o[CEBhEj
    // Destroy overlay window
    if(hWndOverlay != NULL)
    {
        enc_return = ENC_Destroy_Overlay_Window(ENC_ID);
        if(enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_DESTROY_OVERLAY);
            MessageBox(strMessage);
        }
    }

    // GR[_I
    // Terminate decode
    enc_return = ENC_Terminate(ENC_ID);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_TERMINATE_ENCODE);
        MessageBox(strMessage);
    }
    
    CFrameWnd::OnClose();
}

//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
// @\     I[o[CEBhE쐬                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE    EBhE쐬ɐ                    
//                      FALSE   EBhE쐬Ɏs                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
//  Function:   Create overlay window                                   
//                                                                      
//      Parameters:  none                                               
//                                                                      
//      Return value:   BOOL    TRUE    success                         
//                              FALSE   fail                            
//                                                                      
//----------------------------------------------------------------------
BOOL CMainFrame::CreateOverlayWindow()
{
    ENC_RETURN  enc_return;
    RECT        rc;
    CString     strMessage;

    GetClientRect(&rc);

    enc_return = ENC_Can_Overlay_Window(ENC_ID, NULL, rc.right, rc.bottom);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_CAN_OVERLAY);
        MessageBox(strMessage);
    }
    else
    {
        // I[o[CEBhE̍쐬
        // Create overlay window
        enc_return = ENC_Create_Overlay_Window(ENC_ID, m_hWnd, &hWndOverlay, 0, 0, rc.right, rc.bottom);
    
        if(enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_CREATE_OVERLAY);
            MessageBox(strMessage);
        }
    }

    return TRUE;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
// @\     I[o[CEBhËʒüړ                          
//                                                                      
//  F      int     x                                               
//              int     y                                               
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
//  Function:   Move overlay window                                     
//                                                                      
//      Parameters:     int     x                                       
//                      int     y                                       
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnMove(int x, int y) 
{
    CFrameWnd::OnMove(x, y);

    if(hWndOverlay)
        ENC_Move_Overlay_Window(ENC_ID, x, y);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
// @\     I[o[CEBhẼTCYύX                          
//                                                                      
//  F      UINT    nType                                           
//              int     cx                                              
//              int     cy                                              
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
//  Function:   Resize overlay window                                   
//                                                                      
//      Parameters:     UINT    nType                                   
//                      int     cx                                      
//                      int     cy                                      
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);

    if(hWndOverlay)
        ENC_Resize_Overlay_Window(ENC_ID, cx, cy);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetTime ]                                           
//                                                                      
// @\     Lv`Ԃ̐ݒ_CAOĂяo                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetTime ]                                           
//                                                                      
//  Function:   Set recorde time                                        
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetTime() 
{
    CTimeDlg    dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioParam ]                                     
//                                                                      
// @\     I[fBIp[^ݒ_CAOĂяo                  
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioParam ]                                     
//                                                                      
//  Function:   Set audio parameters                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudioParam() 
{
    CAudioDlg   dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioEncParam ]                                  
//                                                                      
// @\     I[fBIGR[hp[^ݒ_CAOĂяo        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioEncParam ]                                  
//                                                                      
//  Function:   Set audio encode parameters                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudioEncParam() 
{
    CAudioEncDlg    dlg;
    RECT            rc;

    if(dlg.DoModal() == IDOK)
    {
        GetClientRect(&rc);
        ENC_Resize_Overlay_Window(ENC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoParam ]                                     
//                                                                      
// @\     rfIp[^ݒ_CAOĂяo                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoParam ]                                     
//                                                                      
//  Function:   Set video parameters                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoParam() 
{
    ENC_RETURN  enc_return;
    CVideoDlg   dlg;
    CString     strMessage;
    RECT        rc;

	dlg.m_nBoardConf = m_nBoardConf;

    if(dlg.DoModal() == IDOK)
    {
        // EBhEnh̍XV
        // Get a handle of overlay window
        enc_return = ENC_Get_Overlay_Window(ENC_ID, &hWndOverlay);
        if(enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_GET_OVERLAY);
            MessageBox(strMessage);
            return;
        }
        
        GetClientRect(&rc);
        ENC_Resize_Overlay_Window(ENC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoEncParam ]                                  
//                                                                      
// @\     rfIGR[hp[^ݒ_CAOĂяo            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoEncParam ]                                  
//                                                                      
//  Function:   Set video encode parameters                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoEncParam() 
{
    CVideoEncDlg    dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncAudio ]                                          
//                                                                      
// @\     GR[hiI[fBIj                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncAudio ]                                          
//                                                                      
//  Function:   Audio encode                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncAudio() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szFile[MAX_PATH];
    char    szFilter[] = {"Mpeg2 Audio(*,m2a)|*.m2a|Mpeg1 Audio(*.mpa)|*.mpa||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szFile);
    if(enc_return == ENC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
        lstrcpy(szFile, strFileName);

        SetWindowText(szFile);

        // t@Cݒ肷
        // Set audio encode file name
        enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szFile);
        if(enc_return == ENC_SUCCESS)
        {
            enc_return = ENC_Init_Movie(ENC_ID);
            if(enc_return == ENC_SUCCESS)
            {
                strMessage.LoadString(IDC_MESSAGE_START_CAPTURE);
                MessageBox(strMessage);
                enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_AUDIO);
                if(enc_return != ENC_SUCCESS)
                {
                    strMessage.LoadString(IDC_ERROR_START_CAPTURE);
                    MessageBox(strMessage);
                    return;
                }
            }
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncVideo ]                                          
//                                                                      
// @\     GR[hirfIj                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncVideo ]                                          
//                                                                      
//  Function:   Video encode                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncVideo() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szFile[MAX_PATH];
    char    szFilter[] = {"Mpeg2 Video(*,m2v)|*.m2v|Mpeg1 Video(*.mpv)|*.mpv||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szFile);
    if(enc_return == ENC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
        lstrcpy(szFile, strFileName);

        SetWindowText(szFile);

        // t@Cݒ肷
        // Set audio encode file name
        enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szFile);
        if(enc_return == ENC_SUCCESS)
        {
            enc_return = ENC_Init_Movie(ENC_ID);
            if(enc_return == ENC_SUCCESS)
            {
                strMessage.LoadString(IDC_MESSAGE_START_CAPTURE);
                MessageBox(strMessage);
                enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_VIDEO);
                if(enc_return != ENC_SUCCESS)
                {
                    strMessage.LoadString(IDC_ERROR_START_CAPTURE);
                    MessageBox(strMessage);
                    return;
                }
            }
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncAV ]                                             
//                                                                      
// @\     GR[hiI[fBI{rfIj                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncAV ]                                             
//                                                                      
//  Function:   Audio and video encode                                  
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncAv() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szVideoFile[MAX_PATH];
    char    szAudioFile[MAX_PATH];
    char    szVideoFilter[] = {"Mpeg2 Video Stream(*,m2v)|*.m2v|Mpeg1 Video Stream(*.mpv)|*.mpv||"};
    char    szAudioFilter[] = {"Mpeg2 Audio Stream(*,m2a)|*.m2a|Mpeg1 Audio Stream(*.mpa)|*.mpa||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlgVideo(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szVideoFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szVideoFile);
    if(enc_return == ENC_SUCCESS)
        dlgVideo.m_ofn.lpstrFile = szVideoFile;

    if (dlgVideo.DoModal() != IDOK)
        return;

    strFileName = dlgVideo.GetPathName();
    lstrcpy(szVideoFile, strFileName);

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlgAudio(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szAudioFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szAudioFile);
    if(enc_return == ENC_SUCCESS)
        dlgAudio.m_ofn.lpstrFile = szAudioFile;

    if (dlgAudio.DoModal() != IDOK)
        return;

    strFileName = dlgAudio.GetPathName();
    lstrcpy(szAudioFile, strFileName);

    // t@C̐ݒ
    // Set file name
    enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szVideoFile);
    if (enc_return != ENC_SUCCESS)
        return;
    
    enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szAudioFile);
    if (enc_return != ENC_SUCCESS)
        return;

    strFileName.Format("%s + %s", szVideoFile, szAudioFile);
    SetWindowText(strFileName);
    
    // Lv`Jn
    // Start capture
    enc_return = ENC_Init_Movie(ENC_ID);
    if (enc_return == ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_MESSAGE_START_CAPTURE);
        MessageBox(strMessage);
        enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_VIDEO | ENC_RECORD_AUDIO);
        if (enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_START_CAPTURE);
            MessageBox(strMessage);
            return;
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncProgram ]                                        
//                                                                      
// @\     GR[hivOXg[j                          
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncProgram ]                                        
//                                                                      
//  Function:   Program stream encode                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncProgram() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szFile[MAX_PATH];
    char    szFilter[] = {"Mpeg2 Program Stream(*,m2p)|*.m2p|Mpeg1 System Stream(*.mpg)|*.mpg||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_PS, szFile);
    if(enc_return == ENC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
        lstrcpy(szFile, strFileName);

        SetWindowText(szFile);

        // t@C̎擾
        // Get file name
        enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_PS, szFile);
        if(enc_return == ENC_SUCCESS)
        {
            enc_return = ENC_Init_Movie(ENC_ID);
            if(enc_return == ENC_SUCCESS)
            {
                strMessage.LoadString(IDC_MESSAGE_START_CAPTURE);
                MessageBox(strMessage);
                enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_PS);
                if(enc_return != ENC_SUCCESS)
                {
                    strMessage.LoadString(IDC_ERROR_START_CAPTURE);
                    MessageBox(strMessage);
                    return;
                }
            }
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlay ]                                        
//                                                                      
// @\     I[o[C̕\/\̐؂ւ                         
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlay ]                                        
//                                                                      
//  Function:   Set overlay state                                       
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetOverlay() 
{
    ENC_RETURN  enc_return;
    CString     strMessage;
    CMenu*      pMenu;
    CMenu*      pPopup;
    UINT        nState;

    pMenu = GetMenu();
    pPopup = pMenu->GetSubMenu(1);
    nState = pPopup->GetMenuState(IDM_SET_OVERLAY, MF_BYCOMMAND);

    // EBhEnh̍XV
    // Get a handle of overlay window
    enc_return = ENC_Get_Overlay_Window(ENC_ID, &hWndOverlay);

    if(hWndOverlay != NULL)
    {
        enc_return = ENC_Show_Overlay_Window(ENC_ID, nState & MF_CHECKED ? FALSE : TRUE);

        if(enc_return == ENC_SUCCESS)
            pPopup->CheckMenuItem(IDM_SET_OVERLAY, MF_BYCOMMAND | (nState & MF_CHECKED ? MF_UNCHECKED : MF_CHECKED));
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncAudio ]                                    
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncAudio ]                                    
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncAudio(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncVideo ]                                    
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncVideo ]                                    
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncVideo(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncAv ]                                       
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncAv ]                                       
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncAv(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncProgram ]                                  
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncProgram ]                                  
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncProgram(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncStop ]                                           
//                                                                      
// @\     GR[h𒆎~                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncStop ]                                           
//                                                                      
//  Function:   Stop the encode                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncStop() 
{
    ENC_RETURN  enc_return;
    CString     strMessage;

    enc_return = ENC_Stop(ENC_ID);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_STOP_CAPTURE);
        MessageBox(strMessage);
        return;
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncStop ]                                     
//                                                                      
// @\     GR[hȊO͑IłȂ悤ɂ                    
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncStop ]                                     
//                                                                      
//  Function:   If encoder is working, user can select the item.        
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncStop(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_MOVIE ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateAppExit ]                                     
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateAppExit ]                                     
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateAppExit(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetAudioParam ]                               
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetAudioParam ]                               
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetAudioParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetAudioEncParam ]                            
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetAudioEncParam ]                            
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetAudioEncParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoParam ]                               
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoParam ]                               
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoEncParam ]                            
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoEncParam ]                            
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoEncParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetTime ]                                     
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetTime ]                                     
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetTime(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetOverlay ]                                  
//                                                                      
// @\     I[o[C\̐؂ւ̗LEݒ肷            
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetOverlay ]                                  
//                                                                      
//  Function:   Check the item                                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetOverlay(CCmdUI* pCmdUI) 
{
    // I[o[CEBhE݂Ȃꍇ͖
    // If overlay window isn't found, the item disables.
    if(hWndOverlay == NULL)
        pCmdUI->Enable(FALSE);
    else
        pCmdUI->Enable(TRUE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetMonitor ]                                        
//                                                                      
// @\     j^[̐؂ւ                                          
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetMonitor ]                                        
//                                                                      
//  Function:   Change a monitor status                                 
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetMonitor() 
{
    ENC_RETURN  enc_return;
    CString     strMessage;
    CMenu*      pMenu;
    CMenu*      pPopup;
    UINT        nState;
    RECT        rc;

    pMenu = GetMenu();
    pPopup = pMenu->GetSubMenu(1);
    nState = pPopup->GetMenuState(IDM_SET_MONITOR, MF_BYCOMMAND);

    if(nState == MF_CHECKED)
    {
        enc_return = ENC_Stop_Monitor(ENC_ID);
        
        // EBhEnh̍XV
        // Get a handle of overlay window
        enc_return = ENC_Get_Overlay_Window(ENC_ID, &hWndOverlay);
    }
    else
    {
        enc_return = ENC_Start_Monitor(ENC_ID);

        // EBhEnh̍XV
        // Get a handle of overlay window
        enc_return = ENC_Get_Overlay_Window(ENC_ID, &hWndOverlay);

        GetClientRect(&rc);
        ENC_Resize_Overlay_Window(ENC_ID, rc.right, rc.bottom);
    }
    
    // j[Ƀ`FbNt
    // Check menu item
    if(enc_return == ENC_SUCCESS)
        pPopup->CheckMenuItem(IDM_SET_MONITOR, MF_BYCOMMAND | (nState & MF_CHECKED ? MF_UNCHECKED : MF_CHECKED));
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetMonitor ]                                  
//                                                                      
// @\     j[̃j^[̃`FbNXV                      
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetMonitor ]                                  
//                                                                      
//  Function:   Check the item                                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetMonitor(CCmdUI* pCmdUI) 
{
    ENC_RETURN  enc_return;
    UINT        monitor;

    enc_return = ENC_Get_Monitor_Status(ENC_ID, &monitor);

    if(enc_return == ENC_SUCCESS)
    {
        if(monitor)
            pCmdUI->SetCheck(1);
        else
            pCmdUI->SetCheck(0);
    }
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::AutoDetect ]                                          
//                                                                      
// @\     ̓\[X̎o                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::AutoDetect ]                                          
//                                                                      
//  Function:   Detect input source                                     
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::AutoDetect()
{
    ENC_RETURN  enc_return;
    ENC_VIDEO_PARAMETER enc_video_param;
    int         nInputSource;
    CString     strMessage;
    UINT        fMonitor;

    // j^[̏Ԃ̎擾
    // Get monitor state
    enc_return = ENC_Get_Monitor_Status(ENC_ID, &fMonitor);
    if(enc_return == ENC_SUCCESS)
    {
        if(fMonitor)
        {
            // j^[o͂~߂
            // Stop output monitor
            ENC_Stop_Monitor(ENC_ID);
        }
    }

    // ݂̐ݒl擾
    // Get video parameter
    enc_return = ENC_Get_Video_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    enc_return = ENC_Detect_Video_Input_Source(ENC_ID, &nInputSource);
    if(enc_return == ENC_SUCCESS)
    {
        // ̓\[Xݒ肷
        // Set input source
        enc_video_param.fInputSource = nInputSource;
    }

    // Vlݒ肷
    // Set video parameters
    enc_return = ENC_Set_Video_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_SET_PARAMETER);
        MessageBox(strMessage);
    }

    if(fMonitor)
    {
        // j^[o͂Jn
        // Start output monitor
        enc_return = ENC_Start_Monitor(ENC_ID);
        if(enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_START_MONITOR);
            MessageBox(strMessage);
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoCd ]                                        
//                                                                      
// @\     Video CD[h ɐݒ肷                                   
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoCd ]                                        
//                                                                      
//  Function:   Set Video CD mode                                       
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoCd() 
{
    ENC_AUDIO_PARAMETER enc_audio_param;
    ENC_RETURN          enc_return;
    int                 bEnable;
    UINT                bMonitorStatus;
	RECT				rc;

    enc_return = ENC_Get_VideoCD_Mode(ENC_ID, &bEnable);

    if(enc_return == ENC_SUCCESS)
    {
       enc_return = ENC_Get_Audio_Parameter(ENC_ID, &enc_audio_param);
       if(enc_return == ENC_SUCCESS)
       {
           enc_return = ENC_Get_Monitor_Status(ENC_ID,&bMonitorStatus);
           if(enc_return == ENC_SUCCESS)
           {
            // j^[~
            // Stop output monitor
               if(bMonitorStatus)
                 ENC_Stop_Monitor(ENC_ID);
               bEnable = !bEnable;
               ENC_Set_VideoCD_Mode(ENC_ID, bEnable);
           // I[fBIp[^ݒ肷
           // Set audio parameters
               enc_audio_param.dwSamplingFrequency = 44100;
               enc_return = ENC_Set_Audio_Parameter(ENC_ID, &enc_audio_param);
               if(bMonitorStatus)
                  ENC_Start_Monitor(ENC_ID);

				GetClientRect(&rc);
				ENC_Resize_Overlay_Window(ENC_ID, rc.right, rc.bottom);
           }
       }
    }
}


//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoCd ]                                  
//                                                                      
// @\     j[Video CD`̃`FbNXV                  
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoCd ]                                  
//                                                                      
//  Function:   Check the item                                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoCd(CCmdUI* pCmdUI) 
{
    ENC_RETURN  enc_return;
    int         bEnable;

    enc_return = ENC_Get_VideoCD_Mode(ENC_ID, &bEnable);

    if(enc_return == ENC_SUCCESS)
    {
        if(bEnable)
            pCmdUI->SetCheck(1);
        else
            pCmdUI->SetCheck(0);
    }
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMpeg ]                                
//                                                                      
// @\     j[̃I[fBItH[}bg MPEG                     
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMpeg ]                                
//                                                                      
//  Function:   Select audio format...MPEG                              
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudioFormatMpeg() 
{
    ENC_RETURN          enc_return;
    ENC_AUDIO_FORMAT    enc_audio_format;

    enc_return = ENC_Get_Audio_Format(ENC_ID, &enc_audio_format);

    if(enc_return == ENC_SUCCESS)
    {
        enc_audio_format = ENC_AUDIO_FORMAT_MPEG;
        ENC_Set_Audio_Format(ENC_ID, enc_audio_format);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMono ]                                
//                                                                      
// @\     j[̃I[fBItH[}bg PCM Mono                 
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMono ]                                
//                                                                      
//  Function:   Select audio format...PCM Mono                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudioFormatMono() 
{
    ENC_RETURN          enc_return;
    ENC_AUDIO_FORMAT    enc_audio_format;

    enc_return = ENC_Get_Audio_Format(ENC_ID, &enc_audio_format);

    if(enc_return == ENC_SUCCESS)
    {
        enc_audio_format = ENC_AUDIO_FORMAT_PCM_MONO;
        ENC_Set_Audio_Format(ENC_ID, enc_audio_format);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatStereo ]                                
//                                                                      
// @\     j[̃I[fBItH[}bg PCM Stereo               
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatStereo ]                                
//                                                                      
//  Function:   Select audio format...PCM Mono                          
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudioFormatStereo() 
{
    ENC_RETURN          enc_return;
    ENC_AUDIO_FORMAT    enc_audio_format;

    enc_return = ENC_Get_Audio_Format(ENC_ID, &enc_audio_format);

    if(enc_return == ENC_SUCCESS)
    {
        enc_audio_format = ENC_AUDIO_FORMAT_PCM_STEREO;
        ENC_Set_Audio_Format(ENC_ID, enc_audio_format);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMpeg ]                                
//                                                                      
// @\     j[̃I[fBItH[}bg MPEG `FbN      
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMpeg ]                                
//                                                                      
//  Function:   Check menu -[Audio format]-[MPEG]                       
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetAudioFormatMpeg(CCmdUI* pCmdUI) 
{
    ENC_RETURN          enc_return;
    ENC_AUDIO_FORMAT    enc_audio_format;

    enc_return = ENC_Get_Audio_Format(ENC_ID, &enc_audio_format);
    
    if(enc_return == ENC_SUCCESS)
    {
        if(enc_audio_format == ENC_AUDIO_FORMAT_MPEG)
            pCmdUI->SetCheck(1);
        else
            pCmdUI->SetCheck(0);
    }
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMono ]                                
//                                                                      
// @\     j[̃I[fBItH[}bg PCM Mono `FbN  
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatMono ]                                
//                                                                      
//  Function:   Check menu -[Audio format]-[PCM Mono]                   
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetAudioFormatMono(CCmdUI* pCmdUI) 
{
    ENC_RETURN          enc_return;
    ENC_AUDIO_FORMAT    enc_audio_format;

    enc_return = ENC_Get_Audio_Format(ENC_ID, &enc_audio_format);
    if(enc_return == ENC_SUCCESS)
    {
        if(enc_audio_format == ENC_AUDIO_FORMAT_PCM_MONO)
            pCmdUI->SetCheck(1);
        else
            pCmdUI->SetCheck(0);
    }
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatStereo ]                                
//                                                                      
// @\     j[̃I[fBItH[}bg PCM Stereo `FbN
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioFormatStereo ]                                
//                                                                      
//  Function:   Check menu -[Audio format]-[PCM Stereo]                 
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetAudioFormatStereo(CCmdUI* pCmdUI) 
{
    ENC_RETURN          enc_return;
    ENC_AUDIO_FORMAT    enc_audio_format;

    enc_return = ENC_Get_Audio_Format(ENC_ID, &enc_audio_format);
    if(enc_return == ENC_SUCCESS)
    {
        if(enc_audio_format == ENC_AUDIO_FORMAT_PCM_STEREO)
            pCmdUI->SetCheck(1);
        else
            pCmdUI->SetCheck(0);
    }
    else
        pCmdUI->Enable(FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoEncParamEx ]                                
//                                                                      
// @\     grfIGR[hp[^ݒ_CAOĂяo        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoEncParamEx ]                                
//                                                                      
//  Function:   Set video encode parameter ex                           
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoEncParamEx() 
{
    CVideoEncExDlg  dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoEncParamEx ]                          
//                                                                      
// @\     ~̂݊grfIGR[h_CAOĂԂ悤ɂ    
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoEncParamEx ]                          
//                                                                      
//  Function:   Select the item only encoder is stopped                 
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoEncParamEx(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
// @\     R[obN֐                                            
//                                                                      
//  F      UINT                enc_id                              
//              ENC_STATUS_NOTIFY   enc_state                           
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
//  Function:   Callback function                                       
//                                                                      
//      Paraneters:     UINT                enc_id                      
//                      ENC_STATUS_NOTIFY   enc_state                   
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK StatusProc(UINT enc_id, ENC_STATUS_NOTIFY enc_state)
{
    UINT        count;
    double      time;
    char        szText[MAX_PATH];

    if(enc_state == ENC_NOTIFY_STOP)
    {
        ENC_Get_Frame_Count(enc_id, &count);
        ENC_Get_Time(enc_id, &time);
        sprintf(szText,"Encode Frame : %ld\nEncode Time   : %.2f[sec]", count, time);

        MessageBox(AfxGetMainWnd()->GetSafeHwnd(), szText, "Encode", MB_OK);
    }
}

//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
// @\     R[obN֐iG[j                                  
//                                                                      
//  F      UINT        enc_id                                      
//              ULONG       error                                       
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
//  Function:   Callback function (error)                               
//                                                                      
//      Parameters:     UINT        enc_id                              
//                      ULONG       error                               
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK ErrorProc(UINT enc_id, ULONG error)
{
    CString strText;
    switch (error)
    {
    case MVR_ERROR_SUCCESS:
        strText = "MVR_ERROR_SUCCESS";
        break;
    case MVR_ERROR_PENDING:
        strText = "MVR_ERROR_PENDING";
        break;
    case MVR_ERROR_SYSTEM_ERROR:
        strText = "MVR_ERROR_SYSTEM_ERROR";
         break;
    case MVR_ERROR_NOT_PENDING:
        strText = "MVR_ERROR_NOT_PENDING";
        break;
    case MVR_ERROR_INVALID_ASYNCOP:
        strText = "MVR_ERROR_INVALID_ASYNCOP";
        break;
    case MVR_ERROR_UNSUPPORTED:
        strText = "MVR_ERROR_UNSUPPORTED";
        break;
    case MVR_ERROR_INVALID_TYPE:
        strText = "MVR_ERROR_INVALID_TYPE";
        break;
    case MVR_ERROR_INVALID_OPTION:
        strText = "MVR_ERROR_INVALID_OPTION";
        break;
    case MVR_ERROR_INVALID_ADDRESS:
        strText = "MVR_ERROR_INVALID_ADDRESS";
        break;
    case MVR_ERROR_LIMIT_EXCEEDED:
        strText = "MVR_ERROR_LIMIT_EXCEEDED";
        break;
    case MVR_ERROR_INVALID_HANDLE:
        strText = "MVR_ERROR_INVALID_HANDLE";
        break;
    case MVR_ERROR_INVALID_STREAM:
        strText = "MVR_ERROR_INVALID_STREAM";
        break;
    case MVR_ERROR_INVALID_BUFFER:
        strText = "MVR_ERROR_INVALID_BUFFER";
        break;
    case MVR_ERROR_INVALID_MESSAGE:
        strText = "MVR_ERROR_INVALID_MESSAGE";
        break;
    case MVR_ERROR_CANCELED:
        strText = "MVR_ERROR_CANCELED";
        break;
    case MVR_ERROR_BUSY:
        strText = "MVR_ERROR_BUSY";
        break;
    case MVR_ERROR_BUFFER_ERROR:
        strText = "MVR_ERROR_BUFFER_ERROR";
        break;
    case MVR_ERROR_MESSAGE_ERROR:
        strText = "MVR_ERROR_MESSAGE_ERROR";
        break;
    case MVR_ERROR_BAD_PARAM:
        strText = "MVR_ERROR_BAD_PARAM";
        break;
    case MVR_ERROR_HARDWARE_ERROR:
        strText = "MVR_ERROR_HARDWARE_ERROR";
        break;
    case MVR_ERROR_ALLOC_FAILURE:
        strText = "MVR_ERROR_ALLOC_FAILURE";
        break;
    case MVR_ERROR_INVALID_EVENT:
        strText = "MVR_ERROR_INVALID_EVENT";
        break;
    case MVR_ERROR_INVALID_STATE:
        strText = "MVR_ERROR_INVALID_STATE";
        break;
    case MVR_ERROR_CURRENT_STATE:
        strText = "MVR_ERROR_CURRENT_STATE";
        break;
    case MVR_ERROR_INVALID_FRAME_TYPE:
        strText = "MVR_ERROR_INVALID_FRAME_TYPE";
        break;
    case MVR_ERROR_INSUFFICIENT_BUFFERS:
        strText = "MVR_ERROR_INSUFFICIENT_BUFFERS";
        break;
    case MVR_ERROR_TIMEOUT:
        strText = "MVR_ERROR_TIMEOUT";
        break;
    case MVR_ERROR_INVALID_CODEC_STATE:
        strText = "MVR_ERROR_INVALID_CODEC_STATE";
        break;
    case MVR_ERROR_INVALID_FORMAT:
        strText = "MVR_ERROR_INVALID_FORMAT";
        break;
    case MVR_ERROR_INVALID_OPERATION:
        strText = "MVR_ERROR_INVALID_OPERATION";
        break;
    case MVR_ERROR_OVERFLOW:
        strText = "MVR_ERROR_OVERFLOW";
        break;
    case MVR_ERROR_UNDERFLOW:
        strText = "MVR_ERROR_UNDERFLOW";
        break;
    case MVR_ERROR_SESSION_CANCELED:
        strText = "MVR_ERROR_SESSION_CANCELED";
        break;
    case MVR_ERROR_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_AUDIO_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_AUDIO_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_PARSE_ERROR:
        strText = "MVR_ERROR_PARSE_ERROR";
        break;
    case MVR_ERROR_END_OF_STREAM:
        strText = "MVR_ERROR_END_OF_STREAM";
        break;
    case MVR_ERROR_DISK_FULL:
        strText = "MVR_ERROR_DISK_FULL";
        break;
    case MVR_ERROR_STREAMS_CLOSED:
        strText = "MVR_ERROR_STREAMS_CLOSED";
        break;
    case MVR_ERROR_INTERNAL_ERROR:
        strText = "MVR_ERROR_INTERNAL_ERROR";
        break;
    case MVR_ERROR_INVALID_SHORT_BUFFER:
        strText = "MVR_ERROR_INVALID_SHORT_BUFFER";
        break;
    case MVR_ERROR_EVENT_DATA_OVERRUN:
        strText = "MVR_ERROR_EVENT_DATA_OVERRUN";
        break;
    case MVR_ERROR_EVENT_DATA_UNDERRUN:
        strText = "MVR_ERROR_EVENT_DATA_UNDERRUN";
        break;
    case MVR_ERROR_EVENT_DEVICE_ERROR:
        strText = "MVR_ERROR_EVENT_DEVICE_ERROR";
        break;
    case MVR_ERROR_EVENT_LOSS_OF_VIDEO:
        strText = "MVR_ERROR_EVENT_LOSS_OF_VIDEO";
        break;
    case MVR_ERROR_EVENT_EVENT_LOSS:
        strText = "MVR_ERROR_EVENT_EVENT_LOSS";
        break;
    case MVR_ERROR_EVENT_UNRECOVERABLE_ERROR:
        strText = "MVR_ERROR_EVENT_UNRECOVERABLE_ERROR";
        break;
    default:
        strText = "????";
        break;
    }
    AfxMessageBox(strText);
}

//----------------------------------------------------------------------
// #[ TmapProc ]                                                        
//                                                                      
// @\     R[obN֐                                            
//                                                                      
//  F      UINT        enc_id                                      
//              ENC_VOBU_ENT_INFO   *tmap                                       
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ TmapProc ]                                                        
//                                                                      
//  Function:   Callback function                                       
//                                                                      
//      Parameters:     UINT        enc_id                              
//                      ENC_VOBU_ENT_INFO   *tmap                               
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK TmapProc(UINT enc_id, ENC_VOBU_ENT_INFO *tmap, UINT)
{
    TRACE1("TmapProc (ID = %d)\n", enc_id);
    char    szText[256];
    wsprintf(szText, "VOBU size = %d, 1st reference picture = %d, playback = %d", 
                tmap->Vobu_Sz, tmap->Fstref_Sz, tmap->Vobu_Pb_Tm);
    ::SetWindowText(pMain->m_hWnd, szText);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlayAdjust ]                                  
//                                                                      
// @\     I[o[C̉掿𒲐                                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlayAdjust ]                                  
//                                                                      
//  Function:   Set Adjust (Overlay Window)                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetOverlayAdjust() 
{
    COverlayDlg dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetGetLastError ]                                   
//                                                                      
// @\     G[擾                                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetGetLastError ]                                   
//                                                                      
//  Function:   Get Last Error                                          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetGetLastError() 
{
    ULONG   Err;
    char    szText[256];

    Err = ENC_Get_Last_Error(ENC_ID);
    
    if(Err == MVR_ERROR_SUCCESS)
        return;

    wsprintf(szText, "Error = %d\n", Err);
    MessageBox(szText);
}   

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetEncodeFile ]                                     
//                                                                      
// @\     ڍ׃GR[hp[^̐ݒ                              
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetEncodeFile ]                                     
//                                                                      
//  Function:   Set encode parameter.                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetEncodeFile() 
{
    CString strMessage;
    CString strFile;
    char    szFile[MAX_PATH];

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(TRUE, NULL, NULL,
                    OFN_HIDEREADONLY |
                    OFN_FILEMUSTEXIST |
                    OFN_PATHMUSTEXIST,
                    NULL, this);

    if(dlg.DoModal() == IDOK)
    {
        strFile = dlg.GetPathName();
        lstrcpy(szFile, strFile);

        if(ENC_Set_Video_Encode_File(ENC_ID, szFile) == ENC_FAIL)
        {
            strMessage.LoadString(IDS_ERROR_OPEN_FILE);
            MessageBox(strMessage);
        }
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlayRect ]                                    
//                                                                      
// @\     I[o[C̕\̈ݒ肷                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetOverlayRect ]                                    
//                                                                      
//  Function:   Set overlay rect                                        
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetOverlayRect() 
{
    COverlayRectDlg dlg;
    RECT            rc;

    if(ENC_Get_Overlay_Rect(ENC_ID, &rc) == ENC_FAIL)
        return;
    
    dlg.m_edit_top  = rc.top;
    dlg.m_edit_left = rc.left;
    dlg.m_edit_bottom   = rc.bottom;
    dlg.m_edit_right    = rc.right;

    if(dlg.DoModal() == IDOK)
    {
        rc.top      = dlg.m_edit_top;
        rc.left     = dlg.m_edit_left;
        rc.bottom   = dlg.m_edit_bottom;
        rc.right    = dlg.m_edit_right;
        
        ENC_Set_Overlay_Rect(ENC_ID, &rc);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetOverlayRect ]                              
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetOverlayRect ]                              
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetOverlayRect(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnGetStillImage ]                                    
//                                                                      
// @\     Î~Lv`܂B                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnGetStillImage ]                                 
//                                                                      
//  Function:   Capture still image.                                  
//                                                                      
//  Parameters:     none                                            
//                                                                      
//  Return value:   none                                      
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnGetStillImage() 
{
    CString strMessage;
    CString strFileName;
	CString strFilter;
	
	strFilter.LoadString(ID_STILLIMAGE_FILTER);

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, _T("bmp"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strFilter);

    if (dlg.DoModal() == IDOK) 
	{
        strFileName = dlg.GetPathName();
		if (strFileName.IsEmpty()) 
		{
			return;
		}

		MVRSTILLCAPPARAM Param;

		ZeroMemory( &Param, sizeof(MVRSTILLCAPPARAM));

		// TCYwiK{j
		// define the size (mandate)
		Param.dwSize = sizeof(MVRSTILLCAPPARAM);		
		Param.nFrameCap = m_nStillCapture;
		// YUV - RGB ϊ[16-235] ͈̔  [0-255] ͈̔͂ɍL܂
		// expand the range [16-235] to [0-255]
		Param.fExpandRGB = TRUE;
		// K}␳l  : NTSC : 2.2 PAL : 2.8
		// gamma value : default value is 2.2(NTSC) 2.8(PAL) 
		Param.dCorrectGamma = 2.2;
		// ϊ̊֐o^BNULLłȂꍇ͕Kgp܂B
		// register the function to convert (it is used when the value is not NULL)
//		Param.pfnuyvy2rgb = ConvertYUVtoRGB;
		Param.pfnuyvy2rgb = NULL;

		if (dlg.GetFileExt() == "bmp") 
		{
			LPBYTE lpByte;
			DWORD dwLen;

			if ( ENC_Get_BitmapBits( ENC_ID, &lpByte, &dwLen, &Param) != ENC_FAIL) 
			{
				if (SaveBuffToFile( lpByte, dwLen, strFileName) != FALSE) 
				{
					return;
				}
			}

//			if ( ENC_Save_DIB( ENC_ID, strFileName, &Param) != ENC_FAIL) 
//			{
//				return;
//			}

		}
		else {
			if ( ENC_Save_JPEG( ENC_ID, strFileName, m_nJpegQuality, &Param) != ENC_FAIL) 
			{
				return;
			}
		}

		strMessage.LoadString(IDS_ERROR_STILL_CAPTURE);
		MessageBox(strMessage);
	}	
}

//----------------------------------------------------------------------
// #[ CMainFrame::SaveBuffToFile ]                                    
//                                                                      
// @\     obt@̃f[^t@Cɏ܂B                            
//                                                                      
//  F      LPBYTE lpByte			: ރobt@
//				DWORD dwLen				: obt@̒
//				CString strFileName		: ۑt@C                                  
//                                                                      
//  ߂lF     TRUE                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::SaveBuffToFile ]                                 
//                                                                      
//  Function:   write the data in buffer to a file                                  
//                                                                      
//  Parameters:     LPBYTE lpByte			: buffer to write
//					DWORD dwLen				: length of the buffer
//					CString strFileName		: file name to save                                   
//                                                                      
//  Return value:   BOOL	: TRUE when succeed                                      
//                                                                      
//----------------------------------------------------------------------
BOOL CMainFrame::SaveBuffToFile(LPBYTE lpByte, DWORD dwLen, CString strFileName)
{
	DWORD dwWritten;
	HANDLE hFile;

	hFile = CreateFile( strFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	if ( hFile == INVALID_HANDLE_VALUE) 
	{
		return FALSE;
	}

	WriteFile( hFile, lpByte, dwLen, &dwWritten, NULL);

	CloseHandle(hFile);
	
	return TRUE;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetStillcaptureParam ]                                         
//                                                                      
// @\     Î~Lv`̃p[^ݒ肷B                                             
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetStillcaptureParam ]                                         
//                                                                      
//  Function:   Parameter setup for still image capture                                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetStillcaptureParam() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	// TODO: Add your command handler code here
	CStillCapParam dlg;

	dlg.m_nJpegQuality = m_nJpegQuality;
	dlg.m_nStillCapture = m_nStillCapture;

	if ( dlg.DoModal() == IDOK) {
		m_nJpegQuality = dlg.m_nJpegQuality;
		m_nStillCapture = dlg.m_nStillCapture;
	}	
}

//----------------------------------------------------------------------
// #[ ConvertYUVtoRGB ]                                         
//                                                                      
// @\      UYVY  RGB  Ro[g邽߂̃Tv֐       
//                                                                      
//  F      BYTE u1					: U
//				BYTE y1					: 1oCgڗp Y 
//				BYTE v1					: V
//				BYTE y2					: 2oCgڗp Y
//				COLORREF *pColor1		: ϊ RGB 1oCg
//				COLORREF *pColor2		: ϊ RGB 2oCg               
//                                                                      
//  ߂lF    KPԂ                   
//                                                                      
//----------------------------------------------------------------------
// #[ ConvertYUVtoRGB ]                                         
//                                                                      
//  Function:  sample code of a function to convert UYVY to RGB                                          
//                                                                      
//  Parameters:     BYTE u1				: U 
//					BYTE y1				: Y for the first byte
//					BYTE v1				: V
//					BYTE y2				: Y for the second byte
//					COLORREF *pColor1	: first byte of converted RGB
//					COLORREF *pColor2	: second byte of converted RGB                                        
//                                                                      
//  Return value:   int			1 must be returned                                        
//                                                                      
//----------------------------------------------------------------------
int ConvertYUVtoRGB( BYTE u1, BYTE y1, BYTE v1, BYTE y2, COLORREF *pColor1, COLORREF *pColor2)
{
	int r[2], g[2], b[2];
	int y[2];

	y[0] = y1;
	y[1] = y2;

	for ( int i = 0; i < 2; i++ ) 
	{
		r[i]	= (int)( y[i] + 1.402 * ( v1 - 128 ) );
		g[i]	= (int)( y[i] - 0.344 * ( u1 - 128 ) - 0.714 * ( v1 - 128 ) );
		b[i]	= (int)( y[i] + 1.772 * ( u1 - 128 ) );

	// [ 235-16 ]   ͈̔͂  [ 0-255 ] ͈̔͂ɕϊ
	// expand the range [16-235] to [0-255]

		r[i] = (int)((r[i] - 16) * 256.0 / 220.0);
		g[i] = (int)((g[i] - 16) * 256.0 / 220.0);
		b[i] = (int)((b[i] - 16) * 256.0 / 220.0);

		if		(r[i] < 0 )	r[i] = 0;
		else if	(r[i] > 255 )	r[i] = 255;

		if		(g[i] < 0 )	g[i] = 0;
		else if	(g[i] > 255 )	g[i] = 255;

		if		(b[i] < 0 )	b[i] = 0;
		else if (b[i] > 255 )	b[i] = 255;

	}

	*pColor1	= RGB(r[0], g[0], b[0]);
	*pColor2	= RGB(r[1], g[1], b[1]);

	return 1;
}
