//======================================================================
// -- OverlayDlg.cpp --                                                 
//                                                                      
//  MVR-D2000                                                           
//                                  GR[h  TvvO      
//                                  Encode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// OverlayDlg.cpp : Cve[V t@C
// OverlayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Encode.h"
#include "OverlayDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	ENC_ID;

/////////////////////////////////////////////////////////////////////////////
// COverlayDlg _CAO
// COverlayDlg Dialog

COverlayDlg::COverlayDlg(CWnd* pParent /*=NULL*/)
    : CDialog(COverlayDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(COverlayDlg)
        //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		// NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void COverlayDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(COverlayDlg)
    DDX_Control(pDX, IDC_EDIT_SATURATION, m_Edit_Saturation);
    DDX_Control(pDX, IDC_EDIT_CONTRAST, m_Edit_Contrast);
    DDX_Control(pDX, IDC_EDIT_BRIGHT, m_Edit_Bright);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COverlayDlg, CDialog)
    //{{AFX_MSG_MAP(COverlayDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COverlayDlg bZ[W nh
// COverlayDlg message handlers

//----------------------------------------------------------------------
// #[ COverlayDlg::OnInitDialog ]                                       
//                                                                      
// @\     I[o[C̉掿                                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ COverlayDlg::OnInitDialog ]                                       
//                                                                      
//  Function:   Initialize adjust dialog                                
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL COverlayDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();
    
    ENC_OVERLAY_PARAMETER   enc_overlay_param;
    ENC_RETURN      enc_return;     
    char    szText[16];

    enc_return = ENC_Get_Overlay_Parameter(ENC_ID, &enc_overlay_param);

    if(enc_return == DEC_SUCCESS)
    {
        wsprintf(szText, "%ld", enc_overlay_param.nOverlayBrightness);
        m_Edit_Bright.SetWindowText(szText);
        wsprintf(szText, "%ld", enc_overlay_param.nOverlayContrast);
        m_Edit_Contrast.SetWindowText(szText);
        wsprintf(szText, "%ld", enc_overlay_param.nOverlaySaturation);
        m_Edit_Saturation.SetWindowText(szText);
    }
    
    return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ COverlayDlg::OnOK ]                                               
//                                                                      
// @\     掿̐ݒLɂ                                  
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ COverlayDlg::OnOK ]                                               
//                                                                      
//  Function:   Set adjust parameters                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void COverlayDlg::OnOK() 
{
    ENC_OVERLAY_PARAMETER   enc_overlay_param;
    ENC_RETURN      enc_return;     
    char    szText[16];

    enc_return = ENC_Get_Overlay_Parameter(ENC_ID, &enc_overlay_param);

    if(enc_return == DEC_SUCCESS)
    {
        m_Edit_Bright.GetWindowText(szText, sizeof(szText));
        enc_overlay_param.nOverlayBrightness = atol(szText);
        m_Edit_Contrast.GetWindowText(szText, sizeof(szText));
        enc_overlay_param.nOverlayContrast = atol(szText);
        m_Edit_Saturation.GetWindowText(szText, sizeof(szText));
        enc_overlay_param.nOverlaySaturation = atol(szText);

        ENC_Set_Overlay_Parameter(ENC_ID, &enc_overlay_param);
    }
    
    CDialog::OnOK();
}
