//======================================================================
// -- VideoDlg.cpp --                                                   
//                                                                      
//  MVR-D2000                                                           
//                                  GR[h  TvvO      
//                                  Encode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// VideoDlg.cpp : Cve[V t@C
// VideoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Encode.h"
#include "VideoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	ENC_ID;

/////////////////////////////////////////////////////////////////////////////
// CVideoDlg _CAO
// CVideoDlg Dialog


CVideoDlg::CVideoDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CVideoDlg::IDD, pParent)
{
	m_nBoardConf = 0;
	m_nIreSetting = MVR_IRE_LEVEL_0_NTSC;
    //{{AFX_DATA_INIT(CVideoDlg)
    //}}AFX_DATA_INIT
}


void CVideoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CVideoDlg)
    DDX_Control(pDX, IDC_EDIT_CONTRAST, m_Edit_Contrast);
    DDX_Control(pDX, IDC_EDIT_SATURATION, m_Edit_Saturation);
    DDX_Control(pDX, IDC_EDIT_HUE, m_Edit_Hue);
    DDX_Control(pDX, IDC_EDIT_BRIGHTNESS, m_Edit_Brightness);
    DDX_Control(pDX, IDC_CHECK_MONITOR, m_Check_Monitor);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVideoDlg, CDialog)
    //{{AFX_MSG_MAP(CVideoDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoDlg bZ[W nh
// CVideoDlg message handlers

//----------------------------------------------------------------------
// #[ CVideoDlg::OnInitDialog ]                                         
//                                                                      
// @\     rfIp[^̐ݒ                                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CVideoDlg::OnInitDialog ]                                         
//                                                                      
//  Function:   Initialize video dialog                                 
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CVideoDlg::OnInitDialog() 
{
    ENC_VIDEO_PARAMETER2 enc_video_param;
    ENC_RETURN      enc_return;
    CString     strMessage;
    char    szText[32];

    CDialog::OnInitDialog();

    // rfIp[^̎擾
    // Get video parameters
	enc_video_param.dwSize = sizeof(ENC_VIDEO_PARAMETER2);
    enc_return = ENC_Get_Video_Parameter2(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return FALSE;
    }

    // ̓\[X̐ݒ
    // Set input source
    switch(enc_video_param.EncVideoParam.fInputSource)
    {
    case ENC_VIDEO_INPUT_SOURCE_COMPOSITE:
        CheckRadioButton(IDC_RADIO_COMPOSITE, IDC_RADIO_SVIDEO, IDC_RADIO_COMPOSITE);
        break;
    default:
        CheckRadioButton(IDC_RADIO_COMPOSITE, IDC_RADIO_SVIDEO, IDC_RADIO_SVIDEO);
        break;
    }

    // Ki̐ݒ
    // Set Color System
    switch(enc_video_param.EncVideoParam.TV_System)
    {
    case ENC_VIDEO_TV_SYSTEM_NTSC:
        CheckRadioButton(IDC_RADIO_NTSC, IDC_RADIO_PAL, IDC_RADIO_NTSC);
        break;
    default:
        CheckRadioButton(IDC_RADIO_NTSC, IDC_RADIO_PAL, IDC_RADIO_PAL);
        break;
    }

    // j^[o͂̐ݒ
    // Set output monitor
    m_Check_Monitor.SetCheck(enc_video_param.EncVideoParam.fOutputMonitor ? TRUE : FALSE);

    wsprintf(szText, "%ld", enc_video_param.EncVideoParam.nInputBrightness);
    m_Edit_Brightness.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncVideoParam.nInputContrast);
    m_Edit_Contrast.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncVideoParam.nInputHue);
    m_Edit_Hue.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncVideoParam.nInputSaturation);
    m_Edit_Saturation.SetWindowText(szText);

	// MVR-D2000 ?
	if ( m_nBoardConf == 0 )
	{
		CheckRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S, IDC_RADIO_VP_NONE);
//		GetDlgItem(IDC_STATIC_VP)->EnableWindow(FALSE);
//		GetDlgItem(IDC_RADIO_VP_NONE)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_VP_3DYC)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_VP_NR_W)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_VP_NR_S)->EnableWindow(FALSE);
	}
	else		// D2200 or D2200V
	{
		switch(enc_video_param.nVideoProcessing) 
		{
		case ENC_VIDEO_PROCESSING_3DYC:		// 3DYC
	        CheckRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S, IDC_RADIO_VP_3DYC);
			break;
		case ENC_VIDEO_PROCESSING_NONE:		// NONE
	        CheckRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S, IDC_RADIO_VP_NONE);
			break;
		case ENC_VIDEO_PROCESSING_NR_W:		// NR WEAKE
	        CheckRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S, IDC_RADIO_VP_NR_W);
			break;
		case ENC_VIDEO_PROCESSING_NR_S:		// NR STRONG
	        CheckRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S, IDC_RADIO_VP_NR_S);
			break;
		default:
	        CheckRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S, IDC_RADIO_VP_NONE);
			break;
		}
	}

    ENC_Get_IRE_Setting( ENC_ID, &m_nIreSetting);

	switch ( m_nIreSetting ) {
	case MVR_IRE_LEVEL_75_NTSC:
		CheckRadioButton(IDC_RADIO_0IRE, IDC_RADIO_75IRE, IDC_RADIO_75IRE);
		break;
	case MVR_IRE_LEVEL_0_NTSC:
	default:
		CheckRadioButton(IDC_RADIO_0IRE, IDC_RADIO_75IRE, IDC_RADIO_0IRE);
		break;
	}

    return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ CVideoDlg::OnOK ]                                                 
//                                                                      
// @\     rfIp[^̐ݒLɂ                          
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CVideoDlg::OnOK ]                                                 
//                                                                      
//  Function:   Set video parameters                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CVideoDlg::OnOK() 
{
    ENC_VIDEO_PARAMETER2 enc_video_param;
    ENC_RETURN      enc_return;
    CString     strMessage;
    char    szText[32];
    int     nID;
    UINT    fMonitor;

    // ݂̐ݒl擾
    // Get video parameter
	enc_video_param.dwSize = sizeof(ENC_VIDEO_PARAMETER2);
    enc_return = ENC_Get_Video_Parameter2(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    // ̓\[X̐ݒ
    // Check input source
    nID = GetCheckedRadioButton(IDC_RADIO_COMPOSITE, IDC_RADIO_SVIDEO);
    if(nID == IDC_RADIO_COMPOSITE)
        enc_video_param.EncVideoParam.fInputSource = ENC_VIDEO_INPUT_SOURCE_COMPOSITE;
    else
        enc_video_param.EncVideoParam.fInputSource = ENC_VIDEO_INPUT_SOURCE_SVIDEO;

    // Ki̐ݒ
    // Check color system
    nID = GetCheckedRadioButton(IDC_RADIO_NTSC, IDC_RADIO_PAL);
    if(nID == IDC_RADIO_NTSC)
        enc_video_param.EncVideoParam.TV_System = ENC_VIDEO_TV_SYSTEM_NTSC;
    else
        enc_video_param.EncVideoParam.TV_System = ENC_VIDEO_TV_SYSTEM_PAL;

    // j^[o͂̐ݒ
    // Check output monitor
    if(m_Check_Monitor.GetCheck() == TRUE)
        enc_video_param.EncVideoParam.fOutputMonitor = TRUE;
    else
        enc_video_param.EncVideoParam.fOutputMonitor = FALSE;

    m_Edit_Brightness.GetWindowText(szText, sizeof(szText));
    enc_video_param.EncVideoParam.nInputBrightness = atol(szText);
    m_Edit_Contrast.GetWindowText(szText, sizeof(szText));
    enc_video_param.EncVideoParam.nInputContrast = atol(szText);
    m_Edit_Hue.GetWindowText(szText, sizeof(szText));
    enc_video_param.EncVideoParam.nInputHue = atol(szText);
    m_Edit_Saturation.GetWindowText(szText, sizeof(szText));
    enc_video_param.EncVideoParam.nInputSaturation = atol(szText);

	if ( m_nBoardConf == 0 )
	{
		nID = GetCheckedRadioButton(IDC_RADIO_VP_NONE, IDC_RADIO_VP_NR_S);
		
		switch(nID) 
		{
		case IDC_RADIO_VP_3DYC:		// 3DYC
			enc_video_param.nVideoProcessing = ENC_VIDEO_PROCESSING_3DYC;
			break;
		case IDC_RADIO_VP_NR_W:		// NR WEAKE
			enc_video_param.nVideoProcessing = ENC_VIDEO_PROCESSING_NR_W;
			break;
		case IDC_RADIO_VP_NR_S:		// NR STRONG
			enc_video_param.nVideoProcessing = ENC_VIDEO_PROCESSING_NR_S;
			break;
		case IDC_RADIO_VP_NONE:		// NONE
		default:
			enc_video_param.nVideoProcessing = ENC_VIDEO_PROCESSING_NONE;
			break;
		}
	}

    // j^[̏Ԃ̎擾
    // Get monitor state
    enc_return = ENC_Get_Monitor_Status(ENC_ID, &fMonitor);
    if(enc_return == ENC_SUCCESS)
    {
        if(fMonitor)
        {
            // j^[o͂~߂
            // Stop output monitor
            ENC_Stop_Monitor(ENC_ID);
        }
    }

    // Vlݒ肷
    // Set video parameters
	enc_video_param.dwSize = sizeof(ENC_VIDEO_PARAMETER2);
    enc_return = ENC_Set_Video_Parameter2(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_SET_PARAMETER);
        MessageBox(strMessage);
    }

    if(fMonitor)
    {
        // j^[o͂Jn
        // Start output monitor
        enc_return = ENC_Start_Monitor(ENC_ID);
        if(enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_START_MONITOR);
            MessageBox(strMessage);
        }
    }

	// IRE Setting
	// When ire is set up, the parameter of video (brightness, contrast, saturation)  will return to an initial value
	nID = GetCheckedRadioButton( IDC_RADIO_0IRE, IDC_RADIO_75IRE);
		
	switch (nID) {
	case IDC_RADIO_0IRE:
		if ( m_nIreSetting != MVR_IRE_LEVEL_0_NTSC ) {
			ENC_Set_IRE_Setting( ENC_ID, MVR_IRE_LEVEL_0_NTSC);
		}
		break;
	case IDC_RADIO_75IRE:
		if ( m_nIreSetting != MVR_IRE_LEVEL_75_NTSC ) {
			ENC_Set_IRE_Setting( ENC_ID, MVR_IRE_LEVEL_75_NTSC);
		}
		break;
	default:
		break;
	}

    CDialog::OnOK();
}
