//======================================================================
// -- MainFrm.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//                                  GR[h  TvvO      
//                                  Encode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// MainFrm.cpp : CMainFrame NX̓̒`s܂B
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Encode_m.h"

#include "MainFrm.h"
#include "DlgBSS.h"

#include "VideoDlg.h"
#include "AudioEncDlg.h"
#include "VideoEncExDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	ENC_ID;
CMainFrame* pMain = NULL;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_WM_CREATE()
    ON_WM_CLOSE()
    ON_WM_SIZE()
    ON_WM_MOVE()
    ON_COMMAND(ID_MEM_PARAM, OnMemParam)
	ON_COMMAND(ID_ENCODE_AUDIO, OnEncodeAudio)
	ON_UPDATE_COMMAND_UI(ID_ENCODE_AUDIO, OnUpdateEncodeAudio)
	ON_COMMAND(ID_ENCODE_VIDEO, OnEncodeVideo)
	ON_UPDATE_COMMAND_UI(ID_ENCODE_VIDEO, OnUpdateEncodeVideo)
	ON_COMMAND(ID_ENCODE_AV, OnEncodeAv)
	ON_UPDATE_COMMAND_UI(ID_ENCODE_AV, OnUpdateEncodeAv)
    ON_COMMAND(ID_ENCODE_PS, OnEncodePs)
	ON_UPDATE_COMMAND_UI(ID_ENCODE_PS, OnUpdateEncodePs)
    ON_COMMAND(ID_ENCODE_STOP, OnEncodeStop)
	ON_COMMAND(IDM_SET_VIDEO_PARAM, OnSetVideoParam)
	ON_UPDATE_COMMAND_UI(IDM_SET_VIDEO_PARAM, OnUpdateSetVideoParam)
	ON_COMMAND(IDM_SET_VIDEO_ENC_PARAM, OnSetVideoEncParam)
	ON_UPDATE_COMMAND_UI(IDM_SET_VIDEO_ENC_PARAM, OnUpdateSetVideoEncParam)
	ON_COMMAND(IDM_SET_AUDIO_ENC_PARAM, OnSetAudioEncParam)
	ON_UPDATE_COMMAND_UI(IDM_SET_AUDIO_ENC_PARAM, OnUpdateSetAudioEncParam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
    // TODO: ̈ʒuɃȍR[hǉĂB
	// TODO: add member initialization code here
    m_hFileAudio  = INVALID_HANDLE_VALUE;
    m_hFileVideo  = INVALID_HANDLE_VALUE;
    m_hFilePs     = INVALID_HANDLE_VALUE;
    hWndOverlay   = NULL;
	m_nBoardConf = 0;
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
    //       CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

    return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh
// CMainFrame message handlers


//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
// @\                                                       
//                                                                      
//  F      LPCREATESTRUCT lpCreateStruct;                          
//                                                                      
//  ߂lF    int     0;                                          
//                      -1;     s                                    
//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
//  Function:   Initialize                                              
//                                                                      
//      Parameters:     LPCREATESTRUCT lpCreateStruct;                  
//                                                                      
//      Return value:   int     0;      success                         
//                              -1;     fail                            
//----------------------------------------------------------------------
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    ENC_RETURN  enc_return;
    CString     strMessage;
	UINT		nNumber=0;
	ENC_CONFIG	config;
	UINT		ui;

    ENC_BSS_PARAMETER   BssParam;
    BssParam.fType          = ENC_BSS_TYPE_PS;
    BssParam.pfnCallback    = WriteSectorPsProc;
    BssParam.cbBuff         = 0x8000;
    BssParam.cBuff          = 32;
    BssParam.dwData         = (DWORD)INVALID_HANDLE_VALUE;

    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

	for (int i = 1; i < __argc; i++) {
		LPCTSTR pszParam = __targv[i];
		if ((pszParam[0] == _T('-') || pszParam[0] == _T('/')) && !_tcsnicmp(pszParam + 1, _T("id:"), _tcslen(_T("id:"))))
			// id number is specified by /id:n
			nNumber = atoi(pszParam + 4);
	}

	if (nNumber == 0)
	{
		memset(&config, 0, sizeof(ENC_CONFIG));
		ENC_Get_Codec_Config(ENC_ID, &config);

		for (ui = 0;ui <= config.NumberCodecs; ui++)
		{
			config.CodecNumber = ui;
			ENC_Get_Codec_Config(ENC_ID, &config);
			if (config.CurrentUtilization == FALSE)
			{
				if (config.CodecCaps & ENCCAP_ENCODE)
				{
	                if (config.CodecCaps & ENCCAP_D2200)
		            {
						m_nBoardConf = ENCCAP_D2200;
					}
					else if (config.CodecCaps & ENCCAP_D2200V)
		            {
						m_nBoardConf = ENCCAP_D2200V;
					}
					else {
						m_nBoardConf = 0;
					}
					nNumber = ui;
					break;
				}
			}
		}
	}
	
	ENC_ID=nNumber;	
	ENC_Set_Codec_Number(ENC_ID, nNumber);

    pMain = this;

    // Cȕ
    // Initialize library
    enc_return = ENC_Initialize_Ex(ENC_ID, ENC_MEDIA_MEMORY, &BssParam);
    if(enc_return != ENC_SUCCESS)
    {
        MessageBox("Cannot Initialize library");
        return -1;
    }

	// R[obN̐ݒ
    // Set CallbackProc
    enc_return = ENC_Set_Callback(ENC_ID, StatusProc, ErrorProc, TmapProc, NULL, NULL);
    if(enc_return != ENC_SUCCESS)
    {
        return -1;
    }

    ENC_BSS_PARAMETER   BssParamVideo;
    ENC_BSS_PARAMETER   BssParamAudio;

    BssParamAudio.pfnCallback    = WriteSectorAudioProc;
    BssParamAudio.cBuff          = 16;
    BssParamAudio.cbBuff         = 0x1000;
    BssParamAudio.dwData         = (DWORD)INVALID_HANDLE_VALUE;

    BssParamVideo.pfnCallback    = WriteSectorVideoProc;
    BssParamVideo.cBuff          = 16;
    BssParamVideo.cbBuff         = 0x8000;
    BssParamVideo.dwData         = (DWORD)INVALID_HANDLE_VALUE;

    VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, &BssParamAudio, &BssParamVideo) == ENC_SUCCESS);

    // I[o[CEBhE̍쐬
    // Create overlay window
    if(hWndOverlay == NULL)
        CreateOverlayWindow();

    // ̓\[X̌o
    // Detect input source
    AutoDetect();
    
    // j^Jn
    // Start monitor
    ENC_Start_Monitor(ENC_ID);

    ENC_Set_Record_Time(ENC_ID, 0, FALSE);

    return 0;
}

//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
// @\     R[obN֐                                            
//                                                                      
//  F      UINT                enc_id                              
//              ENC_STATUS_NOTIFY   enc_state                           
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
//  Function:   Callback function                                       
//                                                                      
//      Paraneters:     UINT                enc_id                      
//                      ENC_STATUS_NOTIFY   enc_state                   
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK StatusProc(UINT enc_id, ENC_STATUS_NOTIFY enc_state)
{
    UINT                count;
    double              time;
    char                szText[MAX_PATH];
    ENC_BSS_PARAMETER   BssParam;


    if(enc_state == ENC_NOTIFY_STOP)
    {
        if (pMain->m_hFileAudio != INVALID_HANDLE_VALUE)
        {
            CloseHandle(pMain->m_hFileAudio);                // File Close
			pMain->m_hFileAudio = NULL;

            VERIFY(ENC_Get_BSS_Parameter_AV(ENC_ID, &BssParam, NULL) == ENC_SUCCESS);
            BssParam.dwData = (DWORD)INVALID_HANDLE_VALUE;
            VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, &BssParam, NULL) == ENC_SUCCESS);
            TRACE0("File Close\n");
        }
        if (pMain->m_hFileVideo != INVALID_HANDLE_VALUE)
        {
            CloseHandle(pMain->m_hFileVideo);                // File Close
			pMain->m_hFileVideo = NULL;

            VERIFY(ENC_Get_BSS_Parameter_AV(ENC_ID, NULL, &BssParam) == ENC_SUCCESS);
            BssParam.dwData = (DWORD)INVALID_HANDLE_VALUE;
            VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, NULL, &BssParam) == ENC_SUCCESS);
            TRACE0("File Close\n");
        }
        if (pMain->m_hFilePs != INVALID_HANDLE_VALUE)
        {
            CloseHandle(pMain->m_hFilePs);                // File Close
			pMain->m_hFilePs = NULL;

            VERIFY(ENC_Get_BSS_Parameter(ENC_ID, &BssParam) == ENC_SUCCESS);
            BssParam.dwData = (DWORD)INVALID_HANDLE_VALUE;
            VERIFY(ENC_Set_BSS_Parameter(ENC_ID, &BssParam) == ENC_SUCCESS);
            TRACE0("File Close\n");
        }

        ENC_Get_Frame_Count(enc_id, &count);
        ENC_Get_Time(enc_id, &time);
        sprintf(szText,"Encode Frame : %ld\nEncode Time   : %.2f[sec]", count, time);

        MessageBox(AfxGetMainWnd()->GetSafeHwnd(), szText, "Encode", MB_OK);
    }
}

//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
// @\     R[obN֐iG[j                                  
//                                                                      
//  F      UINT        enc_id                                      
//              ULONG       error                                       
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
//  Function:   Callback function (error)                               
//                                                                      
//      Parameters:     UINT        enc_id                              
//                      ULONG       error                               
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK ErrorProc(UINT enc_id, ULONG error)
{
    CString strText;
    switch (error)
    {
    case MVR_ERROR_SUCCESS:
        strText = "MVR_ERROR_SUCCESS";
        break;
    case MVR_ERROR_PENDING:
        strText = "MVR_ERROR_PENDING";
        break;
    case MVR_ERROR_SYSTEM_ERROR:
        strText = "MVR_ERROR_SYSTEM_ERROR";
        break;
    case MVR_ERROR_NOT_PENDING:
        strText = "MVR_ERROR_NOT_PENDING";
        break;
    case MVR_ERROR_INVALID_ASYNCOP:
        strText = "MVR_ERROR_INVALID_ASYNCOP";
        break;
    case MVR_ERROR_UNSUPPORTED:
        strText = "MVR_ERROR_UNSUPPORTED";
        break;
    case MVR_ERROR_INVALID_TYPE:
        strText = "MVR_ERROR_INVALID_TYPE";
        break;
    case MVR_ERROR_INVALID_OPTION:
        strText = "MVR_ERROR_INVALID_OPTION";
        break;
    case MVR_ERROR_INVALID_ADDRESS:
        strText = "MVR_ERROR_INVALID_ADDRESS";
        break;
    case MVR_ERROR_LIMIT_EXCEEDED:
        strText = "MVR_ERROR_LIMIT_EXCEEDED";
        break;
    case MVR_ERROR_INVALID_HANDLE:
        strText = "MVR_ERROR_INVALID_HANDLE";
        break;
    case MVR_ERROR_INVALID_STREAM:
        strText = "MVR_ERROR_INVALID_STREAM";
        break;
    case MVR_ERROR_INVALID_BUFFER:
        strText = "MVR_ERROR_INVALID_BUFFER";
        break;
    case MVR_ERROR_INVALID_MESSAGE:
        strText = "MVR_ERROR_INVALID_MESSAGE";
        break;
    case MVR_ERROR_CANCELED:
        strText = "MVR_ERROR_CANCELED";
        break;
    case MVR_ERROR_BUSY:
        strText = "MVR_ERROR_BUSY";
        break;
    case MVR_ERROR_BUFFER_ERROR:
        strText = "MVR_ERROR_BUFFER_ERROR";
        break;
    case MVR_ERROR_MESSAGE_ERROR:
        strText = "MVR_ERROR_MESSAGE_ERROR";
        break;
    case MVR_ERROR_BAD_PARAM:
        strText = "MVR_ERROR_BAD_PARAM";
        break;
    case MVR_ERROR_HARDWARE_ERROR:
        strText = "MVR_ERROR_HARDWARE_ERROR";
        break;
    case MVR_ERROR_ALLOC_FAILURE:
        strText = "MVR_ERROR_ALLOC_FAILURE";
        break;
    case MVR_ERROR_INVALID_EVENT:
        strText = "MVR_ERROR_INVALID_EVENT";
        break;
    case MVR_ERROR_INVALID_STATE:
        strText = "MVR_ERROR_INVALID_STATE";
        break;
    case MVR_ERROR_CURRENT_STATE:
        strText = "MVR_ERROR_CURRENT_STATE";
        break;
    case MVR_ERROR_INVALID_FRAME_TYPE:
        strText = "MVR_ERROR_INVALID_FRAME_TYPE";
        break;
    case MVR_ERROR_INSUFFICIENT_BUFFERS:
        strText = "MVR_ERROR_INSUFFICIENT_BUFFERS";
        break;
    case MVR_ERROR_TIMEOUT:
        strText = "MVR_ERROR_TIMEOUT";
        break;
    case MVR_ERROR_INVALID_CODEC_STATE:
        strText = "MVR_ERROR_INVALID_CODEC_STATE";
        break;
    case MVR_ERROR_INVALID_FORMAT:
        strText = "MVR_ERROR_INVALID_FORMAT";
        break;
    case MVR_ERROR_INVALID_OPERATION:
        strText = "MVR_ERROR_INVALID_OPERATION";
        break;
    case MVR_ERROR_OVERFLOW:
        strText = "MVR_ERROR_OVERFLOW";
        break;
    case MVR_ERROR_UNDERFLOW:
        strText = "MVR_ERROR_UNDERFLOW";
        break;
    case MVR_ERROR_SESSION_CANCELED:
        strText = "MVR_ERROR_SESSION_CANCELED";
        break;
    case MVR_ERROR_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_AUDIO_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_AUDIO_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_PARSE_ERROR:
        strText = "MVR_ERROR_PARSE_ERROR";
        break;
    case MVR_ERROR_END_OF_STREAM:
        strText = "MVR_ERROR_END_OF_STREAM";
        break;
    case MVR_ERROR_DISK_FULL:
        strText = "MVR_ERROR_DISK_FULL";
        break;
    case MVR_ERROR_STREAMS_CLOSED:
        strText = "MVR_ERROR_STREAMS_CLOSED";
        break;
    case MVR_ERROR_INTERNAL_ERROR:
        strText = "MVR_ERROR_INTERNAL_ERROR";
        break;
    case MVR_ERROR_INVALID_SHORT_BUFFER:
        strText = "MVR_ERROR_INVALID_SHORT_BUFFER";
        break;
    case MVR_ERROR_EVENT_DATA_OVERRUN:
        strText = "MVR_ERROR_EVENT_DATA_OVERRUN";
        break;
    case MVR_ERROR_EVENT_DATA_UNDERRUN:
        strText = "MVR_ERROR_EVENT_DATA_UNDERRUN";
        break;
    case MVR_ERROR_EVENT_DEVICE_ERROR:
        strText = "MVR_ERROR_EVENT_DEVICE_ERROR";
        break;
    case MVR_ERROR_EVENT_LOSS_OF_VIDEO:
        strText = "MVR_ERROR_EVENT_LOSS_OF_VIDEO";
        break;
    case MVR_ERROR_EVENT_EVENT_LOSS:
        strText = "MVR_ERROR_EVENT_EVENT_LOSS";
        break;
    case MVR_ERROR_EVENT_UNRECOVERABLE_ERROR:
        strText = "MVR_ERROR_EVENT_UNRECOVERABLE_ERROR";
        break;
    default:
        strText = "????";
        break;
    }
    AfxMessageBox(strText);
}

//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
// @\     I[o[CEBhE쐬                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE    EBhE쐬ɐ                    
//                      FALSE   EBhE쐬Ɏs                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
//  Function:   Create overlay window                                   
//                                                                      
//      Parameters:  none                                               
//                                                                      
//      Return value:   BOOL    TRUE    success                         
//                              FALSE   fail                            
//                                                                      
//----------------------------------------------------------------------
BOOL CMainFrame::CreateOverlayWindow()
{
    ENC_RETURN  enc_return;
    RECT        rc;
    CString     strMessage;

    GetClientRect(&rc);

    enc_return = ENC_Can_Overlay_Window(ENC_ID, NULL, rc.right, rc.bottom);
    if(enc_return != ENC_SUCCESS)
    {
        MessageBox("Cannot create overlay window");
    }
    else
    {
        // I[o[CEBhE̍쐬
        // Create overlay window
        enc_return = ENC_Create_Overlay_Window(ENC_ID, m_hWnd, &hWndOverlay, 0, 0, rc.right, rc.bottom);

        if(enc_return != ENC_SUCCESS)
        {
            MessageBox("Cannot create overlay window");
        }
    }

    return TRUE;
}

//----------------------------------------------------------------------
// #[ CMainFrame::AutoDetect ]                                          
//                                                                      
// @\     ̓\[X̎o                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::AutoDetect ]                                          
//                                                                      
//  Function:   Detect input source                                     
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::AutoDetect()
{
    ENC_RETURN  enc_return;
    ENC_VIDEO_PARAMETER enc_video_param;
    int         nInputSource;
    CString     strMessage;
    UINT        fMonitor;

    // j^[̏Ԃ̎擾
    // Get monitor state
    enc_return = ENC_Get_Monitor_Status(ENC_ID, &fMonitor);
    if(enc_return == ENC_SUCCESS)
    {
        if(fMonitor)
        {
            // j^[o͂~߂
            // Stop output monitor
            ENC_Stop_Monitor(ENC_ID);
        }
    }

    // ݂̐ݒl擾
    // Get video parameter
    enc_return = ENC_Get_Video_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        MessageBox("Cannot get video parameters");
        return;
    }

    enc_return = ENC_Detect_Video_Input_Source(ENC_ID, &nInputSource);
    if(enc_return == ENC_SUCCESS)
    {
        // ̓\[Xݒ肷
        // Set input source
        enc_video_param.fInputSource = nInputSource;
    }

    // Vlݒ肷
    // Set video parameters
    enc_return = ENC_Set_Video_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
        MessageBox("Cannot set video parameters");

    if(fMonitor)
    {
        // j^[o͂Jn
        // Start output monitor
        enc_return = ENC_Start_Monitor(ENC_ID);
        if(enc_return != ENC_SUCCESS)
            MessageBox("Cannot start output monitor");
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
// @\     AvP[VI܂                                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
//  Function:   End application                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnClose() 
{
    ENC_RETURN  enc_return;
    CString     strMessage;

    // j^~
    // Stop monitor
    ENC_Stop_Monitor(ENC_ID);

    // I[o[CEBhEj
    // Destroy overlay window
    if(hWndOverlay != NULL)
    {
        enc_return = ENC_Destroy_Overlay_Window(ENC_ID);
        if(enc_return != ENC_SUCCESS)
        {
            MessageBox("Cannot destroy overlay window");
        }
    }

    // GR[_I
    // Terminate decode
    enc_return = ENC_Terminate(ENC_ID);
    if(enc_return != ENC_SUCCESS)
        MessageBox("Cannot terminate decode");

    CFrameWnd::OnClose();
}

void CALLBACK WriteSectorAudioProc(LPBYTE pbBuff, DWORD cbBuff, DWORD dwData)
{
    HANDLE hFile = (HANDLE)dwData;
    if (hFile != INVALID_HANDLE_VALUE)
    {
        DWORD   cbWritten;

        VERIFY(WriteFile(hFile, pbBuff, cbBuff, &cbWritten, NULL));
    }
}

void CALLBACK WriteSectorVideoProc(LPBYTE pbBuff, DWORD cbBuff, DWORD dwData)
{
    HANDLE hFile = (HANDLE)dwData;
    if (hFile != INVALID_HANDLE_VALUE)
    {
        DWORD   cbWritten;

        VERIFY(WriteFile(hFile, pbBuff, cbBuff, &cbWritten, NULL));
    }
}

void CALLBACK WriteSectorPsProc(LPBYTE pbBuff, DWORD cbBuff, DWORD dwData)
{
    HANDLE hFile = (HANDLE)dwData;
    if (hFile != INVALID_HANDLE_VALUE)
    {
        DWORD   cbWritten;

        VERIFY(WriteFile(hFile, pbBuff, cbBuff, &cbWritten, NULL));
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
// @\     I[o[CEBhËʒüړ                          
//                                                                      
//  F      int     x                                               
//              int     y                                               
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
//  Function:   Move overlay window                                     
//                                                                      
//      Parameters:     int     x                                       
//                      int     y                                       
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnMove(int x, int y) 
{
    CFrameWnd::OnMove(x, y);

    if(hWndOverlay)
        ENC_Move_Overlay_Window(ENC_ID, x, y);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
// @\     I[o[CEBhẼTCYύX                          
//                                                                      
//  F      UINT    nType                                           
//              int     cx                                              
//              int     cy                                              
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
//  Function:   Resize overlay window                                   
//                                                                      
//      Parameters:     UINT    nType                                   
//                      int     cx                                      
//                      int     cy                                      
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);

    if(hWndOverlay)
        ENC_Resize_Overlay_Window(ENC_ID, cx, cy);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnMemParam ]                                          
//                                                                      
// @\     ]p[^ݒ_CAOĂяo                  
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnMemParam ]                                          
//                                                                      
//  Function:   Set memory parameters                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnMemParam() 
{
    CDlgBSS dlg;

    ENC_BSS_PARAMETER   BssParamAudio;
    ENC_BSS_PARAMETER   BssParamVideo;
    ENC_BSS_PARAMETER   BssParamPs;
    VERIFY(ENC_Get_BSS_Parameter_AV(ENC_ID, &BssParamAudio, &BssParamVideo) == ENC_SUCCESS);
    VERIFY(ENC_Get_BSS_Parameter(ENC_ID, &BssParamPs) == ENC_SUCCESS);

    dlg.m_dwMemoryAudio = BssParamAudio.cbBuff;
    dlg.m_dwBuffAudio   = BssParamAudio.cBuff;
    dlg.m_dwMemoryVideo = BssParamVideo.cbBuff;
    dlg.m_dwBuffVideo   = BssParamVideo.cBuff;
    dlg.m_dwMemoryPs    = BssParamPs.cbBuff;
    dlg.m_dwBuffPs      = BssParamPs.cBuff;

    if (dlg.DoModal() == IDOK)
    {
        BssParamAudio.cbBuff = dlg.m_dwMemoryAudio;
        BssParamAudio.cBuff  = dlg.m_dwBuffAudio;
        BssParamVideo.cbBuff = dlg.m_dwMemoryVideo;
        BssParamVideo.cBuff  = dlg.m_dwBuffVideo;
        BssParamPs.cbBuff    = dlg.m_dwMemoryPs;
        BssParamPs.cBuff     = dlg.m_dwBuffPs;

        VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, &BssParamAudio, &BssParamVideo) == ENC_SUCCESS);
        VERIFY(ENC_Set_BSS_Parameter(ENC_ID, &BssParamPs) == ENC_SUCCESS);
	}
}

//----------------------------------------------------------------------
// #[ TmapProc ]                                                        
//                                                                      
// @\     R[obN֐                                            
//                                                                      
//  F      UINT        enc_id                                      
//              ENC_VOBU_ENT_INFO   *tmap                               
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ TmapProc ]                                                        
//                                                                      
//  Function:   Callback function                                       
//                                                                      
//      Parameters:     UINT        enc_id                              
//                      ENC_VOBU_ENT_INFO   *tmap                       
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK TmapProc(UINT enc_id, ENC_VOBU_ENT_INFO *tmap, UINT)
{
    TRACE1("TmapProc (ID = %d)\n", enc_id);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncodeAudio ]                                       
//                                                                      
// @\     GR[hiI[fBIj                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncodeAudio ]                                       
//                                                                      
//  Function:   Audio encode                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncodeAudio() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szFile[MAX_PATH];
    char    szFilter[] = {"Mpeg2 Audio(*,m2a)|*.m2a|Mpeg1 Audio(*.mpa)|*.mpa||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szFile);
    if(enc_return == ENC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
        lstrcpy(szFile, strFileName);

        SetWindowText(szFile);

        m_hFileAudio = CreateFile(szFile, 
                            GENERIC_READ | GENERIC_WRITE, 
                            FILE_SHARE_READ, 
                            NULL, 
                            CREATE_ALWAYS,
                            FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
                            NULL);

        ENC_BSS_PARAMETER   BssParam;
        VERIFY(ENC_Get_BSS_Parameter_AV(ENC_ID, &BssParam, NULL) == ENC_SUCCESS);
        BssParam.dwData         = (DWORD)m_hFileAudio;
        VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, &BssParam, NULL) == ENC_SUCCESS);

        // t@C̐ݒ
        // Set file name
        enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szFile);
        if(enc_return == ENC_SUCCESS)
        {
            enc_return = ENC_Init_Movie(ENC_ID);
            if(enc_return == ENC_SUCCESS)
            {
                MessageBox("Start encode");
                enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_AUDIO);
                if(enc_return == ENC_SUCCESS)
					return;

                MessageBox("Cannot start encode");
            }
        }

        CloseHandle(m_hFileAudio);
        m_hFileAudio = NULL;
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodeAudio ]                                 
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodeAudio ]                                 
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncodeAudio(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncodeVideo ]                                       
//                                                                      
// @\     GR[hirfIj                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncodeVideo ]                                       
//                                                                      
//  Function:   Video encode                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncodeVideo() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szFile[MAX_PATH];
    char    szFilter[] = {"Mpeg2 Video(*,m2v)|*.m2v|Mpeg1 Video(*.mpv)|*.mpv||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szFile);
    if(enc_return == ENC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
        lstrcpy(szFile, strFileName);

        SetWindowText(szFile);

        m_hFileVideo = CreateFile(szFile, 
                            GENERIC_READ | GENERIC_WRITE, 
                            FILE_SHARE_READ, 
                            NULL, 
                            CREATE_ALWAYS,
                            FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
                            NULL);

        ENC_BSS_PARAMETER   BssParam;
        VERIFY(ENC_Get_BSS_Parameter_AV(ENC_ID, NULL, &BssParam) == ENC_SUCCESS);
        BssParam.dwData         = (DWORD)m_hFileVideo;
        VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, NULL, &BssParam) == ENC_SUCCESS);

        // t@C̐ݒ
        // Set file name
        enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szFile);
        if(enc_return == ENC_SUCCESS)
        {
            enc_return = ENC_Init_Movie(ENC_ID);
            if(enc_return == ENC_SUCCESS)
            {
                MessageBox("Start encode");
                enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_VIDEO);
                if(enc_return == ENC_SUCCESS)
					return;

                MessageBox("Cannot start encode");
            }
        }

        CloseHandle(m_hFileVideo);
        m_hFileVideo = NULL;
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodeVideo ]                                 
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodeVideo ]                                 
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncodeVideo(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncodeAv ]                                          
//                                                                      
// @\     GR[hiI[fBI{rfIj                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncodeAv ]                                          
//                                                                      
//  Function:   Audio and Video encode                                  
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncodeAv() 
{
	ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szVideoFile[MAX_PATH];
	char    szAudioFile[MAX_PATH];
    char    szVideoFilter[] = {"Mpeg2 Video Stream(*,m2v)|*.m2v|Mpeg1 Video Stream(*.mpv)|*.mpv||"};
	char    szAudioFilter[] = {"Mpeg2 Audio Stream(*,m2a)|*.m2a|Mpeg1 Audio Stream(*.mpa)|*.mpa||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlgVideo(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szVideoFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szVideoFile);
    if(enc_return == ENC_SUCCESS)
        dlgVideo.m_ofn.lpstrFile = szVideoFile;

    if (dlgVideo.DoModal() != IDOK)
		return;

    strFileName = dlgVideo.GetPathName();
    lstrcpy(szVideoFile, strFileName);

	// _CAO̐ݒ
    // Initialize dialog
	CFileDialog dlgAudio(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szAudioFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szAudioFile);
    if(enc_return == ENC_SUCCESS)
        dlgAudio.m_ofn.lpstrFile = szAudioFile;

    if (dlgAudio.DoModal() != IDOK)
		return;

    strFileName = dlgAudio.GetPathName();
    lstrcpy(szAudioFile, strFileName);

    // t@C̐ݒ
    // Set file name
    enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_VIDEO, szVideoFile);
    if (enc_return != ENC_SUCCESS)
		return;

    enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_AUDIO, szAudioFile);
    if (enc_return != ENC_SUCCESS)
		return;

	strFileName.Format("%s + %s", szVideoFile, szAudioFile);
	SetWindowText(strFileName);

    m_hFileVideo = CreateFile(szVideoFile, 
                            GENERIC_READ | GENERIC_WRITE, 
                            FILE_SHARE_READ, 
                            NULL, 
                            CREATE_ALWAYS,
                            FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
                            NULL);

    m_hFileAudio = CreateFile(szAudioFile, 
                            GENERIC_READ | GENERIC_WRITE, 
                            FILE_SHARE_READ, 
                            NULL, 
                            CREATE_ALWAYS,
                            FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
                            NULL);

    ENC_BSS_PARAMETER   BssParamVideo;
    ENC_BSS_PARAMETER   BssParamAudio;
    VERIFY(ENC_Get_BSS_Parameter_AV(ENC_ID, &BssParamAudio, &BssParamVideo) == ENC_SUCCESS);
    BssParamAudio.dwData         = (DWORD)m_hFileAudio;
    BssParamVideo.dwData         = (DWORD)m_hFileVideo;
    VERIFY(ENC_Set_BSS_Parameter_AV(ENC_ID, &BssParamAudio, &BssParamVideo) == ENC_SUCCESS);

    enc_return = ENC_Init_Movie(ENC_ID);
    if(enc_return == ENC_SUCCESS)
    {
        MessageBox("Start encode");
        enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_VIDEO | ENC_RECORD_AUDIO);
        if (enc_return == ENC_SUCCESS)
			return;

        MessageBox("Cannot start encode");
    }

    CloseHandle(m_hFileAudio);
    CloseHandle(m_hFileVideo);
    m_hFileAudio = NULL;
    m_hFileVideo = NULL;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodeAv ]                                    
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodeAv ]                                    
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncodeAv(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncProgram ]                                        
//                                                                      
// @\     GR[hivOXg[j                          
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncProgram ]                                        
//                                                                      
//  Function:   Program stream encode                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncodePs() 
{
    ENC_RETURN  enc_return;
    CString strMessage;
    CString strFileName;
    char    szFile[MAX_PATH];
    char    szFilter[] = {"Mpeg2 Program Stream(*,m2p)|*.m2p|Mpeg1 System Stream(*.mpg)|*.mpg||"};

    // _CAO̐ݒ
    // Initialize dialog
    CFileDialog dlg(FALSE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // t@C̎擾
    // Get file name
    enc_return = ENC_Get_Movie_File(ENC_ID, ENC_RECORD_PS, szFile);
    if(enc_return == ENC_SUCCESS)
        dlg.m_ofn.lpstrFile = szFile;

    if(dlg.DoModal() == IDOK)
    {
        strFileName = dlg.GetPathName();
        lstrcpy(szFile, strFileName);

        SetWindowText(szFile);

        m_hFilePs = CreateFile(szFile, 
                            GENERIC_READ | GENERIC_WRITE, 
                            FILE_SHARE_READ, 
                            NULL, 
                            CREATE_ALWAYS,
                            FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
                            NULL);

        ENC_BSS_PARAMETER   BssParam;
        VERIFY(ENC_Get_BSS_Parameter(ENC_ID, &BssParam) == ENC_SUCCESS);
        BssParam.dwData = (DWORD)m_hFilePs;
        VERIFY(ENC_Set_BSS_Parameter(ENC_ID, &BssParam) == ENC_SUCCESS);

        // t@C̐ݒ
        // Set file name
        enc_return = ENC_Set_Movie_File(ENC_ID, ENC_RECORD_PS, szFile);
        if(enc_return == ENC_SUCCESS)
        {
            enc_return = ENC_Init_Movie(ENC_ID);
            if(enc_return == ENC_SUCCESS)
            {
                MessageBox("Start encode");
                enc_return = ENC_Record_Movie(ENC_ID, ENC_RECORD_PS);
                if(enc_return == ENC_SUCCESS)
					return;

                MessageBox("Cannot start encode");
            }
        }

        CloseHandle(m_hFilePs);
        m_hFilePs = NULL;
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodePs ]                                    
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateEncodePs ]                                    
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateEncodePs(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    if(ENC_Can_Record(ENC_ID) != ENC_SUCCESS)
    {
        pCmdUI->Enable(FALSE);
        return;
    }

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnEncStop ]                                           
//                                                                      
// @\     GR[h𒆎~                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnEncStop ]                                           
//                                                                      
//  Function:   Stop the encode                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnEncodeStop() 
{
    ENC_RETURN  enc_return;
    CString     strMessage;

    enc_return = ENC_Stop(ENC_ID);
    if(enc_return != ENC_SUCCESS)
    {
        MessageBox("Cannot stop encode");
        return;
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoParam ]                                     
//                                                                      
// @\     rfIp[^ݒ_CAOĂяo                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoParam ]                                     
//                                                                      
//  Function:   Set video parameters                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoParam() 
{
    ENC_RETURN  enc_return;
    CVideoDlg   dlg;
    CString     strMessage;
    RECT        rc;

	dlg.m_nBoardConf = m_nBoardConf;

    if(dlg.DoModal() == IDOK)
    {
        // EBhEnh̍XV
        // Get a handle of overlay window
        enc_return = ENC_Get_Overlay_Window(ENC_ID, &hWndOverlay);
        if(enc_return != ENC_SUCCESS)
        {
            strMessage.LoadString(IDC_ERROR_GET_OVERLAY);
            MessageBox(strMessage);
            return;
        }
        
        GetClientRect(&rc);
        ENC_Resize_Overlay_Window(ENC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoParam ]                               
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoParam ]                               
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoEncParam ]                                
//                                                                      
// @\     rfIGR[hp[^ݒ_CAOĂяo        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetVideoEncParamEx ]                                
//                                                                      
//  Function:   Set video encode parameter                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetVideoEncParam() 
{
   CVideoEncExDlg  dlg;

    dlg.DoModal();
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoEncParamEx ]                          
//                                                                      
// @\     ~̂݊grfIGR[h_CAOĂԂ悤ɂ    
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetVideoEncParamEx ]                          
//                                                                      
//  Function:   Select the item only encoder is stopped                 
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetVideoEncParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);	
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioEncParam ]                                  
//                                                                      
// @\     I[fBIGR[hp[^ݒ_CAOĂяo        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetAudioEncParam ]                                  
//                                                                      
//  Function:   Set audio encode parameters                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetAudioEncParam() 
{
    CAudioEncDlg    dlg;
    RECT            rc;

    if(dlg.DoModal() == IDOK)
    {
        GetClientRect(&rc);
        ENC_Resize_Overlay_Window(ENC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetAudioEncParam ]                            
//                                                                      
// @\     GR[h͑IłȂ悤ɂ                        
//                                                                      
//  F      CCmdUI* pCmdUI                                          
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnUpdateSetAudioEncParam ]                            
//                                                                      
//  Function:   If encoder is working, user cannot select the item.     
//                                                                      
//      Parameters:     CCmdUI* pCmdUI                                  
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnUpdateSetAudioEncParam(CCmdUI* pCmdUI) 
{
    ENC_STATUS  enc_status;

    ENC_Get_Status(ENC_ID, &enc_status);
    pCmdUI->Enable(enc_status == ENC_STATUS_STOP ? TRUE : FALSE);
}