
// DecodeDoc.h : CDecodeDoc NX̐錾уC^[tFCX̒`܂B
// DecodeDoc.h : interface of the CDecodeDoc class
// Copyright (C) 2000-2005 Canopus Co., Ltd. All rights reserved.

/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DECODEDOC_H__874DEB91_DA3C_11D3_A299_00A0C9AFEEEA__INCLUDED_)
#define AFX_DECODEDOC_H__874DEB91_DA3C_11D3_A299_00A0C9AFEEEA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MvrApiDef.h"

#define MSG_DESTROY_OVERLAY (WM_USER+100)
#define MSG_CREATE_OVERLAY (WM_USER+101)

class CMpegReceiver; // for forward reference

class CDecodeDoc : public CDocument
{
protected:	// VACY@\݂̂쐬܂B
			// create from serialization only
	CDecodeDoc();
	DECLARE_DYNCREATE(CDecodeDoc)

// Agr[g
// Attributes
public:
	enum DecState {
		decNone, decConnected, decDisconnected, decStarted, decStopped
	};
	DecState m_fState;

// Iy[V
// Operations
public:
	static void CALLBACK DecStatusCallback(UINT nDecId, DEC_STATUS_NOTIFY fStatus);
	static void CALLBACK DecErrorCallback(UINT nDecId, ULONG ulError);

	void OnDecStopped();

	void RestartDecoder();
	BOOL m_fRestarting;

	CView* m_pView; // ċNɎgp
					// use when reboot automatically
	BOOL m_fCanRestart;

//I[o[Ch
// Overrides
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDecodeDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Cve[V
// Implementation
public:
	virtual ~CDecodeDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CMpegReceiver* m_pReceiver;
	WORD m_nPort;
	CString m_szAddress;
	CString m_szAddressRecvFrom;
	DWORD m_cbBsrBuff; // BSR buffer size in bytes
	DWORD m_cBsrBuff; // default BSR buffer count

// ꂽbZ[W }bv֐
// Generated message map functions
protected:
	//{{AFX_MSG(CDecodeDoc)
	afx_msg void OnConnect();
	afx_msg void OnUpdateConnect(CCmdUI* pCmdUI);
	afx_msg void OnDisconnect();
	afx_msg void OnUpdateDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnReceiveStart();
	afx_msg void OnUpdateReceiveStart(CCmdUI* pCmdUI);
	afx_msg void OnReceiveEnd();
	afx_msg void OnUpdateReceiveEnd(CCmdUI* pCmdUI);
	afx_msg void OnConnectOption();
	afx_msg void OnUpdateConnectOption(CCmdUI* pCmdUI);
	afx_msg void OnReceiveOption();
	afx_msg void OnUpdateReceiveOption(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DECODEDOC_H__874DEB91_DA3C_11D3_A299_00A0C9AFEEEA__INCLUDED_)

