
// Dialog.cpp : Cve[V t@C
// Dialog.cpp : implementation file
// Copyright (C) 2005 Canopus Co., Ltd. All rights reserved.

#include "stdafx.h"
#include "Encode_cEx.h"
#include "Dialog.h"

#include "mvrapidef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectOptionDlg _CAO
// CConnectOptionDlg dialog

CConnectOptionDlg::CConnectOptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectOptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConnectOptionDlg)
	m_szAddress = _T("");
	m_nPort = 0;
	m_szSendTo = _T("");
	//}}AFX_DATA_INIT
}

void CConnectOptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectOptionDlg)
	DDX_Text(pDX, IDC_CONNECT_ADDRESS, m_szAddress);
	DDX_Text(pDX, IDC_CONNECT_PORT, m_nPort);
	DDX_Text(pDX, IDC_CONNECT_SENDTO, m_szSendTo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConnectOptionDlg, CDialog)
	//{{AFX_MSG_MAP(CConnectOptionDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectOptionDlg bZ[W nh
// CConnectOptionDlg message handlers

/////////////////////////////////////////////////////////////////////////////
// CSendOptionDlg _CAO
// CSendOptionDlg dialog

CSendOptionDlg::CSendOptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendOptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendOptionDlg)
	m_dwAudioBitRate = 0;
	m_cBssBuff = 0;
	m_cbBssBuff = 0;
	m_dwVideoBitRate = 0;
	//}}AFX_DATA_INIT
}

void CSendOptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendOptionDlg)
	DDX_Text(pDX, IDC_SEND_AUDIO_BPS, m_dwAudioBitRate);
	DDX_Text(pDX, IDC_SEND_BUFF_COUNT, m_cBssBuff);
	DDX_Text(pDX, IDC_SEND_BUFF_SIZE, m_cbBssBuff);
	DDX_Text(pDX, IDC_SEND_VIDEO_BPS, m_dwVideoBitRate);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendOptionDlg, CDialog)
	//{{AFX_MSG_MAP(CSendOptionDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendOptionDlg bZ[W nh
// CSendOptionDlg message handlers

BOOL CSendOptionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ENC_VIDEO_ENCODE_PARAMETER enc_param;
	if (ENC_Get_Video_Encode_Parameter(GetEncId(), &enc_param)==ENC_SUCCESS)
	{
		switch (enc_param.fConvertType)
		{
		case ENCVEPARAM_CONVERT_TYPE_SIF:
			CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_SIF); break;
		case ENCVEPARAM_CONVERT_TYPE_HALF_D1:
			CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_HALFD1); break;
		default:
			CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_STANDARD);
		}
	}

	m_fConvertType = enc_param.fConvertType;
	
	return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

void CSendOptionDlg::OnOK() 
{
	switch (GetCheckedRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1))
	{
		case IDC_RADIO_SIF: m_fConvertType = ENCVEPARAM_CONVERT_TYPE_SIF; break;
		case IDC_RADIO_HALFD1: m_fConvertType = ENCVEPARAM_CONVERT_TYPE_HALF_D1; break;
		default: m_fConvertType = ENCVEPARAM_CONVERT_TYPE_STANDARD;
	}
	CDialog::OnOK();
}
