//======================================================================
// -- Adjust.cpp --                                                     
//                                                                      
//  MVR-D2000                                                           
//                                  fR[h    TvvO      
//                                  Decode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// Adjust.cpp : Cve[V t@C
// Adjust.cpp : implementation file
//

#include "stdafx.h"
#include "Decode.h"
#include "Adjust.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int	DEC_ID;

/////////////////////////////////////////////////////////////////////////////
// CAdjust _CAO
// CAdjust Dialog

CAdjust::CAdjust(CWnd* pParent /*=NULL*/)
    : CDialog(CAdjust::IDD, pParent)
{
	m_nBoardConf = 0;
    //{{AFX_DATA_INIT(CAdjust)
        //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		// NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void CAdjust::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAdjust)
    DDX_Control(pDX, IDC_EDIT_SATURATION, m_Edit_Saturation);
    DDX_Control(pDX, IDC_EDIT_CONTRAST, m_Edit_Contrast);
    DDX_Control(pDX, IDC_EDIT_BRIGHT, m_Edit_Bright);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdjust, CDialog)
    //{{AFX_MSG_MAP(CAdjust)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdjust bZ[W nh
// CAdjust message handlers

//----------------------------------------------------------------------
// #[ CAdjust::OnInitDialog ]                                           
//                                                                      
// @\     I[o[C̉掿                                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CAdjust::OnInitDialog ]                                           
//                                                                      
//  Function:   Initialize adjust dialog                                
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CAdjust::OnInitDialog() 
{
    CDialog::OnInitDialog();

  
	if ( m_nBoardConf == DECCAP_D2200V ) 
	{

#define DECPARAM_OUTPUT_DEVICE 0x4000
#define DEC_OUTPUT_DEVICE_SOFTWARE	0	
#define DEC_OUTPUT_DEVICE_DVSTORM	1
#define DEC_OUTPUT_DEVICE_MVR_SOFTWARE		2
#define DEC_OUTPUT_DEVICE_MVR_HARDWARE		3

		DWORD dwValue;

		if ( DEC_Get_Overlay_Parameter_Ex( DEC_ID, (DECPARAM_OVERLAY)DECPARAM_OUTPUT_DEVICE, &dwValue) != DEC_FAIL ) {
			if ( dwValue == DEC_OUTPUT_DEVICE_MVR_HARDWARE ) {
				DEC_OVERLAY_PARAMETER   dec_overlay_param;
				DEC_RETURN      dec_return;
				char    szText[16];

				dec_return = DEC_Get_Overlay_Parameter(DEC_ID, &dec_overlay_param);

				if(dec_return == DEC_SUCCESS)
				{
					wsprintf(szText, "%ld", dec_overlay_param.nOverlayBrightness);
					m_Edit_Bright.SetWindowText(szText);
					wsprintf(szText, "%ld", dec_overlay_param.nOverlayContrast);
					m_Edit_Contrast.SetWindowText(szText);
					wsprintf(szText, "%ld", dec_overlay_param.nOverlaySaturation);
					m_Edit_Saturation.SetWindowText(szText);
				}

				GetDlgItem(IDC_STATIC_OVERLAY)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_NONE)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_BOB)->EnableWindow(FALSE);
				GetDlgItem(IDC_RADIO_FLIPPING)->EnableWindow(FALSE);

				return TRUE;
			}
		}

		DECPARAM_OVERLAY_RANGE Range;
		DWORD dwVal;
	// Brightness
		if ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_BRIGHTNESS, &Range) == DEC_FAIL ) 
		{
			Range.fEnable = FALSE;
		}

		if ( Range.fEnable == FALSE ) 
		{
			SetDlgItemInt( IDC_EDIT_BRIGHT, -1, FALSE);
			GetDlgItem(IDC_EDIT_BRIGHT)->EnableWindow(FALSE);
		}
		else {
			if ( DEC_Get_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_BRIGHTNESS, &dwVal) != DEC_FAIL ) 
			{
				if ( ((DWORD)dwVal < Range.dwMin) || ((DWORD)dwVal > Range.dwMax) ) 
				{
					dwVal = 0;
				}
				SetDlgItemInt( IDC_EDIT_BRIGHT, dwVal, FALSE);
			}
			else
			{
				SetDlgItemInt( IDC_EDIT_BRIGHT, -1, FALSE);
				GetDlgItem(IDC_EDIT_BRIGHT)->EnableWindow(FALSE);
			}
		}

	// Contrast
		if ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_CONTRAST, &Range) == DEC_FAIL ) 
		{
			Range.fEnable = FALSE;
		}
		if ( Range.fEnable == FALSE ) 
		{
			SetDlgItemInt( IDC_EDIT_CONTRAST, -1, FALSE);
			GetDlgItem(IDC_EDIT_CONTRAST)->EnableWindow(FALSE);
		}
		else 
		{
			if ( DEC_Get_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_CONTRAST, &dwVal) != DEC_FAIL ) 
			{
				if ( ((DWORD)dwVal < Range.dwMin) || ((DWORD)dwVal > Range.dwMax) ) 
				{
					dwVal = 0;
				}
				SetDlgItemInt( IDC_EDIT_CONTRAST, dwVal, FALSE);
			}
			else
			{
				SetDlgItemInt( IDC_EDIT_CONTRAST, -1, FALSE);
				GetDlgItem(IDC_EDIT_CONTRAST)->EnableWindow(FALSE);
			}
		}

	// Saturation
		if ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_SATURATION, &Range) == DEC_FAIL ) 
		{
			Range.fEnable = FALSE;
		}
		if ( Range.fEnable == FALSE ) 
		{
			SetDlgItemInt( IDC_EDIT_SATURATION, -1, FALSE);
			GetDlgItem(IDC_EDIT_SATURATION)->EnableWindow(FALSE);
		}
		else 
		{
			if ( DEC_Get_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_SATURATION, &dwVal) != DEC_FAIL ) 
			{
				if ( ((DWORD)dwVal < Range.dwMin) || ((DWORD)dwVal > Range.dwMax) ) 
				{
					dwVal = 0;
				}
				SetDlgItemInt( IDC_EDIT_SATURATION, dwVal, FALSE);
			}
			else 
			{
				SetDlgItemInt( IDC_EDIT_SATURATION, -1, FALSE);
				GetDlgItem(IDC_EDIT_SATURATION)->EnableWindow(FALSE);
			}
		}

		DEC_Get_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_BOB, &dwVal);
		if ( dwVal == 1 ) 
		{
			CheckRadioButton(IDC_RADIO_NONE, IDC_RADIO_BOB, IDC_RADIO_BOB);
		}
		else 
		{
			DEC_Get_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_FLIP, &dwVal);
		
			if ( dwVal == 1 ) 
			{
				CheckRadioButton(IDC_RADIO_NONE, IDC_RADIO_BOB, IDC_RADIO_FLIPPING);
			}
			else 
			{
				CheckRadioButton(IDC_RADIO_NONE, IDC_RADIO_BOB, IDC_RADIO_NONE);
			}
		}

		if ( ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_BOB, &Range) == DEC_FAIL ) || ( Range.fEnable == FALSE ) )
		{
			GetDlgItem(IDC_RADIO_BOB)->EnableWindow(FALSE);
		}

		if ( ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_FLIP, &Range) == DEC_FAIL ) || ( Range.fEnable == FALSE ) )
		{
			GetDlgItem(IDC_RADIO_FLIPPING)->EnableWindow(FALSE);
		}
	}
	else {
		DEC_OVERLAY_PARAMETER   dec_overlay_param;
		DEC_RETURN      dec_return;
		char    szText[16];

		dec_return = DEC_Get_Overlay_Parameter(DEC_ID, &dec_overlay_param);

		if(dec_return == DEC_SUCCESS)
		{
			wsprintf(szText, "%ld", dec_overlay_param.nOverlayBrightness);
			m_Edit_Bright.SetWindowText(szText);
			wsprintf(szText, "%ld", dec_overlay_param.nOverlayContrast);
			m_Edit_Contrast.SetWindowText(szText);
			wsprintf(szText, "%ld", dec_overlay_param.nOverlaySaturation);
			m_Edit_Saturation.SetWindowText(szText);
		}

		GetDlgItem(IDC_STATIC_OVERLAY)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_NONE)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_BOB)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_FLIPPING)->EnableWindow(FALSE);
	}

	return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ CAdjust::OnOK ]                                                   
//                                                                      
// @\     掿̐ݒLɂ                                  
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CAdjust::OnOK ]                                                   
//                                                                      
//  Function:   Set adjust parameters                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CAdjust::OnOK() 
{

	if ( m_nBoardConf == DECCAP_D2200V ) 
	{
		DWORD dwValue;
		if ( DEC_Get_Overlay_Parameter_Ex( DEC_ID, (DECPARAM_OVERLAY)DECPARAM_OUTPUT_DEVICE, &dwValue) != DEC_FAIL ) {
			if ( dwValue == DEC_OUTPUT_DEVICE_MVR_HARDWARE ) {
				DEC_OVERLAY_PARAMETER   dec_overlay_param;
				DEC_RETURN      dec_return;     
				char    szText[16];

				dec_return = DEC_Get_Overlay_Parameter(DEC_ID, &dec_overlay_param);

				if(dec_return == DEC_SUCCESS)
				{
					m_Edit_Bright.GetWindowText(szText, sizeof(szText));
					dec_overlay_param.nOverlayBrightness = atol(szText);
					m_Edit_Contrast.GetWindowText(szText, sizeof(szText));
					dec_overlay_param.nOverlayContrast = atol(szText);
					m_Edit_Saturation.GetWindowText(szText, sizeof(szText));
					dec_overlay_param.nOverlaySaturation = atol(szText);

					dec_return = DEC_Set_Overlay_Parameter(DEC_ID, &dec_overlay_param);
				}
			}
		   CDialog::OnOK();
		}
		

		DWORD dwVal;
		DECPARAM_OVERLAY_RANGE Range;

	// Brightness
		if ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_BRIGHTNESS, &Range) != DEC_FAIL ) 
		{
			if ( Range.fEnable != FALSE ) 
			{
				dwVal = GetDlgItemInt(IDC_EDIT_BRIGHT);
				if ( ((DWORD)dwVal >= Range.dwMin) && ((DWORD)dwVal <= Range.dwMax) ) 
				{
					DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_BRIGHTNESS, dwVal);
				}
			}
		}

	// Contrast
		if ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_CONTRAST, &Range) != DEC_FAIL ) 
		{
			if ( Range.fEnable != FALSE ) 
			{
				dwVal = GetDlgItemInt(IDC_EDIT_CONTRAST);
				if ( ((DWORD)dwVal >= Range.dwMin) && ((DWORD)dwVal <= Range.dwMax) ) 
				{
					DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_CONTRAST, dwVal);
				}
			}
		}

	// Saturation
		if ( DEC_Get_Overlay_Parameter_Range_Ex( DEC_ID, DECPARAM_OVERLAY_SATURATION, &Range) != DEC_FAIL ) 
		{
			if ( Range.fEnable != FALSE ) 
			{
				dwVal = GetDlgItemInt(IDC_EDIT_SATURATION);
				if ( ((DWORD)dwVal >= Range.dwMin) && ((DWORD)dwVal <= Range.dwMax) ) 
				{
					DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_SATURATION, dwVal);
				}
			}
		}

		switch ( GetCheckedRadioButton(IDC_RADIO_NONE, IDC_RADIO_BOB) ) {
		case IDC_RADIO_FLIPPING:
			DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_BOB, 0);
			DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_FLIP, 1);
			break;
		case IDC_RADIO_BOB:
			DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_FLIP, 1);
			DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_BOB, 1);
			break;
		case IDC_RADIO_NONE:
		default:
			DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_BOB, 0);
			DEC_Set_Overlay_Parameter_Ex( DEC_ID, DECPARAM_OVERLAY_FLIP, 0);
		}
	}
	else 
	{
		DEC_OVERLAY_PARAMETER   dec_overlay_param;
		DEC_RETURN      dec_return;     
		char    szText[16];

		dec_return = DEC_Get_Overlay_Parameter(DEC_ID, &dec_overlay_param);

		if(dec_return == DEC_SUCCESS)
		{
			m_Edit_Bright.GetWindowText(szText, sizeof(szText));
			dec_overlay_param.nOverlayBrightness = atol(szText);
			m_Edit_Contrast.GetWindowText(szText, sizeof(szText));
			dec_overlay_param.nOverlayContrast = atol(szText);
			m_Edit_Saturation.GetWindowText(szText, sizeof(szText));
			dec_overlay_param.nOverlaySaturation = atol(szText);

			DEC_Set_Overlay_Parameter(DEC_ID, &dec_overlay_param);
		}
    }

    CDialog::OnOK();
}

