//======================================================================
// -- DecodeParam.cpp --                                                
//                                                                      
//  MVR-D2000                                                           
//                                  fR[h    TvvO      
//                                  Decode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// DecodeParam.cpp : Cve[V t@C
// DecodeParam.cpp : implementation file
//

#include "stdafx.h"
#include "Decode.h"
#include "DecodeParam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int	DEC_ID;

/////////////////////////////////////////////////////////////////////////////
// CDecodeParam _CAO
// CDecodeParam Dialog

CDecodeParam::CDecodeParam(CWnd* pParent /*=NULL*/)
    : CDialog(CDecodeParam::IDD, pParent)
{
	m_nBoardConf = 0;
    //{{AFX_DATA_INIT(CDecodeParam)
    //}}AFX_DATA_INIT
}


void CDecodeParam::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CDecodeParam)
    DDX_Control(pDX, IDC_CHECK_FRAME_CLIP, m_Check_Frame_Clip);
    DDX_Control(pDX, IDC_CHECK_PAN_SCAN, m_Check_Pan_and_Scan);
    DDX_Control(pDX, IDC_RADIO_FRAME, m_Radio_Fild);
    DDX_Control(pDX, IDC_RADIO_FILD, m_Radio_Frame);
    DDX_Control(pDX, IDC_CHECK_STOP, m_Check_Stop);
    DDX_Control(pDX, IDC_CHECK_TIMESTAMP, m_Check_Timestamp);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDecodeParam, CDialog)
    //{{AFX_MSG_MAP(CDecodeParam)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDecodeParam bZ[W nh
// CDecodeParam message handler

//----------------------------------------------------------------------
// #[ CDecodeParam::OnInitDialog ]                                      
//                                                                      
// @\     fR[hp[^̐ݒ                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CDecodeParam::OnInitDialog ]                                      
//                                                                      
//  Function:   Initialize decode parameter dialog                      
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CDecodeParam::OnInitDialog() 
{
    CDialog::OnInitDialog();

    DEC_RETURN  dec_return;
    DEC_DECODE_PARAMETER    dec_decode_param;

    dec_return = DEC_Get_Decode_Parameter(DEC_ID, &dec_decode_param);

    if(dec_return != DEC_SUCCESS)
        return FALSE;

    // ^CX^ṽ`FbN
    // Check timestamp
    m_Check_Timestamp.SetCheck(dec_decode_param.fTimestampUsage ? 1: 0);

    // ŏIt[\E\̃`FbN
    // Check preview last frame
    m_Check_Stop.SetCheck(dec_decode_param.fRepeatOnStop ? 1: 0);

    // ŏIt[̕\@Iit[\/tB[h\j
    // Select the last frame view (frame or fild)
    if(dec_decode_param.fFrameRepeat == TRUE)
        CheckRadioButton(IDC_RADIO_FRAME, IDC_RADIO_FILD, IDC_RADIO_FRAME);
    else
        CheckRadioButton(IDC_RADIO_FRAME, IDC_RADIO_FILD, IDC_RADIO_FILD);

    // pXLI
    // Select pan and scan
    m_Check_Pan_and_Scan.SetCheck(dec_decode_param.fPanScan ? 1: 0);

    m_Check_Frame_Clip.SetCheck(dec_decode_param.fFrameClip ? 1: 0);

	if ( m_nBoardConf == DECCAP_D2200V ) 
	{
		CheckRadioButton(IDC_RADIO_FRAME, IDC_RADIO_FILD, IDC_RADIO_FRAME);

		GetDlgItem(IDC_CHECK_TIMESTAMP)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_PAN_SCAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_FRAME_CLIP)->EnableWindow(FALSE);

		GetDlgItem(IDC_CHECK_PAN_SCAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_FRAME_CLIP)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_FILD)->EnableWindow(FALSE);

	}

	INT nIreSetting;

	DEC_Get_IRE_Setting( DEC_ID, &nIreSetting);

	switch ( nIreSetting ) {
	case MVR_IRE_LEVEL_75_NTSC:
		CheckRadioButton(IDC_RADIO_0IRE, IDC_RADIO_75IRE, IDC_RADIO_75IRE);
		break;
	case MVR_IRE_LEVEL_0_NTSC:
	default:
		CheckRadioButton(IDC_RADIO_0IRE, IDC_RADIO_75IRE, IDC_RADIO_0IRE);
		break;
	}


    return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
                  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//----------------------------------------------------------------------
// #[ CDecodeParam::OnOK ]                                              
//                                                                      
// @\     fR[hp[^̐ݒLɂ                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CDecodeParam::OnOK ]                                              
//                                                                      
//  Function:   Set decode parameters                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CDecodeParam::OnOK() 
{
    DEC_RETURN  dec_return;
    DEC_DECODE_PARAMETER    dec_decode_param;
    CString     strMessage;
    int         nID;

    dec_return = DEC_Get_Decode_Parameter(DEC_ID, &dec_decode_param);
    if(dec_return == DEC_SUCCESS)
    {
        dec_decode_param.fTimestampUsage = (m_Check_Timestamp.GetCheck() ? TRUE : FALSE);
        dec_decode_param.fRepeatOnStop = (m_Check_Stop.GetCheck() ? TRUE : FALSE);
        dec_decode_param.fPanScan = (m_Check_Pan_and_Scan.GetCheck() ? TRUE : FALSE);
        dec_decode_param.fFrameClip = (m_Check_Frame_Clip.GetCheck() ? TRUE : FALSE);

        nID = GetCheckedRadioButton(IDC_RADIO_FRAME, IDC_RADIO_FILD);
        if(nID == IDC_RADIO_FRAME)
            dec_decode_param.fFrameRepeat = TRUE;
        else
            dec_decode_param.fFrameRepeat = FALSE;

        dec_return = DEC_Set_Decode_Parameter(DEC_ID, &dec_decode_param);
        if(dec_return != DEC_SUCCESS)
        {
            strMessage.LoadString(IDS_ERROR_SET_DECODE_PARAM);
            MessageBox(strMessage);
        }
    }

	INT nIreSetting;

	DEC_Get_IRE_Setting( DEC_ID, &nIreSetting);

	nID = GetCheckedRadioButton(IDC_RADIO_0IRE, IDC_RADIO_75IRE);

	switch ( nID ) {
	case IDC_RADIO_75IRE:
		nIreSetting = MVR_IRE_LEVEL_75_NTSC;
		break;
	case IDC_RADIO_0IRE:
	default:
		nIreSetting = MVR_IRE_LEVEL_0_NTSC;
		break;
	}

	DEC_Set_IRE_Setting( DEC_ID, nIreSetting);

    CDialog::OnOK();
}
