//======================================================================
// -- MainFrm.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//                                  fR[h    TvvO      
//                                  Decode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// MainFrm.cpp : CMainFrame NX̓̒`s܂B
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Decode_m.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	DEC_ID;
CMainFrame* pMain = NULL;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
    ON_WM_CREATE()
    ON_WM_CLOSE()
    ON_WM_MOVE()
    ON_WM_SIZE()
    ON_COMMAND(IDM_DECODE_PLAY, OnDecodePlay)
    ON_COMMAND(IDM_DECODE_STOP, OnDecodeStop)
    ON_COMMAND(IDM_DECODE_PAUSE, OnDecodePause)
    ON_COMMAND(IDM_DECODE_RESUME, OnDecodeResume)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
    // TODO: ̈ʒuɃȍR[hǉĂB
 	// TODO: add member initialization code here    hWndOverlay = NULL;
    m_szFile[0] = NULL;
	hWndOverlay = NULL;
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
    //       CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
    return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh
// CMainFrame message handlers

//----------------------------------------------------------------------
// #[ CMainFrame::OnFileOpen ]                                          
//                                                                      
// @\     t@CJ                                              
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnFileOpen ]                                          
//                                                                      
//  Function:   Open a file                                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnFileOpen() 
{
    CFileDialog dlg(TRUE, NULL, NULL,
                    OFN_HIDEREADONLY |
                    OFN_FILEMUSTEXIST |
                    OFN_PATHMUSTEXIST,
                    NULL, this);
    DEC_VIDEO_PARAMETER dec_video_param;
    DEC_RETURN  dec_return;
    DEC_TYPE    dec_type;
    CString     strMessage;
    CString     strFile;
    CString     szType;
    char        szText[MAX_PATH];

    dlg.m_ofn.lpstrFile = m_szFile;

    // t@CJ
    // Open file dialog
    if(dlg.DoModal() == IDOK)
    {
        strFile = dlg.GetFileName();
        lstrcpy(m_szFile, strFile);

        dec_return = DEC_Get_File_Type(DEC_ID, m_szFile, &dec_type);
        if(dec_return == DEC_SUCCESS)
        {
            DEC_BSR_PARAMETER   BsrParam;
            VERIFY(DEC_Get_BSR_Parameter(DEC_ID, &BsrParam) == DEC_SUCCESS);

            switch(dec_type)
            {
            case DEC_TYPE_MPEG1_AUDIO:
                BsrParam.fType = DEC_BSR_TYPE_AUDIO;
                szType         = "MPEG1 Audio";
                break;

            case DEC_TYPE_MPEG1_VIDEO:
                BsrParam.fType = DEC_BSR_TYPE_VIDEO;
                szType         = "MPEG1 Video";
                break;

            case DEC_TYPE_MPEG1_SYSTEM_STREAM:
                BsrParam.fType = DEC_BSR_TYPE_PS;
                szType         = "MPEG1 System stream";
                break;

            case DEC_TYPE_MPEG2_AUDIO:
                BsrParam.fType = DEC_BSR_TYPE_AUDIO;
                szType         = "MPEG2 Audio";
                break;

            case DEC_TYPE_MPEG2_VIDEO:
                BsrParam.fType = DEC_BSR_TYPE_VIDEO;
                szType         = "MPEG2 Video";
                break;

            case DEC_TYPE_MPEG2_PROGRAM_STREAM:
                BsrParam.fType = DEC_BSR_TYPE_PS;
                szType         = "MPEG2 Program Stream";
                break;

            default:
                BsrParam.fType = DEC_BSR_TYPE_UNKOWN;
                szType         = "unknown";
                break;
            }

	        VERIFY(DEC_Set_BSR_Parameter(DEC_ID, &BsrParam) == DEC_SUCCESS);

            wsprintf(szText, "[%s] : %s", szType, m_szFile);
        }
        else
        {
            wsprintf(szText, "%s", m_szFile);
        }

        SetWindowText(szText);
    }

    // K擾Eݒ肷
	// Get standard and set up.
    dec_return = DEC_Get_Video_Parameter(DEC_ID, &dec_video_param);
    if(dec_return == DEC_SUCCESS)
    {
        if(dec_video_param.TV_System == DEC_VIDEO_TV_SYSTEM_NTSC)
            OnSetNtsc();
        else
            OnSetPal();
    }
}

//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
// @\     R[obN֐                                            
//                                                                      
//  F      UINT                dec_id                              
//              DEC_STATUS_NOTIFY   dec_state                           
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ StatusProc ]                                                      
//                                                                      
//  Function:   Callback function                                       
//                                                                      
//      Parameters:     UINT                dec_id                      
//                      DEC_STATUS_NOTIFY   dec_state                   
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK StatusProc(UINT dec_id, DEC_STATUS_NOTIFY dec_state)
{
    DEC_TYPE    dec_type;
    DEC_BSR_PARAMETER   BsrParam;
    CString     szType;

    if(dec_state == DEC_NOTIFY_STOP)
    {
        DEC_Get_Type(dec_id, &dec_type);

        switch(dec_type)
        {
        case DEC_TYPE_MPEG1_AUDIO:
            szType = "MPEG1 Audio";
            break;
        case DEC_TYPE_MPEG1_VIDEO:
            szType = "MPEG1 Video";
            break;
        case DEC_TYPE_MPEG1_SYSTEM_STREAM:
            szType = "MPEG1 System Stream";
            break;
        case DEC_TYPE_MPEG2_AUDIO:
            szType = "MPEG2 Audio";
            break;
        case DEC_TYPE_MPEG2_VIDEO:
            szType = "MPEG2 Video";
            break;
        case DEC_TYPE_MPEG2_PROGRAM_STREAM:
            szType = "MPEG2 Program Stream";
            break;
        default:
            szType = "unknown";
            break;
        }

        CloseHandle(pMain->m_hFile);                // File Close
        pMain->m_hFile = NULL;

        VERIFY(DEC_Get_BSR_Parameter(DEC_ID, &BsrParam) == DEC_SUCCESS);
        BsrParam.dwData = (DWORD)INVALID_HANDLE_VALUE;
        VERIFY(DEC_Set_BSR_Parameter(DEC_ID, &BsrParam) == DEC_SUCCESS);

        TRACE0("File Close\n");
        ::MessageBox(AfxGetMainWnd()->GetSafeHwnd(), "Decode finish", szType, MB_OK);
    }
}

//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
// @\     R[obN֐iG[j                                  
//                                                                      
//  F      UINT        dec_id                                      
//              ULONG       error                                       
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ ErrorProc ]                                                       
//                                                                      
//  Function:   Callback function(error)                                
//                                                                      
//      Parameters:     UINT        dec_id                              
//                      ULONG       error                               
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CALLBACK ErrorProc(UINT dec_id, ULONG error)
{
    CString strText;
    switch (error)
    {
    case MVR_ERROR_SUCCESS:
        strText = "MVR_ERROR_SUCCESS";
        break;
    case MVR_ERROR_PENDING:
        strText = "MVR_ERROR_PENDING";
        break;
    case MVR_ERROR_SYSTEM_ERROR:
        strText = "MVR_ERROR_SYSTEM_ERROR";
        break;
    case MVR_ERROR_NOT_PENDING:
        strText = "MVR_ERROR_NOT_PENDING";
        break;
    case MVR_ERROR_INVALID_ASYNCOP:
        strText = "MVR_ERROR_INVALID_ASYNCOP";
        break;
    case MVR_ERROR_UNSUPPORTED:
        strText = "MVR_ERROR_UNSUPPORTED";
        break;
    case MVR_ERROR_INVALID_TYPE:
        strText = "MVR_ERROR_INVALID_TYPE";
        break;
    case MVR_ERROR_INVALID_OPTION:
        strText = "MVR_ERROR_INVALID_OPTION";
        break;
    case MVR_ERROR_INVALID_ADDRESS:
        strText = "MVR_ERROR_INVALID_ADDRESS";
        break;
    case MVR_ERROR_LIMIT_EXCEEDED:
        strText = "MVR_ERROR_LIMIT_EXCEEDED";
        break;
    case MVR_ERROR_INVALID_HANDLE:
        strText = "MVR_ERROR_INVALID_HANDLE";
        break;
    case MVR_ERROR_INVALID_STREAM:
        strText = "MVR_ERROR_INVALID_STREAM";
        break;
    case MVR_ERROR_INVALID_BUFFER:
        strText = "MVR_ERROR_INVALID_BUFFER";
        break;
    case MVR_ERROR_INVALID_MESSAGE:
        strText = "MVR_ERROR_INVALID_MESSAGE";
        break;
    case MVR_ERROR_CANCELED:
        strText = "MVR_ERROR_CANCELED";
        break;
    case MVR_ERROR_BUSY:
        strText = "MVR_ERROR_BUSY";
        break;
    case MVR_ERROR_BUFFER_ERROR:
        strText = "MVR_ERROR_BUFFER_ERROR";
        break;
    case MVR_ERROR_MESSAGE_ERROR:
        strText = "MVR_ERROR_MESSAGE_ERROR";
        break;
    case MVR_ERROR_BAD_PARAM:
        strText = "MVR_ERROR_BAD_PARAM";
        break;
    case MVR_ERROR_HARDWARE_ERROR:
        strText = "MVR_ERROR_HARDWARE_ERROR";
        break;
    case MVR_ERROR_ALLOC_FAILURE:
        strText = "MVR_ERROR_ALLOC_FAILURE";
        break;
    case MVR_ERROR_INVALID_EVENT:
        strText = "MVR_ERROR_INVALID_EVENT";
        break;
    case MVR_ERROR_INVALID_STATE:
        strText = "MVR_ERROR_INVALID_STATE";
        break;
    case MVR_ERROR_CURRENT_STATE:
        strText = "MVR_ERROR_CURRENT_STATE";
        break;
    case MVR_ERROR_INVALID_FRAME_TYPE:
        strText = "MVR_ERROR_INVALID_FRAME_TYPE";
        break;
    case MVR_ERROR_INSUFFICIENT_BUFFERS:
        strText = "MVR_ERROR_INSUFFICIENT_BUFFERS";
        break;
    case MVR_ERROR_TIMEOUT:
        strText = "MVR_ERROR_TIMEOUT";
        break;
    case MVR_ERROR_INVALID_CODEC_STATE:
        strText = "MVR_ERROR_INVALID_CODEC_STATE";
        break;
    case MVR_ERROR_INVALID_FORMAT:
        strText = "MVR_ERROR_INVALID_FORMAT";
        break;
    case MVR_ERROR_INVALID_OPERATION:
        strText = "MVR_ERROR_INVALID_OPERATION";
        break;
    case MVR_ERROR_OVERFLOW:
        strText = "MVR_ERROR_OVERFLOW";
        break;
    case MVR_ERROR_UNDERFLOW:
        strText = "MVR_ERROR_UNDERFLOW";
        break;
    case MVR_ERROR_SESSION_CANCELED:
        strText = "MVR_ERROR_SESSION_CANCELED";
        break;
    case MVR_ERROR_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_AUDIO_UCODE_NOT_FOUND:
        strText = "MVR_ERROR_AUDIO_UCODE_NOT_FOUND";
        break;
    case MVR_ERROR_PARSE_ERROR:
        strText = "MVR_ERROR_PARSE_ERROR";
        break;
    case MVR_ERROR_END_OF_STREAM:
        strText = "MVR_ERROR_END_OF_STREAM";
        break;
    case MVR_ERROR_DISK_FULL:
        strText = "MVR_ERROR_DISK_FULL";
        break;
    case MVR_ERROR_STREAMS_CLOSED:
        strText = "MVR_ERROR_STREAMS_CLOSED";
        break;
    case MVR_ERROR_INTERNAL_ERROR:
        strText = "MVR_ERROR_INTERNAL_ERROR";
        break;
    case MVR_ERROR_INVALID_SHORT_BUFFER:
        strText = "MVR_ERROR_INVALID_SHORT_BUFFER";
        break;
    case MVR_ERROR_EVENT_DATA_OVERRUN:
        strText = "MVR_ERROR_EVENT_DATA_OVERRUN";
        break;
    case MVR_ERROR_EVENT_DATA_UNDERRUN:
        strText = "MVR_ERROR_EVENT_DATA_UNDERRUN";
        break;
    case MVR_ERROR_EVENT_DEVICE_ERROR:
        strText = "MVR_ERROR_EVENT_DEVICE_ERROR";
        break;
    case MVR_ERROR_EVENT_LOSS_OF_VIDEO:
        strText = "MVR_ERROR_EVENT_LOSS_OF_VIDEO";
        break;
    case MVR_ERROR_EVENT_EVENT_LOSS:
        strText = "MVR_ERROR_EVENT_EVENT_LOSS";
        break;
    case MVR_ERROR_EVENT_UNRECOVERABLE_ERROR:
        strText = "MVR_ERROR_EVENT_UNRECOVERABLE_ERROR";
        break;
    default:
        strText = "????";
        break;
    }
    AfxMessageBox(strText);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
// @\                                                       
//                                                                      
//  F      LPCREATESTRUCT lpCreateStruct;                          
//                                                                      
//  ߂lF    int     0;                                          
//                      -1;     s                                    
//----------------------------------------------------------------------
// #[ CMainFrame::OnCreate ]                                            
//                                                                      
//  Function:   Initialize                                              
//                                                                      
//      Parameters: LPCREATESTRUCT lpCreateStruct;                      
//                                                                      
//      Return value:   int     0;  success                             
//                              -1; fail                                
//----------------------------------------------------------------------
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    DEC_RETURN  dec_return;
    DEC_BSR_PARAMETER   bsr_param;
    CString     strMessage;
	UINT		nNumber=0;
	DEC_CONFIG	config;
	UINT		ui;


    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

	// R[fbNio[̐ݒ
    // Set codec number
	for (int i = 1; i < __argc; i++) {
		LPCTSTR pszParam = __targv[i];
		if ((pszParam[0] == _T('-') || pszParam[0] == _T('/')) && !_tcsnicmp(pszParam + 1, _T("id:"), _tcslen(_T("id:"))))
			// id number is specified by /id:n
			nNumber = atoi(pszParam + 4);
	}

	if (nNumber == 0)
	{
		memset(&config, 0, sizeof(DEC_CONFIG));
		DEC_Get_Codec_Config(DEC_ID, &config);

		for (ui = 0; ui <= config.NumberCodecs; ui++)
		{
			config.CodecNumber = ui;
			DEC_Get_Codec_Config(DEC_ID, &config);
			if (config.CurrentUtilization == FALSE)
			{
				if (config.CodecCaps & DECCAP_DECODE)
				{
					nNumber = ui;
					break;
				}
			}
		}
	}
	
	DEC_ID = nNumber;	
	DEC_Set_Codec_Number(DEC_ID, nNumber);

    pMain = this;

    // Cȕ
    // Initialize library
    bsr_param.fType         = DEC_BSR_TYPE_PS;
    bsr_param.pfnCallback   = BsrProc;
    bsr_param.cbBuff        = 0x8000;
    bsr_param.cBuff         = 32;
    bsr_param.dwData        = (DWORD)INVALID_HANDLE_VALUE;

    dec_return = DEC_Initialize_Ex(DEC_ID, DEC_MEDIA_MEMORY, &bsr_param);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot initialize library");
        return -1;
    }

	// R[obN̐ݒ
    // Set CallbackProc
    dec_return = DEC_Set_Callback(DEC_ID, StatusProc, ErrorProc);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot set callback");
        return -1;
    }

    // I[o[CEBhE̍쐬
    // Create overlay window
    if(hWndOverlay == NULL)
        CreateOverlayWindow();

    return 0;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
// @\     AvP[VI܂                                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnClose ]                                             
//                                                                      
//  Function:   End application                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnClose() 
{
    DEC_RETURN  dec_return;
    CString     strMessage;
    
    if(hWndOverlay != NULL)
    {
        DEC_Stop(DEC_ID);
        dec_return = DEC_Destroy_Overlay_Window(DEC_ID);
        if(dec_return != DEC_SUCCESS)
        {
            MessageBox("Cannot destroy overlay window");
        }
    }

    dec_return = DEC_Terminate(DEC_ID);
    if(dec_return != DEC_SUCCESS)
        MessageBox("Cannot terminate decode");

    CFrameWnd::OnClose();
}

//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
// @\     I[o[CEBhE쐬                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE    EBhE쐬ɐ                    
//                      FALSE   EBhE쐬Ɏs                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::CreateOverlayWindow ]                                 
//                                                                      
//  Function:   Create overlay window                                   
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE;   success                         
//                              FALSE;  fail                            
//                                                                      
//----------------------------------------------------------------------
BOOL CMainFrame::CreateOverlayWindow()
{
    DEC_RETURN  dec_return;
    RECT        rc;
    CString     strMessage;

    GetClientRect(&rc);

    dec_return = DEC_Can_Overlay_Window(DEC_ID, NULL, rc.right, rc.bottom);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot create overlay window");
        return FALSE;
    }

    dec_return = DEC_Create_Overlay_Window( DEC_ID, m_hWnd, &hWndOverlay, 0, 0, rc.right, rc.bottom);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot create overlay window");
        return FALSE;
    }

    return TRUE;
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetNtsc ]                                           
//                                                                      
// @\     KiNTSCɐݒ肷                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetNtsc ]                                           
//                                                                      
//  Function:   Set NTSC                                                
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetNtsc() 
{
    DEC_RETURN  dec_return;
    DEC_VIDEO_PARAMETER dec_video_param;
    RECT        rc;
    UINT        nMonitor;
    CString     strMessage;

    // j^̏Ԃ擾
    // Get monitor status
    dec_return = DEC_Get_Monitor_Status(DEC_ID, &nMonitor);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot get monitor status");
        return;
    }

    // j^Ȃ烂j^~
    // Make to stop monitor
    if(nMonitor)
        DEC_Stop_Monitor(DEC_ID);

    // Set NTSC
    dec_video_param.TV_System = DEC_VIDEO_TV_SYSTEM_NTSC;
    dec_return = DEC_Set_Video_Parameter(DEC_ID, &dec_video_param);

    if(dec_return != DEC_SUCCESS)
        MessageBox("Cannot set video parameters");

    // j^̍ĊJ
    // Restart monitor
    if(nMonitor)
    {
        DEC_Start_Monitor(DEC_ID);
        GetClientRect(&rc);
        DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSetPal ]                                            
//                                                                      
// @\     KiPALɐݒ肷                                     
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSetPal ]                                            
//                                                                      
//  Function:   Set PAL                                                 
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSetPal() 
{
    DEC_RETURN  dec_return;
    DEC_VIDEO_PARAMETER dec_video_param;
    RECT        rc;
    UINT        nMonitor;
    CString     strMessage;

    // j^̏Ԃ擾
    // Get monitorstatus
    dec_return = DEC_Get_Monitor_Status(DEC_ID, &nMonitor);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot get monitor status");
        return;
    }

    // j^Ȃ烂j^~
    // Make to stop monitor
    if(nMonitor)
        DEC_Stop_Monitor(DEC_ID);

    // Set NTSC
    dec_video_param.TV_System = DEC_VIDEO_TV_SYSTEM_PAL;
    dec_return = DEC_Set_Video_Parameter(DEC_ID, &dec_video_param);

    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot set video parameters");
    }

    // j^̍ĊJ
    // Restart monitor
    if(nMonitor)
    {
        DEC_Start_Monitor(DEC_ID);
        GetClientRect(&rc);
        DEC_Resize_Overlay_Window(DEC_ID, rc.right, rc.bottom);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
// @\     I[o[CEBhËʒüړ                          
//                                                                      
//  F      int     x                                               
//              int     y                                               
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnMove ]                                              
//                                                                      
//  Function:   Move the overlay window.                                
//                                                                      
//      Parameters:     int     x                                       
//                      int     y                                       
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnMove(int x, int y) 
{
    CFrameWnd::OnMove(x, y);

    if(hWndOverlay)
        DEC_Move_Overlay_Window(DEC_ID, x, y);
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
// @\     I[o[CEBhẼTCYύX                          
//                                                                      
//  F      UINT    nType                                           
//              int     cx                                              
//              int     cy                                              
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnSize ]                                              
//                                                                      
//  Function:   Resize the overlay window.                              
//                                                                      
//      Parameters:     UINT    nType                                   
//                      int     cx                                      
//                      int     cy                                      
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);

    if(hWndOverlay)
        DEC_Resize_Overlay_Window(DEC_ID, cx, cy);
}

void CALLBACK BsrProc(LPBYTE pBuff, DWORD cbWrite, LPDWORD pcbWritten, DWORD dwData)
{
    HANDLE hFile = (HANDLE)dwData;
    if (hFile != INVALID_HANDLE_VALUE)
    {
        VERIFY(ReadFile(hFile, pBuff, cbWrite, pcbWritten, NULL));
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePlay ]                                        
//                                                                      
// @\     fR[hJn܂                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePlay ]                                        
//                                                                      
//  Function:   Decode starts                                           
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodePlay() 
{
    DEC_STATUS  dec_status;
    DEC_BSR_PARAMETER   BsrParam;

    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_STOP && m_szFile[0] != NULL)
    {
        VERIFY((m_hFile = CreateFile(
                            m_szFile, 
                            GENERIC_READ, 
                            FILE_SHARE_READ, 
                            NULL, 
                            OPEN_EXISTING, 
                            FILE_ATTRIBUTE_NORMAL | FILE_FLAG_NO_BUFFERING | 
                            FILE_FLAG_SEQUENTIAL_SCAN, 
                            NULL)) != INVALID_HANDLE_VALUE);

        VERIFY(DEC_Get_BSR_Parameter(DEC_ID, &BsrParam) == DEC_SUCCESS);
        BsrParam.dwData = (DWORD)m_hFile;
        VERIFY(DEC_Set_BSR_Parameter(DEC_ID, &BsrParam) == DEC_SUCCESS);

        VERIFY(DEC_Play(DEC_ID) == DEC_SUCCESS);
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeStop ]                                        
//                                                                      
// @\     fR[h~܂                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeStop ]                                        
//                                                                      
//  Function:   Decode stops                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodeStop() 
{
    DEC_RETURN  dec_return;
    CString     strMessage;

    dec_return = DEC_Stop(DEC_ID);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot stop decode");
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePause ]                                       
//                                                                      
// @\     fR[hꎞ~܂                                    
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodePause ]                                       
//                                                                      
//  Function:   Pause decode                                            
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodePause() 
{
    DEC_RETURN  dec_return;
    CString     strMessage;

    dec_return = DEC_Pause(DEC_ID);
    if(dec_return != DEC_SUCCESS)
    {
        MessageBox("Cannot pause");
    }
}

//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeResume ]                                      
//                                                                      
// @\     fR[hĊJ܂                                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CMainFrame::OnDecodeResume ]                                      
//                                                                      
//  Function:   Decode restarts                                         
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CMainFrame::OnDecodeResume() 
{
    DEC_STATUS  dec_status;

    // fR[hĊJ
    // Restart Decode
    DEC_Get_Status(DEC_ID, &dec_status);
    if(dec_status == DEC_STATUS_PAUSE)
    {
        // ꎞ~
        // Resume
        DEC_Resume(DEC_ID);
    }
}
