//======================================================================
// -- AudioDlg.cpp --                                                   
//                                                                      
//  MVR-D2000                                                           
//                                  GR[h  TvvO      
//                                  Encode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// AudioDlg.cpp : Cve[V t@C
// AudioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Encode.h"
#include "AudioDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	ENC_ID;

/////////////////////////////////////////////////////////////////////////////
// CAudioDlg _CAO
// CAudioDlg Dialog

CAudioDlg::CAudioDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CAudioDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CAudioDlg)
        //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		// NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void CAudioDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAudioDlg)
    DDX_Control(pDX, IDC_EDIT_RIGHT_GAIN, m_Edit_Right_Gain);
    DDX_Control(pDX, IDC_EDIT_LEFT_GAIN, m_Edit_Left_Gain);
    DDX_Control(pDX, IDC_CHECK_MONITOR, m_Check_Monitor);
    DDX_Control(pDX, IDC_CHECK_MUTE, m_Check_Mute);
    DDX_Control(pDX, IDC_EDIT_LEFT, m_Edit_Left);
    DDX_Control(pDX, IDC_EDIT_RIGHT, m_Edit_Right);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAudioDlg, CDialog)
    //{{AFX_MSG_MAP(CAudioDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAudioDlg bZ[W nh
// CAudioDlg message handlers

//----------------------------------------------------------------------
// #[ CAudioDlg::OnInitDialog ]                                         
//                                                                      
// @\     I[fBIp[^̐ݒ                                  
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CAudioDlg::OnInitDialog ]                                         
//                                                                      
//  Function:   Initialize audio dialog                                 
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CAudioDlg::OnInitDialog() 
{
    ENC_RETURN  enc_return;
    ENC_AUDIO_PARAMETER     enc_audio_param;
    CString     strMessage;
    char    szText[32];

    CDialog::OnInitDialog();
    
    // TODO: ̈ʒuɏ̕⑫ǉĂ
	// TODO: Add extra initialization here
     enc_return = ENC_Get_Audio_Parameter(ENC_ID, &enc_audio_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return FALSE;
    }

    // {[̌ݒlݒ
    // Set Volume
    wsprintf(szText, "%ld", enc_audio_param.dwLeftOutputAtt);
    m_Edit_Left.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_audio_param.dwRightOutputAtt);
    m_Edit_Right.SetWindowText(szText);

    // ̓QČݒlݒ
    // Set Gain Level
    wsprintf(szText, "%d", enc_audio_param.nLeftInputGain);
    m_Edit_Left_Gain.SetWindowText(szText);
    wsprintf(szText, "%d", enc_audio_param.nRightInputGain);
    m_Edit_Right_Gain.SetWindowText(szText);

    // ~[gAj^[̏Ԃݒ
    // Check mute, output monitor
    m_Check_Mute.SetCheck(enc_audio_param.fOutputMute ? TRUE : FALSE);
    m_Check_Monitor.SetCheck(enc_audio_param.fOutputMonitor ? TRUE : FALSE);

    return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ CAudioDlg::OnOK ]                                                 
//                                                                      
// @\     I[fBIp[^̐ݒLɂ                      
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CAudioDlg::OnOK ]                                                 
//                                                                      
//  Function:   Set audio parameters                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CAudioDlg::OnOK() 
{
    ENC_AUDIO_PARAMETER     enc_audio_param;
    ENC_RETURN  enc_return;
    CString     strMessage;
    char    szText[32];

    enc_return = ENC_Get_Audio_Parameter(ENC_ID, &enc_audio_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    // ~[gAj^[̐ݒ
    // check mute, output monitor
    enc_audio_param.fOutputMonitor = (m_Check_Monitor.GetCheck() ? TRUE : FALSE);
    enc_audio_param.fOutputMute = (m_Check_Mute.GetCheck() ? TRUE : FALSE);

    // {[̐ݒ
    // set volume
    m_Edit_Right.GetWindowText(szText, sizeof(szText));
    enc_audio_param.dwRightOutputAtt = atol(szText);
    m_Edit_Left.GetWindowText(szText, sizeof(szText));
    enc_audio_param.dwLeftOutputAtt = atol(szText);

    // ̓QC̐ݒ
    // set gain level
    m_Edit_Right_Gain.GetWindowText(szText, sizeof(szText));
    enc_audio_param.nRightInputGain = atoi(szText);
    m_Edit_Left_Gain.GetWindowText(szText, sizeof(szText));
    enc_audio_param.nLeftInputGain = atoi(szText);

    // p[^̐ݒ
    // set audio parameter
    enc_return = ENC_Set_Audio_Parameter(ENC_ID, &enc_audio_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_SET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    CDialog::OnOK();
}
