//======================================================================
// -- VideoEncDlg.cpp --                                                
//                                                                      
//  MVR-D2000                                                           
//                                  GR[h  TvvO      
//                                  Encode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// VideoEncDlg.cpp : Cve[V t@C
// VideoEncDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Encode.h"
#include "VideoEncDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	ENC_ID;

/////////////////////////////////////////////////////////////////////////////
// CVideoEncDlg _CAO
// CVideoEncDlg Dialog

CVideoEncDlg::CVideoEncDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CVideoEncDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CVideoEncDlg)
        //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		// NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void CVideoEncDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CVideoEncDlg)
    DDX_Control(pDX, IDC_EDIT_WIDTH, m_Edit_Width);
    DDX_Control(pDX, IDC_EDIT_TOP, m_Edit_Top);
    DDX_Control(pDX, IDC_EDIT_LEFT, m_Edit_Left);
    DDX_Control(pDX, IDC_EDIT_HEIGHT, m_Edit_Height);
    DDX_Control(pDX, IDC_EDIT_BITRATE, m_Edit_Bitrate);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVideoEncDlg, CDialog)
    //{{AFX_MSG_MAP(CVideoEncDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoEncDlg bZ[W nh
// CVideoEncDlg message handlers

//----------------------------------------------------------------------
// #[ CVideoEncDlg::OnInitDialog ]                                      
//                                                                      
// @\     rfIGR[hp[^̐ݒ                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CVideoEncDlg::OnInitDialog ]                                      
//                                                                      
//  Function:   Initialize video encode dialog                          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CVideoEncDlg::OnInitDialog() 
{
    ENC_VIDEO_ENCODE_PARAMETER  enc_video_param;
    ENC_RETURN  enc_return;
    CString     strMessage;
    char    szText[32];

    CDialog::OnInitDialog();

    // rfIGR[hp[^̎擾
    // Get video encode parameters
    enc_return = ENC_Get_Video_Encode_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return FALSE;
    }

    // MPEG
    switch(enc_video_param.V_CodingMode)
    {
    case ENCVEPARAM_V_CODING_MODE_MPEG1:
        CheckRadioButton(IDC_RADIO_MPEG1, IDC_RADIO_MPEG2, IDC_RADIO_MPEG1);
        break;
    default:
        CheckRadioButton(IDC_RADIO_MPEG1, IDC_RADIO_MPEG2, IDC_RADIO_MPEG2);
        break;
    }

    // vt@Cƃx̐ݒ
    // Set Profile and Level
    switch(enc_video_param.fProfileAndLevel)
    {
    case ENCVEPARAM_PROFILE_AND_LEVEL_MP_ML:
        CheckRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML, IDC_RADIO_MPML);
        break;
    case ENCVEPARAM_PROFILE_AND_LEVEL_MP_LL:
        CheckRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML, IDC_RADIO_MPLL);
        break;
    case ENCVEPARAM_PROFILE_AND_LEVEL_SP_ML:
        CheckRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML, IDC_RADIO_SPML);
        break;
    default:
        break;
    }

    // rfItH[}bg̐ݒ
    // Set video format
    switch(enc_video_param.fConvertType)
    {
    case ENCVEPARAM_CONVERT_TYPE_STANDARD:
        CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_STANDARD);
        break;
    case ENCVEPARAM_CONVERT_TYPE_SIF:
        CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_SIF);
        break;
    case ENCVEPARAM_CONVERT_TYPE_HALF_D1:
        CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_HALFD1);
        break;
    default:
        break;
    }

    // CBR / VBR ̐ݒ
    // CBR or VBR...
    switch(enc_video_param.EncodeType)
    {
    case ENCVEPARAM_ENCODE_TYPE_CBR:
        CheckRadioButton(IDC_RADIO_CBR, IDC_RADIO_VBR, IDC_RADIO_CBR);
        break;
    default:
        CheckRadioButton(IDC_RADIO_CBR, IDC_RADIO_VBR, IDC_RADIO_VBR);
        break;
    }

    // GOP p^[̐ݒ
    // Set GOP Pattern
    switch(enc_video_param.GopPattern)
    {
    case ENCVEPARAM_GOP_PATTERN_IFRAME:
        CheckRadioButton(IDC_RADIO_IFRAME, IDC_RADIO_IBBP, IDC_RADIO_IFRAME);
        break;
    default:
        CheckRadioButton(IDC_RADIO_IFRAME, IDC_RADIO_IBBP, IDC_RADIO_IBBP);
        break;
    }

    // Set Edit box...
    wsprintf(szText, "%ld", enc_video_param.wImageLeft);
    m_Edit_Left.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.wImageTop);
    m_Edit_Top.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.wImageWidth);
    m_Edit_Width.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.wImageHeight);
    m_Edit_Height.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.dwBitrate);
    m_Edit_Bitrate.SetWindowText(szText);

    return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ CVideoEncDlg::OnOK ]                                              
//                                                                      
// @\     rfIGR[hp[^̐ݒLɂ                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CVideoEncDlg::OnOK ]                                              
//                                                                      
//  Function:   Set video encode parameters                             
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CVideoEncDlg::OnOK() 
{
    ENC_VIDEO_ENCODE_PARAMETER  enc_video_param;
    ENC_RETURN  enc_return;
    CString     strMessage;
    char    szText[32];
    int     nID;

    // rfIGR[hp[^̎擾
    // Get video encode parameters
    enc_return = ENC_Get_Video_Encode_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    // MPEG
    nID = GetCheckedRadioButton(IDC_RADIO_MPEG1, IDC_RADIO_MPEG2);
    if(nID == IDC_RADIO_MPEG1)
        enc_video_param.V_CodingMode = ENCVEPARAM_V_CODING_MODE_MPEG1;
    else
        enc_video_param.V_CodingMode = ENCVEPARAM_V_CODING_MODE_MPEG2;

    // vt@Cƃx̐ݒ
    // Set Profile and Level
    nID = GetCheckedRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML);
    switch(nID)
    {
    case IDC_RADIO_MPML:
        enc_video_param.fProfileAndLevel = ENCVEPARAM_PROFILE_AND_LEVEL_MP_ML;
        break;
    case IDC_RADIO_MPLL:
        enc_video_param.fProfileAndLevel = ENCVEPARAM_PROFILE_AND_LEVEL_MP_LL;
        break;
    default:
        enc_video_param.fProfileAndLevel = ENCVEPARAM_PROFILE_AND_LEVEL_SP_ML;
        break;
    }

    // rfItH[}bg̐ݒ
    // Set video format
    nID = GetCheckedRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1);
    switch(nID)
    {
    case IDC_RADIO_STANDARD:
        enc_video_param.fConvertType = ENCVEPARAM_CONVERT_TYPE_STANDARD;
        break;
    case IDC_RADIO_SIF:
        enc_video_param.fConvertType = ENCVEPARAM_CONVERT_TYPE_SIF;
        break;
    default:
        enc_video_param.fConvertType = ENCVEPARAM_CONVERT_TYPE_HALF_D1;
        break;
    }

    // CBR / VBR ̐ݒ
    // CBR or VBR...
    nID = GetCheckedRadioButton(IDC_RADIO_CBR, IDC_RADIO_VBR);
    if(nID == IDC_RADIO_CBR)
        enc_video_param.EncodeType = ENCVEPARAM_ENCODE_TYPE_CBR;
    else
        enc_video_param.EncodeType = ENCVEPARAM_ENCODE_TYPE_VBR;

    // GOP p^[̐ݒ
    // Set GOP pattern
    nID = GetCheckedRadioButton(IDC_RADIO_IFRAME, IDC_RADIO_IBBP);
    if(nID == IDC_RADIO_IFRAME)
        enc_video_param.GopPattern = ENCVEPARAM_GOP_PATTERN_IFRAME;
    else
        enc_video_param.GopPattern = ENCVEPARAM_GOP_PATTERN_IBBP;

    // Set Edit Box...
    m_Edit_Left.GetWindowText(szText,sizeof(szText));
    enc_video_param.wImageLeft = atoi(szText);
    m_Edit_Top.GetWindowText(szText,sizeof(szText));
    enc_video_param.wImageTop = atoi(szText);
    m_Edit_Width.GetWindowText(szText,sizeof(szText));
    enc_video_param.wImageWidth = atoi(szText);
    m_Edit_Height.GetWindowText(szText,sizeof(szText));
    enc_video_param.wImageHeight = atoi(szText);
    m_Edit_Bitrate.GetWindowText(szText,sizeof(szText));
    enc_video_param.dwBitrate = atol(szText);

    //  rfIGR[hp[^̐ݒ
    //  Set video encode parameters
    enc_return = ENC_Set_Video_Encode_Parameter(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_SET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    CDialog::OnOK();
}
