// Multi.cpp : AvP[VpNX̋@\`s܂B
// Multi.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Multi.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MultiDoc.h"
#include "MultiView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMultiApp

BEGIN_MESSAGE_MAP(CMultiApp, CWinApp)
    //{{AFX_MSG_MAP(CMultiApp)
    ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
    //}}AFX_MSG_MAP
    // W̃t@C{hLg R}h
	// Standard file based document commands
    ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
    ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiApp NX̍\z
// CMultiApp construction

CMultiApp::CMultiApp()
{
    for(UINT i=0;i<MULTI_MAXWINDOW;i++)
    {
        m_WindowStatus[i]  = FALSE;
        m_EncDecStatus[i] = FALSE;
    }
}

/////////////////////////////////////////////////////////////////////////////
// B CMultiApp IuWFNg
// The one and only CMultiApp object

CMultiApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMultiApp NX̏
// CMultiApp initialization

BOOL CMultiApp::InitInstance()
{
    AfxEnableControlContainer();

    // WIȏ
    // ̋@\gpAst@C̃TCY
    // Έȉ̓̏[`̒sKvȂ
    // 폜ĂB
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

    // ݒ肪ۑ鉺̃WXg L[ύX܂B
    // TODO: ̕AЖ܂͏ȂǓK؂Ȃ̂
    // ύXĂB
	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
    SetRegistryKey(_T("Local AppWizard-Generated Applications"));

    LoadStdProfileSettings();	// W INI t@C̃IvV[ނ܂ (MRU ܂)
								// Load standard INI file options (including MRU)

    // AvP[Vp̃hLg ev[go^܂BhLg ev[g
    //  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

    CMultiDocTemplate* pDocTemplate;
    pDocTemplate = new CMultiDocTemplate(
        IDR_MULTITYPE,
        RUNTIME_CLASS(CMultiDoc),
        RUNTIME_CLASS(CChildFrame), // JX^ MDI qt[
									// custom MDI child frame
        RUNTIME_CLASS(CMultiView));
    AddDocTemplate(pDocTemplate);

    // C MDI t[ EBhE쐬
	// create main MDI Frame window
    CMainFrame* pMainFrame = new CMainFrame;
    if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
        return FALSE;
    m_pMainWnd = pMainFrame;

    // DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	// Parse command line for standard shell commands, DDE, file open
    CCommandLineInfo cmdInfo;
    ParseCommandLine(cmdInfo);

    // R}hCŃfBXpb` R}hw肵܂B
	// Dispatch commands specified on the command line
    if (!ProcessShellCommand(cmdInfo))
        return FALSE;

    // C EBhEꂽ̂ŁA\ƍXVs܂B
	// The main window has been initialized, so show and update it.
    pMainFrame->ShowWindow(m_nCmdShow);
    pMainFrame->UpdateWindow();


    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// _CAO f[^
// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard z֐̃I[o[Ch𐶐܂B
	// ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
														// DDX/DDV support
    //}}AFX_VIRTUAL

// Cve[V
// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
        // bZ[W nh͂܂B
		// No message handlers
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // bZ[W nh͂܂B
		// No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
// App command to run the dialog
void CMultiApp::OnAppAbout()
{
    CAboutDlg aboutDlg;
    aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMultiApp bZ[W nh
// CMultiApp message handlers

VOID CMultiApp::SetWindowStatus(UINT nID, BOOL status)
{
    m_WindowStatus[nID] = status;

}
//-------------------------------------------------------------------------
// #[ CChildFrame::GetWindowID ]                                           
//                                                                         
// @\    Window ID(Board ID) Ԃ                                      
//                                                                         
//  F      UINT    nID                                                
//                                                                         
//  ߂lF    UINT    0xFFFFFFFF:     s                               
//                      0xFFFFFFFFȊO: Window ID(Borad ID)                
//-------------------------------------------------------------------------
// #[ CChildFrame::GetWindowID ]                                           
//                                                                         
//  Function: Return Window ID(board ID)                                   
//                                                                         
//      Parameters:     UINT    nID                                        
//                                                                         
//      Return value:   UINT    0xFFFFFFFF:         Error;                 
//                              Except 0xFFFFFFFF:  Window ID(Borad ID)    
//-------------------------------------------------------------------------
UINT CMultiApp::GetWindowID()
{
   for(UINT i=0;i<MULTI_MAXWINDOW;i++)
        if(!m_WindowStatus[i])
                return i;
    return 0xFFFFFFFF;

}

//-------------------------------------------------------------------------
// #[ CChildFrame::CheckAllEncDecStatus ]                                  
//                                                                         
// @\     SĂ Board ɑ΂ fR[h̓GR[h ł邩𔻒  
//                                                                         
//  F      Ȃ                                                       
//                                                                         
//  ߂lF    BOOL    TRUE   s                                      
//                      FALSE  ~                                        
//-------------------------------------------------------------------------
// #[ CChildFrame::CheckAllEncDecStatus ]                                  
//                                                                         
//  Function: It judges whether Decode or Encode is working for all boards.
//                                                                         
//      Parameters:     none                                               
//                                                                         
//      Return value:   BOOL    TRUE  Decode or Encode is working          
//                              FALSE Decode and Encode is stoped          
//-------------------------------------------------------------------------
BOOL CMultiApp::CheckAllEncDecStatus()
{
    for(UINT i=0;i<MULTI_MAXWINDOW;i++)
        if(m_EncDecStatus[i])
            return TRUE;
    return FALSE;

}
